/* A Bison parser, made by GNU Bison 3.0.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"
#include "lib/mac.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
  case T_LC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  check_u16(fa);
  check_u16(ta);
  check_u16(fb);
  check_u16(tb);

  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  struct f_tree *lst = NULL;
  int i;

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define CC_ALL 0xFFFF
#define EC_ALL 0xFFFFFFFF
#define LC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if ((kind != EC_GENERIC) && (ipv4_used || (key >= 0x10000))) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static struct f_tree *
f_new_lc_item(u32 f1, u32 t1, u32 f2, u32 t2, u32 f3, u32 t3)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_LC;
  t->from.val.lc = (lcomm) {f1, f2, f3};
  t->to.val.lc = (lcomm) {t1, t2, t3};
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_dynamic_attr dyn)
{
  struct f_inst *e = f_new_inst(FI_EMPTY);

  switch (dyn.type & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    case EAF_TYPE_LC_SET:
      e->aux = T_LCLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  struct f_inst *s = f_new_inst_da(FI_EA_SET, dyn);
  s->a1.p = e;
  return s;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst(FI_CONSTANT);
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst(FI_PAIR_CONSTRUCT);
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->fi_code == FI_CONSTANT) {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->fi_code == FI_CONSTANT_INDIRECT) {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->fi_code == FI_CONSTANT) {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;

    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst(FI_CONSTANT_INDIRECT);
    rv->a1.p = val;
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst(FI_EC_CONSTRUCT);
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}

static inline struct f_inst *
f_generate_lc(struct f_inst *t1, struct f_inst *t2, struct f_inst *t3)
{
  struct f_inst *rv;

  if ((t1->fi_code == FI_CONSTANT) && (t2->fi_code == FI_CONSTANT) && (t3->fi_code == FI_CONSTANT)) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT) || (t3->aux != T_INT))
      cf_error( "LC - Can't operate with value of non-integer type in tuple constructor");

    rv = f_new_inst(FI_CONSTANT_INDIRECT);

    NEW_F_VAL;
    rv->a1.p = val;
    val->type = T_LC;
    val->val.lc = (lcomm) { t1->a2.i, t2->a2.i, t3->a2.i };
  }
  else
  {
    rv = cfg_allocz(sizeof(struct f_inst3));
    rv->lineno = ifs->lino;
    rv->fi_code = FI_LC_CONSTRUCT;
    rv->a1.p = t1;
    rv->a2.p = t2;
    INST3(rv).p = t3;
  }

  return rv;
}

static inline struct f_inst *
f_generate_path_mask(struct f_path_mask *t)
{
  struct f_path_mask *tt;
  for (tt = t; tt; tt = tt->next) {
    if (tt->kind == PM_ASN_EXPR) {
      struct f_inst *mrv = f_new_inst(FI_PATHMASK_CONSTRUCT);
      mrv->a1.p = t;
      return mrv;
    }
  }

  NEW_F_VAL;
  val->type = T_PATH_MASK;
  val->val.path_mask = t;

  struct f_inst *rv = f_new_inst(FI_CONSTANT_INDIRECT);
  rv->a1.p = val;

  return rv;
}


/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/mrt/config.Y */

#include "proto/mrt/mrt.h"

/* Defines from ../../proto/mrt/config.Y */

#define MRT_CFG ((struct mrt_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");

  if (ip->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *ip->passwords)
    {
      if (pass->alg && (ip->autype != OSPF_AUTH_CRYPT))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default OSPF crypto algorithms */
      if (!pass->alg && (ip->autype == OSPF_AUTH_CRYPT))
	pass->alg = ospf_cfg_is_v2() ? ALG_MD5 : ALG_HMAC_SHA256;
    }
  }
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_config *) this_proto)
#define RIP_IFACE ((struct rip_iface_config *) this_ipatt)

static inline int rip_cfg_is_v2(void) { return RIP_CFG->rip2; }
static inline int rip_cfg_is_ng(void) { return ! RIP_CFG->rip2; }

static inline void
rip_check_auth(void)
{
  if (rip_cfg_is_ng())
    cf_error("Authentication not supported in RIPng");
}


/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;
static struct f_inst **this_srt_last_cmd;

static void
static_route_finish(void)
{
  struct static_route *r;

  /* Update undefined use_bfd entries in multipath nexthops */
  if (this_srt->dest == RTD_MULTIPATH)
    for (r = this_srt->mp_next; r; r = r->mp_next)
      if (r->use_bfd < 0)
        r->use_bfd = this_srt->use_bfd;
}

/* Headers from ../../proto/babel/config.Y */

#include "proto/babel/babel.h"
#include "nest/iface.h"

/* Defines from ../../proto/babel/config.Y */

#define BABEL_CFG ((struct babel_config *) this_proto)
#define BABEL_IFACE ((struct babel_iface_config *) this_ipatt)


#line 734 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    NMA = 277,
    DEFINE = 278,
    ON = 279,
    OFF = 280,
    YES = 281,
    NO = 282,
    S = 283,
    MS = 284,
    US = 285,
    PORT = 286,
    LOG = 287,
    SYSLOG = 288,
    ALL = 289,
    DEBUG = 290,
    TRACE = 291,
    INFO = 292,
    REMOTE = 293,
    WARNING = 294,
    ERROR = 295,
    AUTH = 296,
    FATAL = 297,
    BUG = 298,
    STDERR = 299,
    SOFT = 300,
    TIMEFORMAT = 301,
    ISO = 302,
    OLD = 303,
    SHORT = 304,
    LONG = 305,
    BASE = 306,
    NAME = 307,
    CONFIRM = 308,
    UNDO = 309,
    CHECK = 310,
    TIMEOUT = 311,
    LATENCY = 312,
    LIMIT = 313,
    WATCHDOG = 314,
    CONFIGURE = 315,
    DOWN = 316,
    KERNEL = 317,
    PERSIST = 318,
    SCAN = 319,
    TIME = 320,
    LEARN = 321,
    DEVICE = 322,
    ROUTES = 323,
    GRACEFUL = 324,
    RESTART = 325,
    KRT_SOURCE = 326,
    KRT_METRIC = 327,
    MERGE = 328,
    PATHS = 329,
    TABLE = 330,
    METRIC = 331,
    KRT_PREFSRC = 332,
    KRT_REALM = 333,
    KRT_SCOPE = 334,
    KRT_MTU = 335,
    KRT_WINDOW = 336,
    KRT_RTT = 337,
    KRT_RTTVAR = 338,
    KRT_SSTRESH = 339,
    KRT_CWND = 340,
    KRT_ADVMSS = 341,
    KRT_REORDERING = 342,
    KRT_HOPLIMIT = 343,
    KRT_INITCWND = 344,
    KRT_RTO_MIN = 345,
    KRT_INITRWND = 346,
    KRT_QUICKACK = 347,
    KRT_LOCK_MTU = 348,
    KRT_LOCK_WINDOW = 349,
    KRT_LOCK_RTT = 350,
    KRT_LOCK_RTTVAR = 351,
    KRT_LOCK_SSTRESH = 352,
    KRT_LOCK_CWND = 353,
    KRT_LOCK_ADVMSS = 354,
    KRT_LOCK_REORDERING = 355,
    KRT_LOCK_HOPLIMIT = 356,
    KRT_LOCK_RTO_MIN = 357,
    KRT_FEATURE_ECN = 358,
    KRT_FEATURE_ALLFRAG = 359,
    ROUTER = 360,
    ID = 361,
    PROTOCOL = 362,
    TEMPLATE = 363,
    PREFERENCE = 364,
    DISABLED = 365,
    DIRECT = 366,
    INTERFACE = 367,
    IMPORT = 368,
    EXPORT = 369,
    FILTER = 370,
    NONE = 371,
    VRF = 372,
    DEFAULT = 373,
    STATES = 374,
    FILTERS = 375,
    RECEIVE = 376,
    ACTION = 377,
    WARN = 378,
    BLOCK = 379,
    DISABLE = 380,
    KEEP = 381,
    FILTERED = 382,
    PASSWORD = 383,
    FROM = 384,
    PASSIVE = 385,
    TO = 386,
    EVENTS = 387,
    PACKETS = 388,
    PROTOCOLS = 389,
    INTERFACES = 390,
    ALGORITHM = 391,
    KEYED = 392,
    HMAC = 393,
    MD5 = 394,
    SHA1 = 395,
    SHA256 = 396,
    SHA384 = 397,
    SHA512 = 398,
    PRIMARY = 399,
    STATS = 400,
    COUNT = 401,
    FOR = 402,
    COMMANDS = 403,
    PREEXPORT = 404,
    NOEXPORT = 405,
    GENERATE = 406,
    ROA = 407,
    LISTEN = 408,
    BGP = 409,
    V6ONLY = 410,
    DUAL = 411,
    ADDRESS = 412,
    PASSWORDS = 413,
    DESCRIPTION = 414,
    SORTED = 415,
    RELOAD = 416,
    IN = 417,
    OUT = 418,
    MRTDUMP = 419,
    MESSAGES = 420,
    RESTRICT = 421,
    MEMORY = 422,
    IGP_METRIC = 423,
    CLASS = 424,
    DSCP = 425,
    WAIT = 426,
    MAX = 427,
    FLUSH = 428,
    AS = 429,
    SHOW = 430,
    STATUS = 431,
    SUMMARY = 432,
    ROUTE = 433,
    SYMBOLS = 434,
    ADD = 435,
    DELETE = 436,
    DUMP = 437,
    RESOURCES = 438,
    SOCKETS = 439,
    NEIGHBORS = 440,
    ATTRIBUTES = 441,
    EVAL = 442,
    ECHO = 443,
    ENABLE = 444,
    FUNCTION = 445,
    PRINT = 446,
    PRINTN = 447,
    UNSET = 448,
    RETURN = 449,
    ACCEPT = 450,
    REJECT = 451,
    QUITBIRD = 452,
    INT = 453,
    BOOL = 454,
    IP = 455,
    PREFIX = 456,
    PAIR = 457,
    QUAD = 458,
    EC = 459,
    LC = 460,
    SET = 461,
    STRING = 462,
    BGPMASK = 463,
    BGPPATH = 464,
    CLIST = 465,
    ECLIST = 466,
    LCLIST = 467,
    IF = 468,
    THEN = 469,
    ELSE = 470,
    CASE = 471,
    TRUE = 472,
    FALSE = 473,
    RT = 474,
    RO = 475,
    UNKNOWN = 476,
    GENERIC = 477,
    GW = 478,
    NET = 479,
    MASK = 480,
    PROTO = 481,
    SOURCE = 482,
    SCOPE = 483,
    CAST = 484,
    DEST = 485,
    IFNAME = 486,
    IFINDEX = 487,
    LEN = 488,
    DEFINED = 489,
    CONTAINS = 490,
    RESET = 491,
    PREPEND = 492,
    FIRST = 493,
    LAST = 494,
    LAST_NONAGGREGATED = 495,
    MATCH = 496,
    ROA_CHECK = 497,
    EMPTY = 498,
    WHERE = 499,
    BFD = 500,
    MIN = 501,
    IDLE = 502,
    RX = 503,
    TX = 504,
    INTERVAL = 505,
    MULTIPLIER = 506,
    MULTIHOP = 507,
    NEIGHBOR = 508,
    DEV = 509,
    LOCAL = 510,
    AUTHENTICATION = 511,
    SIMPLE = 512,
    METICULOUS = 513,
    SESSIONS = 514,
    HOLD = 515,
    CONNECT = 516,
    RETRY = 517,
    KEEPALIVE = 518,
    STARTUP = 519,
    VIA = 520,
    NEXT = 521,
    HOP = 522,
    SELF = 523,
    PATH = 524,
    START = 525,
    DELAY = 526,
    FORGET = 527,
    AFTER = 528,
    BGP_PATH = 529,
    BGP_LOCAL_PREF = 530,
    BGP_MED = 531,
    BGP_ORIGIN = 532,
    BGP_NEXT_HOP = 533,
    BGP_ATOMIC_AGGR = 534,
    BGP_AGGREGATOR = 535,
    BGP_COMMUNITY = 536,
    BGP_EXT_COMMUNITY = 537,
    RR = 538,
    RS = 539,
    CLIENT = 540,
    CLUSTER = 541,
    AS4 = 542,
    ADVERTISE = 543,
    IPV4 = 544,
    CAPABILITIES = 545,
    PREFER = 546,
    OLDER = 547,
    MISSING = 548,
    LLADDR = 549,
    DROP = 550,
    IGNORE = 551,
    REFRESH = 552,
    INTERPRET = 553,
    COMMUNITIES = 554,
    BGP_ORIGINATOR_ID = 555,
    BGP_CLUSTER_LIST = 556,
    IGP = 557,
    GATEWAY = 558,
    RECURSIVE = 559,
    MED = 560,
    TTL = 561,
    SECURITY = 562,
    DETERMINISTIC = 563,
    SECONDARY = 564,
    ALLOW = 565,
    AWARE = 566,
    LINK = 567,
    EXTENDED = 568,
    SETKEY = 569,
    BGP_LARGE_COMMUNITY = 570,
    LIVED = 571,
    STALE = 572,
    CEASE = 573,
    HIT = 574,
    ADMINISTRATIVE = 575,
    SHUTDOWN = 576,
    PEER = 577,
    CONFIGURATION = 578,
    CHANGE = 579,
    DECONFIGURED = 580,
    CONNECTION = 581,
    REJECTED = 582,
    COLLISION = 583,
    OF = 584,
    MRT = 585,
    FILENAME = 586,
    PERIOD = 587,
    ALWAYS = 588,
    OSPF = 589,
    AREA = 590,
    OSPF_METRIC1 = 591,
    OSPF_METRIC2 = 592,
    OSPF_TAG = 593,
    OSPF_ROUTER_ID = 594,
    RFC1583COMPAT = 595,
    STUB = 596,
    TICK = 597,
    COST = 598,
    COST2 = 599,
    RETRANSMIT = 600,
    HELLO = 601,
    TRANSMIT = 602,
    PRIORITY = 603,
    DEAD = 604,
    TYPE = 605,
    BROADCAST = 606,
    BCAST = 607,
    NONBROADCAST = 608,
    NBMA = 609,
    POINTOPOINT = 610,
    PTP = 611,
    POINTOMULTIPOINT = 612,
    PTMP = 613,
    STRICT = 614,
    CRYPTOGRAPHIC = 615,
    ELIGIBLE = 616,
    POLL = 617,
    NETWORKS = 618,
    HIDDEN = 619,
    VIRTUAL = 620,
    ONLY = 621,
    BUFFER = 622,
    LARGE = 623,
    NORMAL = 624,
    STUBNET = 625,
    TAG = 626,
    EXTERNAL = 627,
    LSADB = 628,
    ECMP = 629,
    WEIGHT = 630,
    NSSA = 631,
    TRANSLATOR = 632,
    STABILITY = 633,
    GLOBAL = 634,
    LSID = 635,
    INSTANCE = 636,
    REAL = 637,
    NETMASK = 638,
    LENGTH = 639,
    LSA = 640,
    SUPPRESSION = 641,
    TOPOLOGY = 642,
    STATE = 643,
    PIPE = 644,
    MODE = 645,
    OPAQUE = 646,
    TRANSPARENT = 647,
    RADV = 648,
    RA = 649,
    MANAGED = 650,
    OTHER = 651,
    CONFIG = 652,
    LINGER = 653,
    MTU = 654,
    REACHABLE = 655,
    RETRANS = 656,
    TIMER = 657,
    CURRENT = 658,
    VALID = 659,
    PREFERRED = 660,
    MULT = 661,
    LIFETIME = 662,
    SKIP = 663,
    ONLINK = 664,
    AUTONOMOUS = 665,
    RDNSS = 666,
    DNSSL = 667,
    NS = 668,
    DOMAIN = 669,
    TRIGGER = 670,
    SENSITIVE = 671,
    LOW = 672,
    MEDIUM = 673,
    HIGH = 674,
    PROPAGATE = 675,
    RA_PREFERENCE = 676,
    RA_LIFETIME = 677,
    RIP = 678,
    INFINITY = 679,
    UPDATE = 680,
    GARBAGE = 681,
    MULTICAST = 682,
    VERSION = 683,
    SPLIT = 684,
    HORIZON = 685,
    POISON = 686,
    REVERSE = 687,
    ZERO = 688,
    PLAINTEXT = 689,
    RIP_METRIC = 690,
    RIP_TAG = 691,
    STATIC = 692,
    PROHIBIT = 693,
    MULTIPATH = 694,
    BLACKHOLE = 695,
    UNREACHABLE = 696,
    BABEL = 697,
    RXCOST = 698,
    WIRED = 699,
    WIRELESS = 700,
    BABEL_METRIC = 701,
    ENTRIES = 702
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 663 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct f_dynamic_attr fda;
  struct f_static_attr fsa;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct mrt_dump_data *md;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1252 "cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1269 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  75
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3842

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  469
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  326
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1111
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  2111

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   702

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    32,     2,     2,     2,    31,     2,     2,
     460,   461,    29,    27,   465,    28,    33,    30,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   462,   459,
      23,    22,    24,   466,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   467,     2,   468,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   463,     2,   464,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    26,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   415,
     416,   417,   418,   419,   420,   421,   422,   423,   424,   425,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,   438,   439,   440,   441,   442,   443,   444,   445,
     446,   447,   448,   449,   450,   451,   452,   453,   454,   455,
     456,   457,   458
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   882,   882,   883,   886,   888,   896,   905,   906,   907,
     914,   915,   916,   924,   925,   926,   927,   928,   929,   935,
     936,   943,   944,   948,   955,   956,   960,   964,   971,   979,
     980,   987,   988,   992,   993,   999,  1008,  1009,  1013,  1018,
    1019,  1023,  1024,  1028,  1029,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,  1047,  1048,  1058,  1059,  1060,  1061,
    1064,  1065,  1066,  1067,  1068,  1069,  1073,  1079,  1080,  1081,
    1082,  1090,  1093,  1100,  1103,  1106,  1109,  1113,  1114,  1118,
    1119,  1120,  1128,  1133,  1134,  1138,  1139,  1143,  1150,  1151,
    1152,  1164,  1169,  1173,  1187,  1188,  1202,  1203,  1207,  1208,
    1209,  1210,  1217,  1231,  1233,  1235,  1239,  1240,  1241,  1242,
    1247,  1253,  1254,  1258,  1266,  1270,  1272,  1278,  1279,  1286,
    1287,  1291,  1297,  1301,  1310,  1319,  1321,  1325,  1326,  1327,
    1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
    1338,  1342,  1343,  1344,  1345,  1349,  1350,  1351,  1352,  1353,
    1357,  1363,  1367,  1375,  1376,  1384,  1392,  1393,  1394,  1398,
    1399,  1403,  1408,  1409,  1413,  1415,  1423,  1427,  1428,  1434,
    1441,  1442,  1443,  1444,  1448,  1456,  1462,  1463,  1464,  1468,
    1469,  1473,  1474,  1475,  1476,  1477,  1478,  1484,  1485,  1486,
    1490,  1491,  1495,  1496,  1502,  1503,  1506,  1508,  1512,  1513,
    1517,  1537,  1538,  1539,  1540,  1541,  1542,  1543,  1544,  1545,
    1549,  1550,  1551,  1552,  1553,  1554,  1555,  1556,  1557,  1558,
    1564,  1567,  1570,  1573,  1577,  1578,  1581,  1584,  1588,  1592,
    1597,  1603,  1610,  1615,  1620,  1625,  1629,  1633,  1637,  1646,
    1654,  1658,  1665,  1666,  1667,  1672,  1676,  1683,  1690,  1694,
    1702,  1703,  1704,  1709,  1713,  1716,  1717,  1718,  1719,  1720,
    1721,  1722,  1727,  1732,  1740,  1747,  1754,  1762,  1764,  1766,
    1768,  1770,  1772,  1774,  1776,  1779,  1783,  1789,  1790,  1791,
    1795,  1796,  1802,  1804,  1806,  1808,  1810,  1812,  1816,  1820,
    1823,  1827,  1828,  1829,  1833,  1834,  1835,  1843,  1843,  1853,
    1857,  1858,  1859,  1860,  1861,  1862,  1863,  1864,  1865,  1866,
    1867,  1868,  1869,  1870,  1871,  1893,  1904,  1905,  1912,  1913,
    1920,  1929,  1933,  1937,  1958,  1959,  1963,  1975,  1975,  1991,
    1992,  1995,  1996,  2000,  2003,  2012,  2025,  2026,  2027,  2028,
    2029,  2033,  2041,  2042,  2043,  2044,  2045,  2049,  2052,  2053,
    2054,  2055,  2056,  2057,  2058,  2059,  2060,  2061,  2066,  2067,
    2068,  2069,  2073,  2074,  2075,  2079,  2080,  2081,  2082,  2083,
    2084,  2085,  2086,  2091,  2092,  2093,  2094,  2095,  2099,  2100,
    2101,  2102,  2103,  2107,  2108,  2112,  2113,  2117,  2124,  2125,
    2126,  2127,  2134,  2135,  2138,  2139,  2146,  2158,  2159,  2163,
    2164,  2168,  2169,  2170,  2171,  2172,  2173,  2177,  2178,  2179,
    2183,  2184,  2185,  2186,  2187,  2188,  2189,  2190,  2191,  2192,
    2196,  2197,  2198,  2199,  2209,  2213,  2235,  2247,  2248,  2249,
    2250,  2251,  2252,  2253,  2254,  2255,  2256,  2260,  2261,  2262,
    2263,  2264,  2265,  2266,  2267,  2268,  2269,  2270,  2271,  2272,
    2273,  2274,  2275,  2276,  2278,  2279,  2280,  2282,  2284,  2286,
    2288,  2289,  2290,  2291,  2292,  2293,  2303,  2304,  2305,  2306,
    2307,  2308,  2309,  2310,  2312,  2313,  2316,  2338,  2339,  2340,
    2341,  2342,  2343,  2347,  2350,  2351,  2352,  2360,  2366,  2374,
    2375,  2379,  2384,  2392,  2400,  2405,  2409,  2415,  2419,  2424,
    2425,  2426,  2433,  2434,  2435,  2436,  2437,  2443,  2451,  2452,
    2453,  2454,  2457,  2459,  2463,  2467,  2481,  2501,  2502,  2503,
    2504,  2505,  2506,  2507,  2508,  2512,  2513,  2514,  2515,  2516,
    2517,  2520,  2522,  2525,  2527,  2531,  2534,  2539,  2540,  2541,
    2545,  2546,  2550,  2551,  2554,  2573,  2579,  2606,  2608,  2609,
    2614,  2615,  2619,  2620,  2624,  2625,  2626,  2627,  2628,  2629,
    2630,  2631,  2632,  2636,  2637,  2638,  2639,  2640,  2641,  2647,
    2648,  2649,  2650,  2651,  2652,  2653,  2654,  2655,  2656,  2657,
    2658,  2659,  2660,  2661,  2662,  2663,  2664,  2665,  2666,  2667,
    2668,  2669,  2670,  2671,  2672,  2673,  2674,  2675,  2676,  2677,
    2678,  2679,  2680,  2681,  2682,  2683,  2684,  2685,  2686,  2692,
    2693,  2694,  2695,  2696,  2697,  2698,  2699,  2700,  2701,  2702,
    2703,  2704,  2705,  2706,  2707,  2708,  2709,  2710,  2711,  2722,
    2728,  2729,  2730,  2731,  2732,  2733,  2734,  2737,  2739,  2743,
    2746,  2750,  2751,  2752,  2753,  2754,  2755,  2762,  2772,  2773,
    2777,  2778,  2779,  2780,  2781,  2782,  2783,  2784,  2785,  2788,
    2803,  2806,  2808,  2812,  2813,  2814,  2815,  2816,  2817,  2818,
    2819,  2820,  2821,  2821,  2822,  2822,  2823,  2824,  2825,  2829,
    2830,  2834,  2842,  2844,  2848,  2849,  2850,  2854,  2855,  2858,
    2860,  2863,  2864,  2865,  2866,  2867,  2868,  2869,  2870,  2871,
    2872,  2873,  2876,  2896,  2897,  2898,  2899,  2900,  2901,  2902,
    2903,  2904,  2905,  2906,  2907,  2908,  2909,  2910,  2911,  2912,
    2913,  2914,  2915,  2916,  2917,  2918,  2919,  2920,  2921,  2922,
    2923,  2924,  2925,  2926,  2927,  2928,  2929,  2930,  2931,  2932,
    2933,  2934,  2937,  2939,  2942,  2944,  2953,  2955,  2956,  2959,
    2961,  2965,  2966,  2969,  2979,  3000,  3002,  3006,  3006,  3009,
    3011,  3014,  3016,  3020,  3025,  3028,  3031,  3036,  3039,  3044,
    3047,  3051,  3055,  3058,  3059,  3060,  3061,  3062,  3063,  3064,
    3065,  3071,  3078,  3079,  3080,  3085,  3086,  3092,  3102,  3103,
    3104,  3105,  3105,  3106,  3106,  3107,  3112,  3115,  3117,  3121,
    3125,  3148,  3149,  3150,  3151,  3152,  3153,  3154,  3155,  3156,
    3157,  3162,  3166,  3167,  3168,  3169,  3170,  3171,  3171,  3172,
    3172,  3173,  3174,  3178,  3179,  3180,  3183,  3221,  3223,  3226,
    3228,  3232,  3235,  3248,  3249,  3250,  3251,  3255,  3262,  3270,
    3272,  3275,  3277,  3281,  3285,  3295,  3300,  3301,  3302,  3306,
    3318,  3320,  3324,  3325,  3329,  3342,  3347,  3348,  3349,  3353,
    3365,  3367,  3371,  3372,  3377,  3378,  3382,  3383,  3390,  3403,
    3404,  3405,  3406,  3407,  3410,  3412,  3416,  3420,  3443,  3473,
    3474,  3475,  3476,  3477,  3478,  3479,  3483,  3484,  3485,  3486,
    3487,  3488,  3489,  3490,  3491,  3492,  3493,  3494,  3495,  3496,
    3497,  3498,  3499,  3500,  3504,  3505,  3506,  3507,  3510,  3512,
    3515,  3517,  3521,  3527,  3530,  3537,  3544,  3545,  3546,  3547,
    3548,  3551,  3561,  3570,  3574,  3580,  3581,  3585,  3590,  3596,
    3599,  3604,  3605,  3606,  3607,  3608,  3612,  3613,  3616,  3618,
    3621,  3623,  3627,  3633,  3640,  3641,  3644,  3646,  3650,  3654,
    3667,  3690,  3691,  3692,  3693,  3694,  3695,  3696,  3697,  3698,
    3699,  3700,  3701,  3704,  3706,  3709,  3711,  3716,  3721,  3724,
    3727,  3734,  3734,  3734,  3734,  3734,  3734,  3734,  3734,  3734,
    3734,  3734,  3734,  3734,  3734,  3734,  3734,  3735,  3735,  3735,
    3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,
    3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,
    3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,
    3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,
    3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,  3735,
    3736,  3736,  3736,  3736,  3736,  3736,  3736,  3736,  3736,  3736,
    3736,  3736,  3737,  3737,  3737,  3737,  3738,  3738,  3738,  3739,
    3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,
    3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,
    3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,  3739,
    3740,  3740,  3741,  3742,  3743,  3744,  3745,  3746,  3747,  3748,
    3749,  3750,  3751,  3752,  3752,  3752,  3752,  3752,  3752,  3752,
    3752,  3752
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "NMA", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'",
  "DEFINE", "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG",
  "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR",
  "AUTH", "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD",
  "SHORT", "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT",
  "LATENCY", "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST",
  "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART",
  "KRT_SOURCE", "KRT_METRIC", "MERGE", "PATHS", "TABLE", "METRIC",
  "KRT_PREFSRC", "KRT_REALM", "KRT_SCOPE", "KRT_MTU", "KRT_WINDOW",
  "KRT_RTT", "KRT_RTTVAR", "KRT_SSTRESH", "KRT_CWND", "KRT_ADVMSS",
  "KRT_REORDERING", "KRT_HOPLIMIT", "KRT_INITCWND", "KRT_RTO_MIN",
  "KRT_INITRWND", "KRT_QUICKACK", "KRT_LOCK_MTU", "KRT_LOCK_WINDOW",
  "KRT_LOCK_RTT", "KRT_LOCK_RTTVAR", "KRT_LOCK_SSTRESH", "KRT_LOCK_CWND",
  "KRT_LOCK_ADVMSS", "KRT_LOCK_REORDERING", "KRT_LOCK_HOPLIMIT",
  "KRT_LOCK_RTO_MIN", "KRT_FEATURE_ECN", "KRT_FEATURE_ALLFRAG", "ROUTER",
  "ID", "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT",
  "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE", "VRF", "DEFAULT",
  "STATES", "FILTERS", "RECEIVE", "ACTION", "WARN", "BLOCK", "DISABLE",
  "KEEP", "FILTERED", "PASSWORD", "FROM", "PASSIVE", "TO", "EVENTS",
  "PACKETS", "PROTOCOLS", "INTERFACES", "ALGORITHM", "KEYED", "HMAC",
  "MD5", "SHA1", "SHA256", "SHA384", "SHA512", "PRIMARY", "STATS", "COUNT",
  "FOR", "COMMANDS", "PREEXPORT", "NOEXPORT", "GENERATE", "ROA", "LISTEN",
  "BGP", "V6ONLY", "DUAL", "ADDRESS", "PASSWORDS", "DESCRIPTION", "SORTED",
  "RELOAD", "IN", "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY",
  "IGP_METRIC", "CLASS", "DSCP", "WAIT", "MAX", "FLUSH", "AS", "SHOW",
  "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "ADD", "DELETE", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "EVAL", "ECHO",
  "ENABLE", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN", "ACCEPT",
  "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR", "QUAD",
  "EC", "LC", "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "ECLIST",
  "LCLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT", "RO",
  "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED", "CONTAINS",
  "RESET", "PREPEND", "FIRST", "LAST", "LAST_NONAGGREGATED", "MATCH",
  "ROA_CHECK", "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX",
  "INTERVAL", "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL",
  "AUTHENTICATION", "SIMPLE", "METICULOUS", "SESSIONS", "HOLD", "CONNECT",
  "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF", "PATH",
  "START", "DELAY", "FORGET", "AFTER", "BGP_PATH", "BGP_LOCAL_PREF",
  "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP", "BGP_ATOMIC_AGGR",
  "BGP_AGGREGATOR", "BGP_COMMUNITY", "BGP_EXT_COMMUNITY", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "IPV4", "CAPABILITIES",
  "PREFER", "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH",
  "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID", "BGP_CLUSTER_LIST",
  "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL", "SECURITY", "DETERMINISTIC",
  "SECONDARY", "ALLOW", "AWARE", "LINK", "EXTENDED", "SETKEY",
  "BGP_LARGE_COMMUNITY", "LIVED", "STALE", "CEASE", "HIT",
  "ADMINISTRATIVE", "SHUTDOWN", "PEER", "CONFIGURATION", "CHANGE",
  "DECONFIGURED", "CONNECTION", "REJECTED", "COLLISION", "OF", "MRT",
  "FILENAME", "PERIOD", "ALWAYS", "OSPF", "AREA", "OSPF_METRIC1",
  "OSPF_METRIC2", "OSPF_TAG", "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB",
  "TICK", "COST", "COST2", "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY",
  "DEAD", "TYPE", "BROADCAST", "BCAST", "NONBROADCAST", "NBMA",
  "POINTOPOINT", "PTP", "POINTOMULTIPOINT", "PTMP", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL",
  "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL",
  "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "LSA", "SUPPRESSION",
  "TOPOLOGY", "STATE", "PIPE", "MODE", "OPAQUE", "TRANSPARENT", "RADV",
  "RA", "MANAGED", "OTHER", "CONFIG", "LINGER", "MTU", "REACHABLE",
  "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT", "LIFETIME",
  "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS", "DOMAIN",
  "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "PROPAGATE",
  "RA_PREFERENCE", "RA_LIFETIME", "RIP", "INFINITY", "UPDATE", "GARBAGE",
  "MULTICAST", "VERSION", "SPLIT", "HORIZON", "POISON", "REVERSE", "ZERO",
  "PLAINTEXT", "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH",
  "BLACKHOLE", "UNREACHABLE", "BABEL", "RXCOST", "WIRED", "WIRELESS",
  "BABEL_METRIC", "ENTRIES", "';'", "'('", "')'", "':'", "'{'", "'}'",
  "','", "'?'", "'['", "']'", "$accept", "config", "conf_entries",
  "definition", "expr", "expr_us", "bool", "ipa", "ipa_scope", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text", "opttext", "text_or_none",
  "log_config", "syslog_name", "log_file", "log_mask", "log_mask_list",
  "log_cat", "mrtdump_base", "timeformat_which", "timeformat_spec",
  "timeformat_base", "debug_unix", "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT",
  "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cfg_name", "cfg_timeout", "kern_proto_start",
  "kern_mp_limit", "kern_item", "kif_proto_start", "kif_item",
  "kern_sys_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "gr_opts", "tab_sorted", "newtab", "roa_table_start", "roa_table_opts",
  "roa_table", "proto_start", "proto_name", "proto_item", "imexport",
  "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "password_algorithm",
  "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS",
  "cmd_SHOW_PROTOCOLS_ALL", "optsym", "cmd_SHOW_INTERFACES",
  "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE", "r_args", "export_mode",
  "cmd_SHOW_ROA", "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args",
  "roa_table_arg", "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS",
  "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES",
  "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO",
  "echo_mask", "echo_size", "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART",
  "cmd_RELOAD", "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG",
  "cmd_MRTDUMP", "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def",
  "$@1", "filter_eval", "type", "one_decl", "decls", "declsn",
  "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "cmds_int", "block",
  "fipa", "set_atom", "switch_atom", "cnum", "pair_item", "ec_kind",
  "ec_item", "lc_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_finish",
  "bfd_iface_item", "bfd_auth_type", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_nbr_opts",
  "bgp_cease_mask", "bgp_cease_list", "bgp_cease_flag", "bgp_proto",
  "mrt_proto_start", "mrt_proto_item", "mrt_proto_opts", "mrt_proto",
  "cmd_MRT_DUMP", "mrt_dump_args", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@6", "$@7", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@8", "$@9", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_proto_start", "rip_proto_item", "rip_proto_opts", "rip_proto",
  "rip_iface_start", "rip_iface_finish", "rip_iface_item", "rip_auth",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface",
  "cmd_SHOW_RIP_INTERFACES", "cmd_SHOW_RIP_NEIGHBORS",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "stat_route_item", "stat_route_opts",
  "stat_route_opt_list", "cmd_SHOW_STATIC", "babel_proto_start",
  "babel_proto_item", "babel_proto_opts", "babel_proto",
  "babel_iface_start", "babel_iface_finish", "babel_iface_item",
  "babel_iface_opts", "babel_iface_opt_list", "babel_iface",
  "cmd_SHOW_BABEL_INTERFACES", "cmd_SHOW_BABEL_NEIGHBORS",
  "cmd_SHOW_BABEL_ENTRIES", "conf", "cli_cmd", "proto", "kern_proto",
  "kif_proto", "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,   277,    43,    45,    42,
      47,    37,    33,    46,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   657,   658,   659,   660,   661,   662,   663,
     664,   665,   666,   667,   668,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,   687,   688,   689,   690,   691,   692,   693,
     694,   695,   696,   697,   698,   699,   700,   701,   702,    59,
      40,    41,    58,   123,   125,    44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1625

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1625)))

#define YYTABLE_NINF -490

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-490)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      89,  2028,   207,   835,   757,   867,   212,   757,   757,   729,
     757,   245,   124,  2306,   148,   277,  1147,  2098,    42,   757,
      65, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625,   439,   855,   226,
     820,   315,   455,   523,   456, -1625, -1625,   596,   545,   500,
     198,  2098,   672, -1625, -1625, -1625, -1625, -1625, -1625,   222,
     222, -1625, -1625, -1625, -1625,   287, -1625,  2880, -1625,   222,
    2941, -1625, -1625, -1625,   222, -1625,   222,  3087,   222, -1625,
     222,  2908,   222,  3255,   222, -1625,   222, -1625,   222,  1078,
     222, -1625, -1625, -1625,  2935,  2011, -1625, -1625, -1625,   139,
   -1625,   739,   693,   716,   739,   698, -1625,   747,   747,   757,
     757,   814,   145, -1625,   743,   905,    68, -1625,   836,   853,
   -1625, -1625,   589,   414,   321,   849,   137,   843,   843,   868,
     873,   880,   898,   901,   903,   906,   914,    41, -1625, -1625,
   -1625,   892,   470, -1625,   692,   151,    27,  2098, -1625,   484,
     489,   492, -1625, -1625,   502,   507,   529,  1119,    95, -1625,
   -1625, -1625, -1625, -1625,  2533, -1625,  3650, -1625, -1625,  2349,
     945,   747, -1625,   979, -1625, -1625,   955, -1625, -1625,   -12,
     294,   139,   278, -1625, -1625, -1625, -1625,   538,   573,   278,
     278,   860,   904,    58, -1625,  1050, -1625,   145,   613,  2919,
   -1625,   951,  1079,   654,   667, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,   680,   139,
     822,  1131,  1038,   278,   705, -1625,  1026,   999,   217,  1090,
     846,   145, -1625,   708,   724,   730,   738,   141,   842,   891,
    1153,   777,  1217,   611,   954,   846,   705,  1172,  1158,    30,
    1076,   385,   180,   843,   182,  1174,   279,  1175,   985,   986,
    1186,   993,   630,   981,   980,   705,   983,   982,   978,   910,
     101,  1210,   984,   997,   705,   347,   705, -1625,   840,   851,
     865,   920,   154,   705,  1200,   278,   705,  1212, -1625, -1625,
     887,   877, -1625,   894,  1268,   609, -1625,   896,   895,   897,
     900,  1036,   843,  1279, -1625,   907,   485,   908,   911,  1283,
     705,  1299,   705,  1294,  1296,  1293,   278, -1625,   923,   924,
     925,  1313,   747, -1625,   931,   933, -1625, -1625,  1152,  1390,
     698, -1625, -1625,  1395,   278,  1397, -1625,  1398,  1399,  1400,
    1402, -1625, -1625, -1625,   271,  1403,  1389,  1410, -1625, -1625,
    1015,  1414, -1625,  1417,   259, -1625, -1625,  3416,  1841,   849,
   -1625,   849,   849, -1625,   368,   535,  1419,   849,   849,  1420,
     849,   849,   849, -1625, -1625,     4,  1236,  1246, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625,    25, -1625,    41,  2098,
      41,    41,  1418, -1625,  1415,  1448,  1408,   161,  1409,    27,
      27,  1406,  1424,  2098,  2098,  2098,  2098,  2098,  1429, -1625,
   -1625,  1435, -1625,   988,    74, -1625, -1625, -1625, -1625,   987,
   -1625,  1444, -1625, -1625, -1625, -1625,   164,    35, -1625,   215,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625,  2098,  2098,  2098,  2098,
    2098,  2098,  2098,  2098,  2098,  2098,  2098,  2098,  2098,  2098,
     872, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
     582, -1625, -1625,  1455,  1456,   567,  2098,   846, -1625, -1625,
    2349,  1001, -1625, -1625, -1625, -1625, -1625, -1625,   278,  2098,
   -1625, -1625, -1625, -1625,   278,   989,  1004, -1625,   755, -1625,
   -1625,   278, -1625, -1625, -1625, -1625, -1625, -1625, -1625,  2098,
    1003,  3475, -1625,   122,  1010, -1625,  1012,  1458, -1625, -1625,
   -1625,  -124, -1625, -1625,   705, -1625, -1625,   154, -1625, -1625,
   -1625, -1625,   256,  3371, -1625,  1336,  2098, -1625, -1625,   256,
   -1625, -1625, -1625,   256, -1625, -1625, -1625, -1625, -1625, -1625,
    1405,  1421,    60,   705,   167, -1625,  1020,   278,   278,   -14,
    1023,  1025,   278,    90,  1177,   705,  1310,   843,  1032,  1033,
   -1625,  1034,  1463,   110,   278,  1311,   278,  1432,  1434,   278,
    1441,    69,   705,  1442,  1060,  1412,  1061,   705,  1063,   705,
     411,   705,  1131,   705,  1071,  1080,   705,   705,   705,  1081,
    1356,   705,  1084, -1625, -1625, -1625,   705, -1625, -1625,   705,
   -1625,  1476,   278, -1625, -1625, -1625,  1537,  1099,  1102, -1625,
   -1625, -1625, -1625,   705, -1625,  1131, -1625, -1625,  1002, -1625,
     843, -1625,  1288, -1625, -1625, -1625,  1107, -1625,   278, -1625,
     278, -1625,   705,   705,   705, -1625, -1625, -1625, -1625,   278,
     843, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,   624,
   -1625, -1625,  1564, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625,   639, -1625, -1625, -1625, -1625,  1566, -1625, -1625,
   -1625,  1551, -1625, -1625,  1556,   843, -1625, -1625,  1553,  1557,
   -1625,  3371, -1625, -1625, -1625, -1625,   843, -1625, -1625, -1625,
    1561, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
    1579,  1563,  1563,  1265,   849,  1563,   849,  1563, -1625,  1563,
    1563, -1625,  1563,  1563,  1563,   278,   843, -1625,  1569,  1572,
    1574, -1625, -1625,   451, -1625, -1625, -1625, -1625,   202, -1625,
    1134, -1625,  1338,  1562, -1625, -1625, -1625, -1625,   369,   595,
     649,  1162,   677,  -219, -1625,  2098, -1625,  2098,  1136,    22,
    1137,  1297,   119,   235, -1625, -1625, -1625,  1584,  1585, -1625,
    3280,  3280,  3280,  3429,  3429,  3280,  3280,  3280,  3280,  3280,
     802,   802,  1424,  1424, -1625,  1154, -1625, -1625, -1625, -1625,
   -1625,  2349, -1625, -1625, -1625,  1100,  3371,   846, -1625,  1029,
   -1625,   676, -1625, -1625,  1416,  1587, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625,  1156, -1625,  1159,  1524, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625,   166,  1160,  1149, -1625, -1625,   278, -1625, -1625,
     843, -1625, -1625, -1625,   772,  3475, -1625,   843, -1625,  1165,
   -1625,  1589, -1625,  1148, -1625,  1488, -1625, -1625, -1625, -1625,
     705,  2919, -1625, -1625,  1746,   278,   278,  1544,  1554,  1168,
     278,  1170,  1178, -1625,  1179,  1182,   705,    53, -1625, -1625,
    1190,  1194,  1195,  1198,   705,  1209,   705,  1213, -1625, -1625,
   -1625,  1612, -1625,   278,   278, -1625,  1214,   278,  1215,   278,
     278,  1216,   278,  1220,  1222,  1223,   278, -1625,   154, -1625,
    1224, -1625,  1225,  1226,  1227,  1232,  1233,  1235,  1238, -1625,
   -1625,  1239,  1241,  1245, -1625,   262,  1249, -1625,  3147, -1625,
   -1625,   278, -1625,  1462,  1258, -1625, -1625,  2914,  3060,  1260,
    1261, -1625,  1463, -1625,   843,   -34,  1288,   821, -1625,  3308,
   -1625, -1625, -1625, -1625,  1576, -1625,     4, -1625, -1625, -1625,
    1152, -1625, -1625,   271, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625,  1666,  1702, -1625, -1625,   154,
   -1625, -1625,   154,  1706, -1625,   154,  1563,  1719,  1563,  1720,
    1723,  1724,  1725,  1727,  1728, -1625, -1625,  1548,  1549,    41,
   -1625,  2098, -1625,  1709,  1710,  2098,  2098,  2098, -1625,  2098,
   -1625,  2098,   703,   133,  1242,  2098,  1496,  2098, -1625, -1625,
    2098, -1625, -1625,  1274,   892, -1625,  2098, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625,  1148, -1625, -1625,
   -1625, -1625,  3475,  1129, -1625, -1625, -1625,  1281,  1284, -1625,
    1565, -1625, -1625,  1082, -1625,   510, -1625, -1625, -1625, -1625,
     843, -1625, -1625,  1287,  1282,  1292,   548,   278, -1625,  1295,
   -1625, -1625, -1625, -1625,  1300,  1244, -1625,  1301, -1625, -1625,
   -1625, -1625,  1303, -1625,  1304, -1625, -1625,   152, -1625, -1625,
   -1625,  1318, -1625,  1328,  1340, -1625,  1341, -1625, -1625, -1625,
    1342,  1343, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625,  1345, -1625,  1138,  3371,   846,   278,
    1616, -1625, -1625, -1625,  1350, -1625, -1625,    84,   705,   806,
   -1625,  1430,   843, -1625, -1625,   928, -1625,  1354, -1625,  1425,
   -1625, -1625,   843, -1625, -1625,   843,  1733, -1625, -1625,  1357,
   -1625,   705,   278, -1625, -1625,  1360, -1625, -1625, -1625,  1463,
     705,   278,   -34,     9, -1625,  1799, -1625, -1625,  1362,  2098,
   -1625, -1625, -1625,  2098,  2098,   705, -1625,  2533,  1366,  1778,
   -1625, -1625, -1625, -1625, -1625,  1367,   278, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625,  1825, -1625,  1828, -1625,
   -1625, -1625, -1625, -1625, -1625,  1819,  1824, -1625, -1625,  1812,
   -1625,  1756,  2150,  2224,  2283,   760,  2098, -1625,  2098,     3,
      34,  2919,  1376,   233,    21,  1377,  1297,  1832,  2330, -1625,
    1384,   100, -1625,  3475, -1625,  1839,   843, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625,  1392, -1625,   143, -1625,
   -1625,   278, -1625,  1404,  1413,  1422, -1625, -1625,  1516,  1789,
   -1625,    -7,  1523,  1533,   823,   712, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625,  1593, -1625, -1625, -1625,   278,   278,   705, -1625,
     278, -1625,  1436,   154, -1625, -1625,  1437,  1438,   278, -1625,
   -1625,   278,  1439, -1625, -1625, -1625,  1443, -1625,   149,    31,
   -1625,   705, -1625, -1625, -1625,  1806, -1625, -1625, -1625, -1625,
   -1625,  2098,  1448,  2098, -1625,  2653,  3617,   947,  1426,  1857,
     616, -1625,  2919,  1423,  1428, -1625, -1625, -1625, -1625, -1625,
   -1625,   743,   743,  1852, -1625, -1625, -1625, -1625,  2098,  2356,
    2382, -1625,  1878,  2098, -1625,  1963, -1625,  1881,  2098,  1904,
    2031,  2075,  1449, -1625, -1625, -1625, -1625,  1729, -1625,  1148,
    1392, -1625, -1625,  1893,   846,  1651,  1459, -1625, -1625, -1625,
    1726,  1592, -1625, -1625, -1625, -1625, -1625, -1625, -1625,  1244,
     705,  1148,  1460, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625,  1461, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625,  1465,   278,  2680,  1464,
    2706,  2809, -1625,  1508, -1625, -1625,  2098,  2098,   694,  1778,
   -1625,  1466,  1916,  1927, -1625,  2409, -1625, -1625,  1471,  1472,
     292,    36,  1473,   301,  1475,  1478,    38,  1480,    39, -1625,
    1922, -1625,  1688, -1625, -1625, -1625,   843,  1680, -1625, -1625,
   -1625, -1625, -1625,  1425, -1625, -1625,    46,  -107,    48,   187,
   -1625, -1625,   690, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625,  1483,  1129,  1722, -1625,    32,  2770,  2824,  1491,
    1492,  1493,  1494,  1498, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625,  1929,  2098, -1625, -1625, -1625,  1932,  2098,
   -1625,  2098,  1955, -1625,  2098, -1625,  1506, -1625,   846,   705,
    1503,   922,  1708,   278,   278,   710, -1625, -1625, -1625,  1509,
    1514, -1625,   705, -1625, -1625,  3245, -1625, -1625, -1625,    70,
     705,   278,   705, -1625,  1515, -1625,   278,   -35,   278,   278,
    1693,   177, -1625, -1625,  1525,  3062, -1625,  1568,  1570,   705,
     705,   705, -1625,  1530,   400,   244,  2884, -1625,  1535,  1534,
    1508,   114, -1625, -1625, -1625,   987, -1625, -1625,  1980, -1625,
   -1625, -1625, -1625,   384, -1625, -1625,  2098,  2098,  2098,  2098,
   -1625,  1019, -1625,  1538,  1540,  1541,  1543,  1542,  1545,  1550,
   -1625, -1625, -1625,  1873,  1752,  1753,  1754, -1625, -1625, -1625,
    1046, -1625,  1868, -1625,   950, -1625, -1625,  1694,   278,  1558,
     705,  1641,   192,   185,  1707,   705,  1624,   705,   278,   278,
     278,  1745,   278,   349,  1528,  1634,  1665,   278,  1644,  1670,
   -1625, -1625,  1575, -1625,   278,  1577, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625,   278,   278, -1625, -1625,
     -59,  1628,   159,    40,   -61,  1625,   705,  1629,  1962,  1626,
    1765,  1779,  1786, -1625,  1594,   278,   278, -1625, -1625, -1625,
   -1625,   388,   843, -1625,  1595,   388,  2035, -1625,  1607,   278,
     -78,  1991,   278,   705,   843,   705,  1690,   275,   -70,  1751,
    1684,  -153,  1995,  1996,   320,  1632,  1633, -1625, -1625,  1619,
   -1625, -1625, -1625, -1625,  2435,   106,   114,   132,  2477,  2503,
    2544,  2570,   278,  1757,  1697,   420,  1818,   749,  1820,   278,
   -1625,  1623, -1625, -1625, -1625,  2098, -1625,  2098, -1625,  1620,
    1637,   278,   278,   278, -1625, -1625,  1058,   278,  2065,  2065,
    1064,   308,   508,  1642,   705, -1625, -1625, -1625,   263,   278,
     278,   278,   278, -1625, -1625, -1625, -1625,   858, -1625,  1701,
   -1625, -1625, -1625, -1625,   278, -1625,   278, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625,   705,   705, -1625,   278,
     705, -1625, -1625, -1625, -1625, -1625,   699,   278,  1826,   699,
    2025,   278,  2032, -1625,   278,  1849,   278, -1625,   705,   278,
     278,  2043,   705,   149,   705,    31, -1625,  1692,  1692,   278,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
     705,   705,   278, -1625, -1625, -1625, -1625,   278,   278,   278,
   -1625, -1625, -1625, -1625, -1625, -1625,  1192,   278, -1625, -1625,
     278,   278,   705, -1625,   705,   705, -1625, -1625,  2098, -1625,
   -1625, -1625,  1662,  1663,  1664,  1674, -1625,   705,   278,   278,
     278, -1625,   278, -1625, -1625,   278, -1625, -1625,  1668,  1659,
   -1625,  1873, -1625, -1625, -1625, -1625, -1625,  1675, -1625,  1678,
    1679,  1353,  1513,  1681,  2065,  2065,  2065,  2065, -1625, -1625,
      76, -1625, -1625, -1625, -1625, -1625, -1625, -1625,  1764, -1625,
     705, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625,  1692,   278, -1625,   278,  1692,   278, -1625,   278, -1625,
   -1625, -1625, -1625,   278, -1625, -1625, -1625, -1625,   705, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,  1767, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625,  2435, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,  2098, -1625,
     950,   950,   950, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625,   950,  1683,  1686,  1687,  1691, -1625,  1775,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625,  1698, -1625, -1625, -1625, -1625,   950,   950,   950,
     950, -1625,  1711,  2098, -1625, -1625, -1625, -1625, -1625,  1695,
   -1625
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    77,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   424,     0,     0,
       0,   987,   988,   989,   990,   991,   992,   993,   994,   995,
     996,   997,   998,   999,  1000,  1001,  1002,  1003,  1004,  1005,
    1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,  1015,
    1016,  1017,  1018,  1019,  1020,  1021,  1022,  1023,  1024,  1025,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
    1036,  1037,  1038,  1039,     3,     1,     2,     0,     0,     0,
       0,     0,     0,     0,     0,   119,   120,     0,     0,     0,
       0,   424,     0,   971,   972,   973,   974,   975,   976,   121,
     121,   977,   978,   979,   980,   117,   981,     0,   983,   121,
     125,   984,   985,   986,   121,  1043,   121,   125,   121,  1045,
     121,   125,   121,   125,   121,  1048,   121,  1049,   121,   125,
     121,  1051,     5,   982,   125,   125,   291,   293,   292,     0,
      78,    77,     0,     0,    77,    79,    76,    34,    34,     0,
       0,     0,     0,   290,   262,   295,     0,   246,     0,     0,
     229,   254,     0,   225,     0,   225,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   406,   410,   419,
     416,   335,   426,   413,     0,     0,   409,   424,   457,     0,
       0,     0,   411,   412,     0,     0,     0,   424,     0,   414,
     415,   423,   455,   456,     0,   454,     0,   278,   277,     0,
     280,    34,   641,     0,    30,    29,    37,    40,    38,     0,
      18,     0,     0,    59,    58,    57,    56,     0,     0,     0,
       0,     0,   111,     0,   297,     0,   104,     0,     0,   299,
     327,   122,     0,     0,     0,   115,    82,    91,   169,   546,
     507,   629,   647,   781,   787,   868,   915,   943,     0,     0,
       0,     0,     0,     0,    18,   174,     0,     0,     0,     0,
       0,     0,  1042,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,    18,     0,   547,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,    18,     0,    18,  1044,     0,     0,
       0,     0,     0,    18,     0,     0,    18,     0,  1046,   650,
       0,     0,   658,     0,     0,     0,  1047,     0,     0,     0,
       0,     0,     0,     0,  1050,     0,     0,   940,     0,     0,
      18,     0,    18,     0,     0,     0,     0,  1040,     0,     0,
       0,     0,    34,  1041,     0,     0,   177,   176,     0,     0,
      79,    73,    74,     0,    80,     0,    33,     0,     0,     0,
       0,   285,   188,   187,     0,     0,     0,     0,   294,   296,
     295,     0,   226,     0,   250,   221,   220,     0,     0,   225,
     224,   225,   225,   772,   225,   225,     0,   225,   225,     0,
     225,   225,   225,    19,    20,     0,     0,     0,   273,   269,
     274,   270,   267,   268,   271,   272,   406,   426,   406,   424,
     406,   406,     0,   397,     0,   424,     0,     0,     0,   409,
     409,     0,   452,   424,   424,   424,   424,   424,     0,   358,
     359,     0,   361,     0,     0,   336,   339,   337,   341,   424,
     338,   376,   373,   374,   375,   383,     0,   388,   392,     0,
    1090,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  1066,  1067,
    1068,  1069,  1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,
    1078,  1079,  1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,
    1088,   427,  1089,   428,   429,   430,   431,   432,   433,   434,
     435,   436,  1092,  1095,  1094,  1091,  1093,  1096,  1097,  1098,
    1101,  1099,  1100,  1102,  1103,  1104,  1105,  1106,  1107,  1108,
    1109,  1110,  1111,   458,   459,   275,   424,   424,   424,   424,
     424,   424,   424,   424,   424,   424,   424,   424,   424,   424,
       0,    45,    46,    47,    48,    49,    50,    51,    52,    53,
       0,    43,   281,     0,     0,     0,   424,     0,    39,    41,
       0,     0,     7,     9,    14,    16,    15,    17,     0,   424,
      13,    67,   153,   154,    60,     0,     0,    66,     0,    69,
      70,     0,   112,   113,    98,   100,   101,   102,   165,   424,
       0,   316,   114,     0,     0,    55,     0,     0,   123,  1052,
    1056,     0,   170,   128,    18,   152,   138,     0,   126,   127,
     155,   143,     0,   316,   144,     0,   424,   130,   142,     0,
     131,   137,   136,     0,   140,   129,   171,   172,   512,   563,
       0,     0,     0,    18,    18,   575,     0,     0,     0,     0,
       0,     0,     0,    18,     0,    18,     0,     0,     0,     0,
     576,     0,    21,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    18,     0,     0,     0,     0,    18,     0,    18,
       0,    18,     0,    18,     0,     0,    18,    18,    18,     0,
       0,    18,     0,   564,   637,   648,    18,   659,   651,    18,
     656,   653,     0,   649,   661,   782,     0,     0,     0,   783,
     797,   874,   916,    18,   921,     0,   917,   932,     0,   931,
       0,   935,     0,   933,   934,   938,     0,   946,     0,    85,
       0,    87,    18,    18,    18,    95,  1054,  1055,  1053,     0,
       0,  1058,  1057,   182,   181,   183,   185,   186,   184,     0,
     179,   288,     0,    75,    81,    71,   284,   282,   286,   287,
     192,   193,     0,   190,   289,   263,   266,     0,   222,   227,
     245,     0,   252,   251,     0,     0,   228,   235,     0,     0,
     243,   316,   237,   236,   240,   241,     0,   242,   244,   230,
       0,   234,   253,   261,   255,   258,   259,   257,   260,   256,
       0,    32,    32,     0,   225,    32,   225,    32,   764,    32,
      32,   942,    32,    32,    32,     0,     0,    23,     0,     0,
       0,   401,   403,     0,   404,   405,   399,   387,   487,   490,
       0,   466,     0,     0,   467,   407,   408,   400,     0,     0,
       0,     0,     0,     0,   360,   424,   437,   424,     0,     0,
       0,   347,     0,     0,   417,   389,   390,     0,     0,   418,
     449,   447,   445,   442,   443,   444,   446,   448,   450,   451,
     438,   439,   440,   441,   460,     0,   461,   463,   464,   465,
     279,     0,   276,   283,   640,     0,   316,     0,   645,     0,
      36,     0,    35,    68,     0,     0,    62,    63,    64,    65,
      10,    11,    12,     0,   155,     0,     0,    96,   300,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,     0,     0,     0,   298,   320,     0,   108,   109,
       0,   103,   105,    54,     0,   316,   124,     0,   118,     0,
     139,   159,   162,   175,   151,   145,   133,   321,   322,   141,
      18,   323,   134,   132,   125,     0,     0,     0,     0,     0,
       0,     0,     0,   569,     0,     0,    18,    18,   606,   609,
       0,     0,     0,     0,    18,     0,    18,     0,   628,   627,
     577,     0,   547,     0,     0,   567,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   571,     0,   572,
       0,   604,     0,     0,     0,     0,     0,     0,     0,   583,
     584,     0,     0,     0,   611,     0,     0,   607,   125,   655,
     652,     0,   657,     0,     0,   785,   786,   125,   125,     0,
       0,   928,    21,   930,     0,   925,   929,   424,   920,   125,
      94,    86,    88,    89,    83,    92,    25,    24,    93,   178,
       0,    72,   189,     0,   223,   249,   248,   247,   232,   239,
     233,   231,   238,   545,    31,     0,     0,   771,   780,     0,
     778,   775,     0,     0,   773,     0,    32,     0,    32,     0,
       0,     0,     0,     0,     0,    26,    27,     0,     0,   406,
     398,   424,   476,     0,     0,   424,   424,   424,   453,   424,
     474,   424,     0,     0,   424,   424,   424,   424,   340,   335,
     424,   377,   384,     0,     0,   393,   424,    44,   643,   642,
     644,   646,     6,    42,     8,    61,   110,   166,    97,    99,
     315,   314,   316,   424,   107,   106,   325,   318,     0,   328,
       0,   173,   160,     0,   155,     0,   150,   135,   515,   515,
       0,   514,   508,     0,     0,     0,    18,     0,   626,     0,
     619,   618,   591,   590,     0,     0,   550,     0,   608,   612,
     613,   614,     0,   602,     0,   592,    22,     0,   548,   549,
     565,     0,   573,     0,     0,   596,     0,   579,   578,   585,
       0,     0,   605,   588,   580,   581,   582,   610,   624,   587,
     586,   625,   589,   616,     0,   615,     0,   316,     0,     0,
       0,   639,   630,   633,     0,   654,   754,     0,    18,    18,
     672,     0,     0,   674,   664,    18,   660,     0,   678,   755,
     784,   800,     0,   791,   793,     0,     0,   799,   788,     0,
     877,    18,     0,   876,   869,     0,   918,   919,   927,    21,
      18,     0,   926,     0,   480,     0,   481,   482,     0,   424,
     478,   479,   477,   424,   424,    18,   941,     0,     0,   424,
     936,   939,   949,   948,   944,     0,     0,    90,   180,   191,
     766,   765,   779,   774,   776,   777,     0,   767,     0,   769,
     913,   914,   968,   969,   970,     0,     0,   402,   488,     0,
     468,     0,     0,     0,     0,     0,   424,   420,   424,     0,
       0,   347,     0,     0,     0,     0,     0,     0,     0,   317,
       0,   424,   331,     0,   324,     0,   156,   157,   161,   163,
     148,   146,   147,   149,   155,   509,   533,   510,   537,   511,
     513,     0,   597,     0,     0,     0,   620,   599,     0,     0,
     554,     0,     0,     0,     0,     0,   552,   600,   601,   603,
     568,   566,   595,   594,   574,   593,   570,   617,   631,   632,
     634,   635,     0,   638,   155,   677,     0,     0,    18,   665,
       0,   663,     0,     0,   681,   676,   680,     0,     0,   670,
     662,     0,   688,   155,   789,   832,   841,   790,     0,     0,
     795,    18,   798,   155,   873,   870,   872,   875,   922,   924,
     923,   424,   424,   424,   424,     0,     0,     0,     0,     0,
       0,   500,   483,   485,     0,   155,   945,   947,    84,   768,
     770,   262,   262,     0,   473,   471,   472,   470,   424,     0,
       0,   356,     0,   424,   354,   424,   350,     0,   424,   348,
     424,   424,     0,   462,   326,   332,   319,     0,   158,   164,
     533,   531,   516,     0,     0,   540,     0,   622,   621,   623,
       0,     0,   558,   556,   557,   560,   559,   561,   551,     0,
      18,   757,   761,   667,   668,   666,   669,   742,   702,   682,
     742,   671,   756,   689,   829,   839,   838,   845,   844,   852,
     792,   854,   855,   862,   794,   796,   910,     0,     0,     0,
       0,     0,   494,   424,   394,   937,   424,   424,     0,   424,
     499,   965,     0,     0,   469,     0,   421,   422,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   391,
       0,   516,     0,   536,   538,   539,     0,   542,   598,   562,
     555,   553,   636,   755,   759,   763,     0,     0,     0,   691,
     827,   826,     0,   843,   850,   860,   908,   878,   871,   493,
     425,   497,     0,   424,   491,   333,     0,     0,     0,     0,
       0,     0,     0,     0,   486,   963,   950,   264,   265,   475,
     371,   355,   353,     0,   424,   351,   369,   349,     0,   424,
     367,   424,   365,   364,   424,   362,     0,   535,     0,    18,
       0,     0,     0,     0,     0,     0,   534,   524,   195,   199,
       0,   541,    18,   544,   758,     0,   673,   745,   743,   746,
      18,     0,    18,   679,     0,   675,     0,     0,     0,     0,
       0,     0,   687,   701,     0,     0,   831,     0,     0,    18,
      18,    18,   842,     0,   846,   856,     0,   912,     0,     0,
     424,   424,   342,   346,   344,   424,   501,   345,   381,   378,
     379,   380,   385,     0,   496,   495,   424,   424,   424,   424,
     502,   951,   967,     0,     0,     0,     0,     0,     0,     0,
     116,   200,   522,   196,     0,     0,     0,   517,   521,   525,
       0,   526,     0,   523,   201,   532,   543,     0,     0,     0,
      18,     0,     0,     0,     0,    18,     0,    18,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     762,   741,     0,   747,     0,     0,   685,   686,   684,   683,
     695,   698,   699,   700,   693,   692,     0,     0,   696,   690,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,   817,   819,   830,     0,     0,     0,   833,   834,   835,
     840,     0,     0,   849,     0,     0,     0,   859,     0,     0,
       0,     0,     0,    18,     0,    18,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   911,   903,     0,
     498,   334,   492,   396,   347,     0,   424,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     966,     0,   370,   352,   368,   424,   366,   424,   363,     0,
       0,     0,     0,     0,   527,   528,     0,     0,     0,     0,
       0,     0,     0,     0,    18,   707,   749,   739,     0,     0,
       0,     0,     0,   734,   728,   729,   730,    18,   740,     0,
     723,   703,   706,   704,     0,   721,     0,   708,   710,   711,
     712,   713,   714,   715,   716,   717,    18,    18,   705,     0,
      18,   760,   748,   744,   694,   697,     0,     0,     0,     0,
       0,     0,     0,   816,     0,     0,     0,   804,    18,     0,
       0,     0,    18,     0,    18,     0,   828,   866,   866,     0,
     864,   848,   847,   853,   851,   858,   857,   863,   861,   884,
      18,    18,     0,   879,   882,   883,   901,     0,     0,     0,
     896,   904,   907,   906,   905,   902,    18,     0,   881,   880,
       0,     0,    18,   885,    18,    18,   909,   343,   424,   382,
     395,   386,     0,     0,     0,     0,   952,    18,     0,     0,
       0,   960,     0,   956,   957,     0,   953,   964,     0,     0,
     194,   196,   518,   519,   520,   529,   530,     0,    28,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   198,   724,
       0,   732,   731,   733,   167,   168,   735,   736,     0,   737,
      18,   720,   709,   719,   722,   725,   718,   823,   824,   825,
     812,   866,     0,   813,     0,   866,     0,   803,     0,   806,
     805,   807,   808,     0,   821,   818,   822,   820,    18,   836,
     837,   865,   900,   889,   891,   894,   897,   895,     0,   898,
     893,   890,   892,   886,   887,   888,     0,   506,   504,   505,
     503,   962,   958,   961,   959,   954,   955,   357,   424,   197,
     201,   201,   201,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   201,     0,     0,     0,     0,   727,   751,
     750,   738,   726,   810,   802,   815,   811,   814,   801,   809,
     867,   899,     0,   208,   206,   207,   209,   201,   201,   201,
     201,   752,     0,   424,   202,   203,   204,   205,   753,     0,
     372
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1625, -1625, -1625, -1625,   -76,  -227,   120,  -283,  -835,  -159,
    -767, -1625, -1240,   -77,   602,    28, -1625, -1625, -1625, -1625,
    1583,  1286, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625,   706,  1795, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625,  -317, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625,  3397,   -99,  1882, -1625,   194,  -296, -1625,
   -1625, -1625, -1625,  1024,  -618,  -589, -1625, -1625, -1445, -1625,
   -1625, -1625, -1625,    55, -1625,  1121,   304, -1625,  1116,  -799,
     211, -1624, -1625,  -464, -1625, -1625, -1625, -1625, -1625,  -138,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
    -210, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625,   881,  1794, -1625, -1625, -1625,
   -1625,  -882,  1053,   864,  1588,  -642,  -377, -1625,  1253, -1625,
   -1625, -1396, -1625,   530,  -197,  1344,   389, -1090, -1523,  2000,
   -1497, -1398,  1346,   386, -1625, -1625,  -194,  1348, -1625, -1625,
   -1625, -1625,  -405,   784, -1625, -1625, -1025, -1625,  -171,   935,
     -17, -1625, -1625,   679,  1113,   795, -1030, -1625, -1625, -1625,
   -1625,  1066,   668, -1625, -1625, -1625,   753, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625,  1243, -1625, -1625,   750, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625,   740, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625,   678, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,   350,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,   487,
     469, -1625, -1625, -1625, -1625,   339,   467, -1625, -1625, -1625,
   -1625,   351,   480, -1477, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
    1208, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625, -1625,
   -1625, -1625, -1625, -1625, -1625, -1212
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    94,   580,   589,   581,   415,   982,  1047,
    1048,   817,  1979,   218,  1065,   377,    95,   568,   219,   571,
     560,   561,    96,   227,   228,    97,    98,    21,    22,    23,
      24,    25,    26,   145,   375,    99,  1277,   358,   100,   364,
     359,   101,   600,   102,   603,   932,   103,   593,   104,   105,
     611,   106,   107,   243,   273,   627,  1146,   946,   616,   108,
     941,  1328,  1143,   942,  1459,  1460,   904,   905,  1853,   109,
     110,   620,   274,   369,   749,   750,   385,   762,   763,  1617,
    1829,  1618,  1619,  1843,  1983,    27,    28,    29,    30,   406,
      31,    32,    33,   397,   790,    34,   394,   775,    35,   398,
     387,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,   210,   563,    49,    50,    51,    52,
      53,    54,    55,    56,    57,   139,   391,   111,   601,   112,
     922,   923,   924,  1138,   948,   949,   628,   935,   926,   113,
     606,  1320,  1321,  1574,   199,   461,  1668,   849,   462,   850,
     463,   464,   465,  1672,   466,  1673,   200,   468,   469,  1576,
     431,   201,   432,   441,   202,   203,   204,  1268,   205,   533,
    1311,  1269,  1423,  1424,   829,   830,  1322,   114,  1153,   954,
     115,  1334,  1543,  1620,  1703,  1542,  1462,  1335,  1337,  1465,
    1547,  1623,  1339,    58,   116,   663,  1167,  1355,  1356,   117,
     118,  1214,  1018,   119,    59,   565,   120,   121,   330,   331,
     332,  1023,  1227,  1382,  1387,  1385,  1386,  1557,  1634,  1228,
    1559,  1644,  1229,  1732,  1556,  1628,  1629,  1735,  1990,  2102,
    2080,  1374,  1392,  1482,  1553,  1625,  1555,  1375,    60,    61,
      62,    63,    64,    65,    66,    67,   803,   122,   123,   124,
    1239,  1398,  1399,  1027,   125,  1393,  1764,  1903,  1905,  2010,
    1646,  1645,  1561,  1394,  1396,  1653,  1563,  1562,  1496,  1397,
    1499,  1564,  1774,  1913,  1654,  1500,  1503,  1565,  1778,  1917,
    1655,  1504,  1911,  2029,   126,  1245,  1028,   127,  1403,  1657,
    1799,  1935,  1656,  1567,  1404,    68,    69,   128,   129,   346,
    1035,  1036,   347,  1271,  1037,   726,    70,   130,  1275,  1039,
     131,  1425,  1682,  1821,  1681,  1586,  1426,    71,    72,    73,
     132,    74,   133,   134,   135,   534
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     206,   460,   943,   590,   467,   697,   433,  1270,   416,   417,
     662,   665,  1267,   238,  1310,  1312,  1314,  1315,   318,  1061,
     791,   821,   329,   822,   337,   824,   825,   409,  1448,  1105,
     345,  1411,   820,   569,   815,   360,   365,   966,  1661,   937,
     426,  1443,   439,  1594,   427,  1601,  1604,  1662,  1663,  1664,
    1109,  1501,  1137,  1669,   428,  1420,   426,  1931,   413,   414,
     427,  1886,   855,   856,   413,   414,   413,   414,   572,  1830,
     428,   392,   573,   594,   239,   595,   596,   597,   207,  1670,
    1932,  1630,   536,   537,   538,   539,   540,   208,   574,   575,
     576,   577,  1741,     1,   413,   414,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   572,  -330,   550,  1267,   573,
     455,   456,   457,   181,   458,  -330,  -330,  -330,  -330,  1253,
    -329,  1662,  1663,  1664,  1109,   574,   575,   576,   577,  -329,
    -329,  -329,  -329,  1253,   455,   456,   457,  1109,   458,  1060,
     957,   536,   537,   538,   539,   540,   583,  1662,  1663,  1664,
    1109,  1254,   983,   588,   588,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   927,  1254,   550,   413,   414,   594,
     442,   595,   596,   597,  1463,   366,   378,  1659,  1671,   437,
     454,   382,   572,   714,   367,  1130,   573,   618,   888,   832,
     383,   632,   572,   634,   983,   572,   573,  1248,   598,   573,
     413,   414,   574,   575,   576,   577,   993,    75,   650,  1938,
     536,   537,   538,   539,   540,   146,   661,   214,   215,   654,
    1255,  1894,  1250,   684,   541,   542,   543,   544,   545,   546,
     547,   548,   549,  1742,  1255,   550,   214,   215,   789,   564,
    1472,   241,  1100,   960,  1120,  1920,  1101,  1631,   153,   700,
     455,   456,   457,  1109,   458,   433,   393,   433,   212,   433,
     433,   800,   770,   801,   802,  1803,   805,   807,  1632,   809,
     810,   572,   812,   813,   814,   573,   582,   572,   572,  1889,
     735,   573,   573,   410,  1669,  1939,  1127,   154,   928,   929,
     930,  1455,   944,   572,   220,   984,  1267,   573,   754,  1572,
     940,  1933,  1256,  1257,  1258,  1259,  1260,  1261,  1262,   572,
    1670,   167,  1854,   573,   613,   967,  1256,  1257,  1258,  1259,
    1260,  1261,  1262,   640,  1263,  1473,  1608,  1264,   655,   574,
     575,   576,   577,   411,  1747,   572,  1743,   984,  1263,   573,
     938,  1264,  1930,   237,  1895,   771,   631,  1830,   994,   971,
     972,   893,  1251,  1529,   656,  1531,  1610,  1633,  1533,  1887,
    1536,  1538,   242,   578,   572,   229,  1921,   664,   573,  1636,
    1961,   221,  1849,  1850,   977,  1934,  1327,   536,   537,   538,
     539,   540,   230,  1131,   619,   222,  1007,   400,   958,  1511,
     740,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     572,   760,   550,   572,   573,   438,   651,   573,  1464,  1671,
    1950,   659,   823,   804,  1408,   833,   685,   772,   828,  1030,
     574,   575,   576,   577,   641,   678,   838,   839,   840,   841,
     842,  2030,   773,   400,   689,  1032,   692,  1033,  1376,  1377,
     168,  1137,   851,   698,   774,  1733,   701,   761,  1984,  1892,
    1985,   570,  1734,  1855,  1637,  1849,  1850,  1046,   213,   536,
     537,   538,   539,   540,  1441,   658,   816,   407,  1442,  1412,
     729,  1378,   731,   541,   542,   543,   544,   545,   546,   547,
     548,   549,  1449,  1575,   550,   429,  1450,  1106,  1267,   961,
     890,   430,  1665,   440,  1502,  1444,  1666,  1595,   857,  1602,
    1605,   429,   588,  1046,  1684,   209,  1866,   430,   895,  1686,
    1626,  1687,  1635,   579,  1689,   903,  1165,   408,   599,   860,
     861,   862,   863,   864,   865,   866,   867,   868,   869,   870,
     871,   872,   873,  1086,  2083,   846,   231,   401,  2086,   847,
    2078,   604,   232,  1638,  1639,  1640,   945,  1641,  1267,   889,
     579,  1851,   667,   945,   400,   459,  1856,   945,   584,  1458,
    -330,   668,   894,   572,  -330,  1369,  1948,   573,  1890,   985,
     884,   964,   965,   233,  -329,   635,   970,  1891,  -329,  1110,
     806,   931,   906,   574,   575,   576,   577,  1852,   986,  1119,
     988,  1330,  1665,   991,  1307,   412,   585,   586,  1308,  1980,
    1849,  1850,   368,   536,   537,   538,   539,   540,   384,   951,
     402,  1360,  1497,   690,   599,   234,  1057,   541,   542,   543,
     544,   545,   546,   547,   548,   549,  1022,   579,   550,   853,
    1575,   235,   854,   691,  1928,  1267,  1267,   579,  1517,   660,
     579,  1213,  1991,  1992,  1331,  1332,  1333,  1135,  1986,  1518,
    1987,  1642,  1040,   885,  1041,   460,   460,   536,   537,   538,
     539,   540,  1775,  1045,   467,   236,  1076,  1091,  1078,  1776,
    1929,   541,   542,   543,   544,   545,   546,   547,   548,   549,
     858,  1191,   550,   859,  1297,   536,   537,   538,   539,   540,
    1003,   240,   717,   886,  1446,   459,   371,  1942,  1447,   541,
     542,   543,   544,   545,   546,   547,   548,   549,  1777,   887,
     550,   536,   537,   538,   539,   540,   579,  1004,  1005,   372,
     572,  1203,   579,   579,   573,   541,   542,   543,   544,   545,
     546,   547,   548,   549,   939,  1968,   550,  1969,   579,  1085,
     574,   575,   576,   577,  2074,  2075,  2076,  2077,   136,   137,
     245,  1249,  1282,  1592,   579,  1283,  1481,  1593,  1285,   140,
    1643,   718,  1597,   959,   962,   374,  1598,   376,   536,   537,
     538,   539,   540,   973,   138,   975,   136,   137,  1140,  1959,
     579,  1267,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   719,   995,   550,   900,   901,   902,  1000,   403,  1002,
     720,  1006,   138,  1008,  1494,  1909,  1011,  1012,  1013,   579,
    1121,  1016,   404,   405,  1506,  1960,  1019,   381,  1771,  1020,
    1579,   572,   626,   952,  1772,   573,  1731,   953,  1102,   386,
    1103,   548,   549,  1029,  1095,   550,  1521,  1699,    76,   395,
    1253,   574,   575,   576,   577,   579,  1806,   370,   579,  1807,
     373,  1134,  1042,  1043,  1044,  1152,   396,  1798,  1700,   399,
    1046,   413,   414,   223,  1773,   214,   215,  1338,   400,    77,
    1343,   418,  1254,   572,   214,   215,   419,   573,    78,  1154,
    1155,    79,   224,   420,  1159,  1580,  1581,   140,   147,   148,
     151,   152,    80,   574,   575,   576,   577,   647,   648,   216,
     211,   421,   149,   150,   422,    81,   423,  1178,  1179,   424,
     217,  1181,  1090,  1183,  1184,    82,  1186,   425,   433,  1212,
    1190,    83,   434,   141,   388,   389,   674,   675,  1238,  1244,
     435,   142,   143,   144,   721,   722,   723,   724,   225,  1204,
    1274,  1255,  1582,   572,   443,  1215,   436,   573,  1583,   444,
     390,    84,   445,    85,    86,   536,   537,   538,   539,   540,
     562,    87,   446,   574,   575,   576,   577,   447,  2092,   541,
     542,   543,   544,   545,   546,   547,   548,   549,  1701,  1702,
     550,   908,   909,   910,   911,   912,   913,   914,   915,   448,
     916,   917,   918,   919,   920,   921,   682,   683,    88,    89,
     177,   566,   178,   179,   180,   181,   182,   183,   579,   226,
      90,   707,   708,  2109,   184,   185,   848,   186,   567,   187,
     413,   414,  1031,  1256,  1257,  1258,  1259,  1260,  1261,  1262,
     379,   380,   587,    91,   388,   389,    92,   536,   537,   538,
     539,   540,   591,  1046,   621,  1263,   880,   881,  1264,   896,
     897,   541,   542,   543,   544,   545,   546,   547,   548,   549,
    1096,  1812,   550,  1384,   898,   899,  1488,  1837,   629,   602,
    1147,   621,   605,  1395,   828,   592,  1400,  1265,  1301,  1302,
    1303,  1345,  1304,   874,  1305,  1813,  1164,  1166,  1049,  1050,
    1838,   607,  1839,  1316,  1172,   622,  1174,  1840,   608,  1318,
     413,   414,  1326,  1052,  1053,  1647,  1648,   188,   875,  1649,
    1650,  1651,  1841,   189,  1097,  1498,   876,   609,  1998,   615,
    1118,   877,   878,   879,   259,   623,   624,  2007,  2008,  2009,
     610,  1370,   177,  1371,   178,   179,   180,   181,   182,   183,
    1123,   881,  1099,   612,   341,   614,   184,   185,  1253,   186,
     615,   187,   623,   624,  1652,   617,  1842,   615,  1368,   633,
    1380,  1476,  1477,   625,   261,   579,  1406,   636,  1306,   642,
     536,   537,   538,   539,   540,  1410,  1478,  1479,   190,   191,
    1254,  1694,  1695,   637,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   638,   262,   550,  1834,  1835,   263,   264,
    1428,   639,   266,   267,  1963,  1964,   268,   572,  1975,  1976,
     269,   573,  1981,  1982,   643,   192,   193,   449,   450,   451,
     452,  1522,  1523,   835,   836,  1438,   169,   574,   575,   576,
     577,   743,   194,  1136,   644,   195,   645,   646,   649,   188,
     196,   652,  1415,   653,   657,   189,  1416,  1417,   270,  1255,
     666,   669,  1422,   271,   626,   177,   670,   178,   179,   180,
     181,   182,   183,  1621,   671,  1466,   579,   342,  1067,   184,
     185,  1309,   186,   672,   187,   673,  1344,   676,  1814,  1815,
     677,   626,   744,   745,  1068,  1266,   679,   680,   681,  1439,
     170,  1440,   171,   172,    93,   746,   747,   686,   748,   693,
    1483,  1484,   687,   696,  1486,   536,   537,   538,   539,   540,
     190,   191,  1491,   688,   694,  1492,   699,  1388,   579,   541,
     542,   543,   544,   545,   546,   547,   548,   549,   695,   702,
     550,  1256,  1257,  1258,  1259,  1260,  1261,  1262,  1379,  1381,
     704,   173,   174,   175,   176,  1389,   703,   192,   193,   449,
     450,   451,   452,  1263,   706,   709,  1264,   705,   710,   713,
     711,  1405,   188,   712,   194,   715,   716,   195,   189,   728,
    1409,   725,   196,   732,   727,   730,  1816,   733,   734,  1667,
    1817,  1069,   736,   737,   738,  1418,  1697,  1545,   579,   739,
     741,   343,   742,   751,  1508,   828,  1510,  1627,   753,  1627,
     755,   756,   757,   758,  1066,   759,   764,  1077,   765,  1079,
    1514,  1080,  1081,   766,  1082,  1083,  1084,   768,  1348,   818,
     769,  1525,   808,   811,   536,   537,   538,   539,   540,   819,
     827,  1568,   826,   190,   191,   831,   837,   834,   541,   542,
     543,   544,   545,   546,   547,   548,   549,   197,   843,   550,
     844,   852,  2038,   845,   198,  1818,  1349,   550,   882,   883,
     892,   177,   907,   178,   179,   180,   181,   182,   183,   933,
     192,   193,   934,  1819,   950,   184,   185,   936,   186,   963,
     187,   955,   968,  1820,   969,   974,   976,   194,  1122,  1498,
     195,   978,   979,   980,   981,   196,   987,   956,  1485,  1577,
    1578,  1925,  1422,  2063,  2064,  2065,  2066,  2067,   989,   177,
     990,   178,   179,   180,   181,   182,   183,   992,   996,   997,
     999,  1505,  1001,   184,   185,  1313,   186,  1253,   187,   998,
    1009,  1691,   536,   537,   538,   539,   540,   588,  1698,  1010,
    1014,  1015,   344,  1017,  1070,  1021,   541,   542,   543,   544,
     545,   546,   547,   548,   549,  1737,  1024,   550,  1025,  1254,
    1740,  1026,  1744,  1745,  1034,  1748,  1038,  1051,   188,  1054,
    1055,  1056,  1058,  1350,   189,  1351,  1059,  1352,  1353,   197,
    1062,  1354,  1063,  1064,  1087,  1216,   198,  1088,  1071,  1089,
    1094,  1217,  1093,  -329,  1395,  1092,  2093,  2094,  2095,  1113,
    1552,  1104,  1107,  1114,  1972,  1973,  1974,  1125,  1667,  2096,
    1667,  1072,  1133,  1144,  1116,  1126,   188,  1142,  1128,  1132,
    1498,  1145,   189,  1098,  1141,  1156,  1073,  1158,  1255,  1160,
    1157,  1176,  1845,  2104,  2105,  2106,  2107,  1161,  1162,   190,
     191,  1163,  1861,  1862,  1863,  1276,  1865,  1867,  1804,  1168,
    1218,  1878,   579,  1169,  1170,  1074,  1075,  1171,  1882,  1808,
    1809,  1810,  1811,  2068,  2069,  2070,  2071,  2072,  1173,  1280,
    1884,  1885,  1175,  1180,  1182,  1185,   192,   193,  1286,  1187,
    1288,  1188,  1189,  1192,  1193,  1194,  1195,   190,   191,  1907,
    1908,  1196,  1197,   194,  1198,  1910,   195,  1199,  1200,  1910,
    1201,   196,   197,  1919,  1202,  1281,  1923,  2079,  1205,   198,
    1256,  1257,  1258,  1259,  1260,  1261,  1262,  1230,  1943,  1246,
    1247,  1284,  1287,  1289,   192,   193,  1290,  1291,  1292,  1692,
    1293,  1294,  1263,  1295,  1296,  1264,  1956,  1299,  1300,  1317,
    1323,   194,  1706,  1966,   195,  1324,  1340,  1341,  1325,   196,
    1736,  1342,  1738,  1383,  1346,   588,   588,   588,  1108,  1347,
    1357,  1977,  1358,  1359,   536,   537,   538,   539,   540,  1767,
    1768,  1769,  1993,  1994,  1995,  1996,  1997,  1361,   541,   542,
     543,   544,   545,   546,   547,   548,   549,  1362,  2001,   550,
    2002,   177,   259,   178,   179,   180,   181,   182,   183,  1363,
    1364,  1365,  1366,  2005,  1367,   184,   185,  1372,   186,  1373,
     187,  2011,  1401,  1390,  1219,  2015,  1402,  1391,  2017,  1407,
    2019,  1413,  1414,  2021,  2022,  1421,  1427,  1608,  1429,  1609,
    1847,  1430,   261,  2031,  1431,  1858,  1220,  1860,  1221,  1432,
    1433,  1445,  1451,  1222,   792,  1223,  2034,  1452,  1454,  1224,
    1225,  2035,  2036,  2037,  1457,  1461,  1470,  1610,  1471,  1474,
     793,  2040,   262,  1467,  2041,  2042,   263,   264,  1475,  1148,
     266,   267,  1468,  1480,   268,  1507,  1897,  1124,   269,  1516,
    1524,  1469,  2052,  2053,  2054,  1515,  2055,  1520,  1519,  2056,
    1868,  1869,  1870,  1871,  1872,  1873,  1874,  1875,   188,  1487,
    1489,  1490,  1493,  1924,   189,  1926,  1495,  1528,   197,  -489,
    1532,  1534,  1544,  1539,  1540,   198,   270,  1546,  1548,  1587,
    1549,   271,  1550,  1554,  1560,  1570,  1226,   794,  1566,  1585,
    1588,  2046,  1590,  1591,  1596,  1599,  2084,  1606,  2085,  1600,
    2087,  1603,  2088,  1622,  1658,  1611,  1612,  2089,  1660,  1613,
    1614,  1676,  1677,  1678,  1679,  1615,   197,  1680,  1683,   795,
     796,  1685,  1688,   198,  1989,  1690,  1693,   797,  1696,   190,
     191,  1573,  1704,  1705,  1739,  1746,   177,  1999,   178,   179,
     180,   181,   182,   183,  1749,  1129,  1765,  1805,  1766,  1770,
     184,   185,  1530,   186,  1800,   187,  2003,  2004,  1801,  1822,
    2006,  1823,  1824,  1826,   798,  1827,   192,   193,  1825,  1149,
    1150,  1828,  1608,  1831,  1832,  1833,  1836,  1844,  2020,  1848,
    1859,  1846,  2024,   194,  2026,  1857,   195,  1864,  1876,  1877,
    1879,   196,  1880,  1888,  1881,  1896,  1883,  1898,  1899,  1900,
    2032,  2033,   799,  1901,   177,  1902,   178,   179,   180,   181,
     182,   183,  1904,  1906,  1914,  1501,  2039,   259,   184,   185,
    1535,   186,  2043,   187,  2044,  2045,  1918,  1922,  1927,  1936,
    1937,  1940,  1941,  1944,     4,  1958,  1945,  2051,  1946,  1962,
    1957,  1965,  1967,   188,  1970,  1978,   361,  2012,   177,   189,
     178,   179,   180,   181,   182,   183,  1971,   261,  2000,     5,
       6,  2014,   184,   185,  1537,   186,  1988,   187,  2016,     7,
    2018,   177,  2023,   178,   179,   180,   181,   182,   183,  2028,
    2082,  2047,  2048,  2049,  2058,   184,   185,   262,   186,  2057,
     187,   263,   264,  2050,  2060,   266,   267,  2061,  2062,   268,
    2073,  2081,  2097,   269,  2091,  2098,  2099,  2101,  2090,   630,
    2100,   188,  1616,   891,   190,   191,  2110,   189,   536,   537,
     538,   539,   540,  2103,     8,   752,   362,  1117,  1329,  1279,
    2108,  1278,   541,   542,   543,   544,   545,   546,   547,   548,
     549,   270,  2059,   550,   767,  1319,   271,  1456,  1139,   925,
    1802,   192,   193,  1951,  1949,   188,  1111,   453,  1584,  1112,
       9,   189,  1419,    10,  1298,    11,  1115,  1509,   194,  1607,
    1151,   195,    12,  1541,    13,  1336,   196,  1434,   188,    14,
      15,    16,   190,   191,   189,  1177,    17,    18,    19,  1551,
    1558,  1624,   536,   537,   538,   539,   540,  -484,   197,  2013,
    1893,  1912,  2025,  1916,  1252,   198,   541,   542,   543,   544,
     545,   546,   547,   548,   549,  1915,  2027,   550,     0,   192,
     193,     0,     0,     0,     0,     0,   190,   191,     0,     0,
       0,     0,     0,     0,     0,     0,   194,     0,     0,   195,
       0,     0,     0,     0,   196,     0,     0,     0,     0,   190,
     191,   536,   537,   538,   539,   540,     0,     0,     0,     0,
       0,     0,     0,   192,   193,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,     0,   550,     0,     0,     0,
     194,     0,     0,   195,     0,     0,   192,   193,   196,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   536,   537,
     538,   539,   540,   194,     0,     0,   195,     0,     0,     0,
       0,   196,   541,   542,   543,   544,   545,   546,   547,   548,
     549,     0,     0,   550,   536,   537,   538,   539,   540,    20,
       0,     0,     0,     0,     0,     0,     0,     0,   541,   542,
     543,   544,   545,   546,   547,   548,   549,     0,     0,   550,
     536,   537,   538,   539,   540,   551,   552,   553,   554,   555,
     556,   557,   558,   559,   541,   542,   543,   544,   545,   546,
     547,   548,   549,     0,     0,   550,     0,   536,   537,   538,
     539,   540,     0,   197,     0,     0,     0,     0,     0,     0,
     198,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,     0,   550,   536,   537,   538,   539,   540,     0,     0,
       0,   155,   156,     0,     0,     0,     0,   541,   542,   543,
     544,   545,   546,   547,   548,   549,     0,     0,   550,   157,
       0,     0,     0,     0,     0,   363,     0,     0,     0,     0,
       0,     0,     0,     0,   158,   536,   537,   538,   539,   540,
       0,   197,     0,   159,     0,   160,   161,     0,   198,   541,
     542,   543,   544,   545,   546,   547,   548,   549,     0,     0,
     550,   536,   537,   538,   539,   540,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,   197,   550,     0,   470,     0,
       0,     0,   198,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   536,   537,   538,   539,   540,     0,   197,     0,
       0,     0,   162,     0,     0,   198,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,     0,   550,   536,   537,
     538,   539,   540,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   541,   542,   543,   544,   545,   546,   547,   548,
     549,     0,     0,   550,     0,     0,     0,     0,     0,     0,
       0,  1435,     0,     0,     0,   471,   472,     0,     0,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   493,   494,   495,   496,   497,   498,   499,   500,     0,
       0,   163,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   536,   537,   538,   539,   540,     0,     0,     0,     0,
       0,     0,     0,   501,     0,   541,   542,   543,   544,   545,
     546,   547,   548,   549,     0,  1436,   550,     0,   536,   537,
     538,   539,   540,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   541,   542,   543,   544,   545,   546,   547,   548,
     549,     0,   502,   550,   536,   537,   538,   539,   540,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   541,   542,
     543,   544,   545,   546,   547,   548,   549,     0,     0,   550,
     164,     0,     0,     0,  1437,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   165,     0,     0,     0,     0,   166,
       0,     0,     0,     0,     0,     0,     0,   503,   504,     0,
     505,   506,   507,   508,   509,   510,   511,     0,   536,   537,
     538,   539,   540,     0,     0,     0,     0,     0,     0,     0,
       0,  1453,   541,   542,   543,   544,   545,   546,   547,   548,
     549,     0,     0,   550,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   470,     0,     0,  1526,   512,   513,
     514,   515,   516,   517,   518,   519,   520,     0,     0,     0,
       0,     0,   536,   537,   538,   539,   540,     0,     0,     0,
       0,     0,     0,  1527,   521,   522,   541,   542,   543,   544,
     545,   546,   547,   548,   549,     0,     0,   550,     0,   523,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1589,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     524,   525,   526,   527,     0,     0,     0,     0,     0,     0,
       0,   471,   472,     0,     0,     0,  1947,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   489,   490,   491,   492,   493,   494,   495,
     496,   497,   498,   499,   500,     0,  1779,   536,   537,   538,
     539,   540,     0,     0,     0,     0,     0,     0,  1952,     0,
       0,   541,   542,   543,   544,   545,   546,   547,   548,   549,
    1780,  1781,   550,   246,   259,     0,     0,     0,   247,     0,
     259,     0,     0,     0,  1953,   528,   529,     0,     0,     0,
       0,  1782,     0,     0,     0,     0,     0,     0,     0,   530,
     531,   259,     0,     0,     0,     0,     0,   259,   502,     0,
     532,     0,   321,     0,   261,     0,     0,     0,     0,     0,
     261,     0,   248,     0,     0,  1954,     0,   260,   349,   350,
     351,     0,   352,   353,     0,   354,     0,     0,     0,   355,
       0,   261,   356,  1608,   262,  1783,     0,   261,   263,   264,
     262,  1955,   266,   267,   263,   264,   268,  1231,   266,   267,
     269,     0,   268,     0,     0,   249,   269,     0,     0,     0,
       0,   262,  1784,  1610,     0,   263,   264,   262,     0,   266,
     267,   263,   264,   268,   265,   266,   267,   269,     0,   268,
       0,     0,     0,   269,     0,     0,     0,     0,   270,     0,
       0,     0,     0,   271,   270,     0,     0,     0,     0,   271,
       0,     0,     0,     0,   512,   513,   514,   515,   516,   517,
     518,   519,   520,     0,     0,   270,   259,     0,     0,     0,
     271,   270,  1512,     0,     0,     0,   271,     0,     0,     0,
     521,   522,     0,     0,     0,     0,  1232,     0,     0,     0,
       0,     0,     0,   259,     0,   523,   250,     0,   277,  1569,
    1785,     0,     0,  1786,  1787,     0,   261,     0,   278,     0,
       0,  1788,     0,   279,     0,     0,   524,   525,   526,   527,
       0,     0,     0,     0,     0,  1571,     0,   280,     0,     0,
       0,     0,     0,   261,     0,     0,   262,     0,     0,     0,
     263,   264,     0,  1240,   266,   267,     0,     0,   268,     0,
       0,  1750,   269,   259,     0,     0,     0,     0,     0,     0,
       0,  1789,     0,   262,     0,     0,     0,   263,   264,   281,
     282,   266,   267,     0,     0,   268,   283,     0,     0,   269,
       0,   251,     0,   284,     0,   252,   285,     0,   286,  1674,
     270,     0,     0,  1206,     0,   271,     0,     0,     0,     0,
       0,   528,   529,     0,     0,  1751,     0,     0,     0,     0,
       0,  1752,     0,     0,   322,   530,   531,   270,     0,   323,
     324,   325,   271,   262,     0,     0,   532,   263,   264,  1790,
       0,   266,   267,  1207,  1753,   268,   287,     0,   288,   269,
     253,     0,     0,  1675,   254,  1791,     0,   289,  -490,  -490,
    -490,     0,     0,   326,     0,     0,     0,     0,     0,     0,
     327,   259,  -490,  -490,  -490,  -490,  -490,   546,   547,   548,
     549,  1707,     0,   550,   255,     0,     0,   270,     0,  1754,
    1792,  1793,   271,  1794,  1795,   290,  1796,     0,   256,     0,
       0,     0,     0,   257,     0,     0,  1233,  1234,     0,     0,
    1235,   261,     0,   291,     0,  1236,     0,     0,  1797,     0,
     292,   293,     0,   294,   259,     0,     0,     0,   295,   296,
       0,   297,   298,     0,   299,     0,     0,   300,   301,     0,
       0,   262,   328,     0,     0,   263,   264,     0,  1237,   266,
     267,   302,   303,   268,  1608,  1755,   304,   269,   305,   306,
     947,   307,     0,     0,   261,     0,   308,     0,     0,   357,
     309,   310,   626,   311,   312,   272,   313,   314,   315,     0,
       0,     0,   316,     0,  1610,     0,     0,     0,     0,   776,
       0,     0,     0,     0,   262,   270,     0,  1708,   263,   264,
     271,  1272,   266,   267,   413,   414,   268,   536,   537,   538,
     269,  1709,     0,     0,     0,  1241,     0,     0,     0,     0,
       0,   541,   542,   543,   544,   545,   546,   547,   548,   549,
       0,   777,   550,     0,     0,     0,     0,     0,  1756,  1757,
       0,     0,     0,  1758,  1759,     0,  1760,     0,   270,     0,
       0,     0,     0,   271,  1761,  1762,     0,     0,     0,  1208,
    1209,  1210,     0,     0,     0,  1242,     0,   244,     0,     0,
       0,  1710,   778,     0,  1711,  1712,   258,     0,     0,     0,
       0,   275,  1713,   276,     0,   319,     0,   320,     0,   333,
       0,   338,     0,   339,  1243,   340,  1763,   348,     0,     0,
       0,     0,     0,     0,   779,     0,     0,     0,     0,     0,
       0,   780,   781,     0,     0,     0,     0,     0,     0,     0,
       0,   317,     0,     0,   782,     0,     0,     0,     0,     0,
       0,     0,  1714,     0,     0,  1715,     0,     0,  1716,     0,
       0,   783,   784,   785,   786,     0,   787,   788,     0,     0,
     908,   909,   910,   911,   912,   913,   914,   915,   334,   916,
     917,   918,   919,   920,   921,     0,     0,  1717,     0,  1718,
       0,  1719,  1720,  1721,  1722,  1723,  1724,     0,     0,     0,
       0,  1211,  1725,     0,     0,  1726,     0,     0,  1727,     0,
       0,     0,     0,     0,     0,   536,   537,   538,   539,   540,
    1728,     0,     0,     0,     0,     0,     0,     0,  1729,   541,
     542,   543,   544,   545,   546,   547,   548,   549,     0,     0,
     550,     0,     0,   535,     0,     0,   335,     0,   536,   537,
     538,   539,   540,     0,     0,     0,     0,     0,     0,     0,
       0,   626,   541,   542,   543,   544,   545,   546,   547,   548,
     549,     0,     0,   550,   908,   909,   910,   911,   912,   913,
     914,   915,     0,   916,   917,   918,   919,   920,   921,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1730,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   336,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1273,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1513
};

static const yytype_int16 yycheck[] =
{
      17,   198,   620,   230,   198,   322,   177,  1037,   167,   168,
     293,   294,  1037,    90,  1104,  1105,  1106,  1107,   117,   786,
     397,   426,   121,   428,   123,   430,   431,   165,     7,     7,
     129,    22,     7,    45,    30,   134,   135,    51,     6,   163,
      15,     7,    15,     7,    19,     7,     7,    15,    16,    17,
      18,    20,   934,  1576,    29,  1267,    15,   127,    18,    19,
      19,   120,    27,    28,    18,    19,    18,    19,    15,  1693,
      29,     3,    19,    15,    91,    17,    18,    19,    36,  1576,
     150,   188,     8,     9,    10,    11,    12,    45,    35,    36,
      37,    38,   127,     4,    18,    19,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    15,     6,    33,  1133,    19,
      15,    16,    17,    18,    19,    15,    16,    17,    18,    19,
       6,    15,    16,    17,    18,    35,    36,    37,    38,    15,
      16,    17,    18,    19,    15,    16,    17,    18,    19,   781,
      80,     8,     9,    10,    11,    12,   222,    15,    16,    17,
      18,    51,    42,   229,   230,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    42,    51,    33,    18,    19,    15,
     187,    17,    18,    19,    31,    36,   148,  1573,  1576,    28,
     197,    36,    15,   342,    45,    19,    19,   263,   565,    28,
      45,   268,    15,   270,    42,    15,    19,  1032,   140,    19,
      18,    19,    35,    36,    37,    38,   137,     0,   285,   362,
       8,     9,    10,    11,    12,     3,   292,    19,    20,   189,
     120,   282,   256,   122,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   268,   120,    33,    19,    20,   397,   211,
     247,    19,   461,    76,   886,   323,   465,   354,     3,   325,
      15,    16,    17,    18,    19,   426,   188,   428,   193,   430,
     431,   399,     3,   401,   402,  1661,   404,   405,   375,   407,
     408,    15,   410,   411,   412,    19,   221,    15,    15,   120,
     356,    19,    19,   146,  1807,   438,   904,   163,   166,   167,
     168,  1321,    36,    15,    68,   185,  1321,    19,   374,  1511,
     617,   371,   202,   203,   204,   205,   206,   207,   208,    15,
    1807,   163,   127,    19,   259,   329,   202,   203,   204,   205,
     206,   207,   208,   182,   224,   332,   139,   227,   298,    35,
      36,    37,    38,   196,   157,    15,   371,   185,   224,    19,
     464,   227,  1787,   145,   405,    86,   129,  1971,   279,   259,
     260,   578,   386,  1443,   324,  1445,   169,   464,  1448,   418,
    1450,  1451,   140,    69,    15,    50,   444,   185,    19,   182,
    1815,   145,   180,   181,   657,   445,  1143,     8,     9,    10,
      11,    12,    67,   217,   264,   159,   682,    19,   328,  1414,
     362,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      15,   130,    33,    15,    19,   254,   286,    19,   265,  1807,
    1806,   291,   429,    45,  1249,   254,   315,   158,   435,   715,
      35,    36,    37,    38,   283,   305,   443,   444,   445,   446,
     447,  1908,   173,    19,   314,   718,   316,   720,   354,   355,
     163,  1323,   459,   323,   185,   375,   326,   176,   140,   409,
     142,   463,   382,   268,   267,   180,   181,   740,    19,     8,
       9,    10,    11,    12,   461,    80,   462,   146,   465,   460,
     350,   387,   352,    22,    23,    24,    25,    26,    27,    28,
      29,    30,   461,  1513,    33,   460,   465,   465,  1513,   322,
     567,   466,   460,   466,   463,   461,   464,   461,   463,   461,
     461,   460,   578,   786,  1594,   463,   157,   466,   584,  1599,
     464,  1601,   464,   460,  1604,   591,   463,   196,   460,   536,
     537,   538,   539,   540,   541,   542,   543,   544,   545,   546,
     547,   548,   549,   816,  2011,   461,    81,   123,  2015,   465,
     464,   237,    19,   356,   357,   358,   622,   360,  1573,   566,
     460,   359,   273,   629,    19,   460,   371,   633,    20,  1326,
     460,   282,   579,    15,   464,  1207,   460,    19,   409,   459,
       3,   647,   648,   117,   460,   271,   652,   418,   464,   460,
      45,   459,   599,    35,    36,    37,    38,   395,   664,   885,
     666,    81,   460,   669,   461,   458,    58,    59,   465,  1839,
     180,   181,   463,     8,     9,    10,    11,    12,   463,   626,
     196,   459,   463,   266,   460,    19,   775,    22,    23,    24,
      25,    26,    27,    28,    29,    30,   702,   460,    33,   465,
    1660,    86,   468,   286,   359,  1660,  1661,   460,    22,   459,
     460,  1018,   379,   380,   134,   135,   136,   930,   140,    33,
     142,   464,   728,    86,   730,   852,   853,     8,     9,    10,
      11,    12,   418,   739,   858,   165,   804,   465,   806,   425,
     395,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     465,   998,    33,   468,  1089,     8,     9,    10,    11,    12,
     279,    19,   207,   126,   461,   460,     3,   377,   465,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   464,   142,
      33,     8,     9,    10,    11,    12,   460,   306,   307,     3,
      15,   459,   460,   460,    19,    22,    23,    24,    25,    26,
      27,    28,    29,    30,   614,  1825,    33,  1827,   460,   815,
      35,    36,    37,    38,  1984,  1985,  1986,  1987,    19,    20,
     463,  1034,  1069,   461,   460,  1072,  1374,   465,  1075,    20,
    1559,   276,   461,   643,   644,    67,   465,    20,     8,     9,
      10,    11,    12,   653,    45,   655,    19,    20,   937,   359,
     460,  1806,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   306,   672,    33,    39,    40,    41,   677,   384,   679,
     315,   681,    45,   683,  1393,   417,   686,   687,   688,   460,
     887,   691,   398,   399,  1403,   395,   696,     3,   418,   699,
     126,    15,   255,   629,   424,    19,  1625,   633,   845,    86,
     847,    29,    30,   713,   465,    33,  1425,   127,     3,     3,
      19,    35,    36,    37,    38,   460,   462,   141,   460,   465,
     144,   927,   732,   733,   734,   954,     3,  1656,   148,   270,
    1143,    18,    19,    43,   464,    19,    20,  1150,    19,    34,
     322,     3,    51,    15,    19,    20,     3,    19,    43,   955,
     956,    46,    62,     3,   960,   191,   192,    20,     7,     8,
       9,    10,    57,    35,    36,    37,    38,   286,   287,    44,
      19,     3,   173,   174,     3,    70,     3,   983,   984,     3,
      55,   987,   461,   989,   990,    80,   992,     3,  1089,  1018,
     996,    86,    30,    56,    19,    20,   296,   297,  1027,  1028,
     460,    64,    65,    66,   449,   450,   451,   452,   118,  1015,
    1039,   120,   248,    15,   460,  1021,   254,    19,   254,   460,
      45,   116,   460,   118,   119,     8,     9,    10,    11,    12,
      15,   126,   460,    35,    36,    37,    38,   460,  2058,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   268,   269,
      33,   209,   210,   211,   212,   213,   214,   215,   216,   460,
     218,   219,   220,   221,   222,   223,    86,    87,   163,   164,
      13,    22,    15,    16,    17,    18,    19,    20,   460,   189,
     175,   402,   403,  2103,    27,    28,    29,    30,    63,    32,
      18,    19,    20,   202,   203,   204,   205,   206,   207,   208,
     149,   150,   459,   198,    19,    20,   201,     8,     9,    10,
      11,    12,   182,  1326,    45,   224,   464,   465,   227,    60,
      61,    22,    23,    24,    25,    26,    27,    28,    29,    30,
     465,    42,    33,  1222,    60,    61,  1383,   117,    69,    19,
     950,    45,   459,  1232,  1091,   171,  1235,   256,  1095,  1096,
    1097,  1157,  1099,   211,  1101,    66,   966,   967,   464,   465,
     140,   140,   142,  1110,   974,    69,   976,   147,    19,  1116,
      18,    19,    20,   464,   465,   415,   416,   120,   236,   419,
     420,   421,   162,   126,   465,  1398,   244,   463,   260,    19,
      20,   249,   250,   251,    46,   126,   127,   428,   429,   430,
     463,  1208,    13,  1209,    15,    16,    17,    18,    19,    20,
     464,   465,   465,   463,    66,   323,    27,    28,    19,    30,
      19,    32,   126,   127,   464,   117,   206,    19,    20,    69,
     354,   338,   339,   137,    86,   460,  1242,   459,   465,   327,
       8,     9,    10,    11,    12,  1251,   464,   465,   191,   192,
      51,   259,   260,   459,    22,    23,    24,    25,    26,    27,
      28,    29,    30,   463,   116,    33,   150,   151,   120,   121,
    1276,   463,   124,   125,   455,   456,   128,    15,   150,   151,
     132,    19,   148,   149,   323,   228,   229,   230,   231,   232,
     233,  1431,  1432,   439,   440,   465,    79,    35,    36,    37,
      38,    79,   245,   461,    81,   248,   459,    20,   284,   120,
     253,    69,  1259,    85,   168,   126,  1263,  1264,   170,   120,
      76,    76,  1269,   175,   255,    13,   271,    15,    16,    17,
      18,    19,    20,  1546,   278,  1341,   460,   189,     3,    27,
      28,    29,    30,    87,    32,   282,  1156,   296,   259,   260,
     300,   255,   130,   131,    19,   464,   303,   305,   310,  1306,
     143,  1308,   145,   146,   459,   143,   144,    87,   146,   459,
    1376,  1377,   318,   383,  1380,     8,     9,    10,    11,    12,
     191,   192,  1388,   316,   463,  1391,   116,   389,   460,    22,
      23,    24,    25,    26,    27,    28,    29,    30,   463,   117,
      33,   202,   203,   204,   205,   206,   207,   208,  1218,  1219,
     463,   194,   195,   196,   197,  1225,   459,   228,   229,   230,
     231,   232,   233,   224,    86,   459,   227,   463,   463,   323,
     463,  1241,   120,   463,   245,    86,   459,   248,   126,    86,
    1250,   463,   253,    79,   463,    76,   357,    81,    85,  1576,
     361,   116,   459,   459,   459,  1265,  1613,  1464,   460,    76,
     459,   313,   459,     3,  1411,  1412,  1413,  1556,     3,  1558,
       3,     3,     3,     3,   802,     3,     3,   805,    19,   807,
     463,   809,   810,     3,   812,   813,   814,     3,   174,   183,
       3,  1438,     3,     3,     8,     9,    10,    11,    12,   183,
      15,  1507,    14,   191,   192,    27,    30,    28,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   460,    19,    33,
      15,     7,   260,   465,   467,   436,   212,    33,     3,     3,
     459,    13,   459,    15,    16,    17,    18,    19,    20,   459,
     228,   229,   460,   454,   138,    27,    28,    19,    30,   459,
      32,    76,   459,   464,   459,   308,   176,   245,   459,  1772,
     248,   459,   459,   459,    31,   253,   185,    76,  1378,  1516,
    1517,  1784,  1519,   150,   151,   152,   153,   154,    76,    13,
      76,    15,    16,    17,    18,    19,    20,    76,    76,   459,
     459,  1401,   459,    27,    28,    29,    30,    19,    32,   117,
     459,  1608,     8,     9,    10,    11,    12,  1613,  1614,   459,
     459,   185,   464,   459,   279,    69,    22,    23,    24,    25,
      26,    27,    28,    29,    30,  1631,    19,    33,   459,    51,
    1636,   459,  1638,  1639,   276,  1641,   459,     3,   120,     3,
      19,    15,    19,   329,   126,   331,    19,   333,   334,   460,
      19,   337,     3,    20,    15,   123,   467,    15,   323,    15,
      28,   129,   254,   464,  1753,   461,  2060,  2061,  2062,    15,
    1480,   465,   465,    18,  1831,  1832,  1833,    20,  1805,  2073,
    1807,   346,   463,   465,   460,   459,   120,    28,   459,   459,
    1903,   133,   126,   461,   459,    81,   361,   459,   120,   459,
      76,    19,  1708,  2097,  2098,  2099,  2100,   459,   459,   191,
     192,   459,  1718,  1719,  1720,    69,  1722,  1723,  1665,   459,
     188,  1727,   460,   459,   459,   390,   391,   459,  1734,  1676,
    1677,  1678,  1679,   150,   151,   152,   153,   154,   459,     3,
    1746,  1747,   459,   459,   459,   459,   228,   229,  1076,   459,
    1078,   459,   459,   459,   459,   459,   459,   191,   192,  1765,
    1766,   459,   459,   245,   459,  1771,   248,   459,   459,  1775,
     459,   253,   460,  1779,   459,     3,  1782,  1990,   459,   467,
     202,   203,   204,   205,   206,   207,   208,   459,  1794,   459,
     459,    15,     3,     3,   228,   229,     3,     3,     3,  1609,
       3,     3,   224,   185,   185,   227,  1812,    28,    28,   465,
     459,   245,  1622,  1819,   248,   461,   459,   465,   183,   253,
    1630,   459,  1632,   323,   459,  1831,  1832,  1833,   461,   459,
     459,  1837,   459,   459,     8,     9,    10,    11,    12,  1649,
    1650,  1651,  1848,  1849,  1850,  1851,  1852,   459,    22,    23,
      24,    25,    26,    27,    28,    29,    30,   459,  1864,    33,
    1866,    13,    46,    15,    16,    17,    18,    19,    20,   459,
     459,   459,   459,  1879,   459,    27,    28,   191,    30,   459,
      32,  1887,    79,   459,   352,  1891,   459,   392,  1894,   459,
    1896,    22,   460,  1899,  1900,   459,   459,   139,     3,   141,
    1710,     3,    86,  1909,    15,  1715,   374,  1717,   376,    15,
      28,   465,   465,   381,     3,   383,  1922,    15,   464,   387,
     388,  1927,  1928,  1929,    15,   463,   340,   169,    69,   336,
      19,  1937,   116,   459,  1940,  1941,   120,   121,   335,   123,
     124,   125,   459,   280,   128,    69,  1756,   461,   132,    22,
      28,   459,  1958,  1959,  1960,   459,  1962,   459,   465,  1965,
     362,   363,   364,   365,   366,   367,   368,   369,   120,   463,
     463,   463,   463,  1783,   126,  1785,   463,    29,   460,   461,
      29,     7,    19,   464,   185,   467,   170,   266,   459,     3,
     194,   175,   330,   463,   463,   461,   464,    86,   463,   463,
       3,  1948,   461,   461,   461,   460,  2012,    15,  2014,   461,
    2016,   461,  2018,   263,   461,   257,   258,  2023,   226,   261,
     262,   460,   460,   460,   460,   267,   460,   459,    29,   118,
     119,    29,     7,   467,  1844,   459,   463,   126,   260,   191,
     192,   463,   463,   459,   459,   282,    13,  1857,    15,    16,
      17,    18,    19,    20,   459,   461,   418,     7,   418,   459,
      27,    28,    29,    30,   459,    32,  1876,  1877,   464,   461,
    1880,   461,   461,   461,   163,   460,   228,   229,   465,   263,
     264,   461,   139,   261,   261,   261,   148,   323,  1898,   378,
     396,   463,  1902,   245,  1904,   318,   248,   282,   394,   364,
     386,   253,   362,   405,   459,   410,   459,   408,    76,   413,
    1920,  1921,   201,   278,    13,   266,    15,    16,    17,    18,
      19,    20,   266,   459,   459,    20,  1936,    46,    27,    28,
      29,    30,  1942,    32,  1944,  1945,   459,    76,   378,   318,
     386,    76,    76,   441,    46,   378,   443,  1957,   459,   261,
     323,   261,   459,   120,   464,    20,    75,   261,    13,   126,
      15,    16,    17,    18,    19,    20,   459,    86,   397,    71,
      72,    76,    27,    28,    29,    30,   464,    32,    76,    81,
     261,    13,    69,    15,    16,    17,    18,    19,    20,   427,
    2000,   459,   459,   459,   465,    27,    28,   116,    30,   461,
      32,   120,   121,   459,   459,   124,   125,   459,   459,   128,
     459,   377,   459,   132,   377,   459,   459,   372,  2028,   267,
     459,   120,   464,   570,   191,   192,   461,   126,     8,     9,
      10,    11,    12,   465,   136,   370,   155,   881,  1144,  1053,
     459,  1050,    22,    23,    24,    25,    26,    27,    28,    29,
      30,   170,  1971,    33,   390,  1132,   175,  1323,   935,   601,
    1660,   228,   229,  1807,  1805,   120,   852,   197,  1519,   853,
     172,   126,  1267,   175,  1091,   177,   858,  1412,   245,  1541,
     464,   248,   184,  1460,   186,  1149,   253,   461,   120,   191,
     192,   193,   191,   192,   126,   982,   198,   199,   200,  1479,
    1490,  1553,     8,     9,    10,    11,    12,   459,   460,  1889,
    1753,  1772,  1903,  1776,  1036,   467,    22,    23,    24,    25,
      26,    27,    28,    29,    30,  1775,  1905,    33,    -1,   228,
     229,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   245,    -1,    -1,   248,
      -1,    -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,   191,
     192,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   228,   229,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    33,    -1,    -1,    -1,
     245,    -1,    -1,   248,    -1,    -1,   228,   229,   253,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,     9,
      10,    11,    12,   245,    -1,    -1,   248,    -1,    -1,    -1,
      -1,   253,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,     8,     9,    10,    11,    12,   341,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
       8,     9,    10,    11,    12,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    -1,    33,    -1,     8,     9,    10,
      11,    12,    -1,   460,    -1,    -1,    -1,    -1,    -1,    -1,
     467,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    -1,    33,     8,     9,    10,    11,    12,    -1,    -1,
      -1,   145,   146,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    -1,    33,   163,
      -1,    -1,    -1,    -1,    -1,   464,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   178,     8,     9,    10,    11,    12,
      -1,   460,    -1,   187,    -1,   189,   190,    -1,   467,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,   460,    33,    -1,     5,    -1,
      -1,    -1,   467,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     8,     9,    10,    11,    12,    -1,   460,    -1,
      -1,    -1,   256,    -1,    -1,   467,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   461,    -1,    -1,    -1,    82,    83,    -1,    -1,    -1,
      -1,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,    -1,
      -1,   345,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   140,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,   461,    33,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,   179,    33,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    -1,    33,
     434,    -1,    -1,    -1,   461,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   448,    -1,    -1,    -1,    -1,   453,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   234,   235,    -1,
     237,   238,   239,   240,   241,   242,   243,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   461,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     5,    -1,    -1,   461,   285,   286,
     287,   288,   289,   290,   291,   292,   293,    -1,    -1,    -1,
      -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,   461,   311,   312,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    -1,    33,    -1,   326,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     461,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     347,   348,   349,   350,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    82,    83,    -1,    -1,    -1,   461,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,    -1,    42,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,   461,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      66,    67,    33,    73,    46,    -1,    -1,    -1,    78,    -1,
      46,    -1,    -1,    -1,   461,   432,   433,    -1,    -1,    -1,
      -1,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   446,
     447,    46,    -1,    -1,    -1,    -1,    -1,    46,   179,    -1,
     457,    -1,    84,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      86,    -1,   122,    -1,    -1,   461,    -1,    66,    73,    74,
      75,    -1,    77,    78,    -1,    80,    -1,    -1,    -1,    84,
      -1,    86,    87,   139,   116,   141,    -1,    86,   120,   121,
     116,   461,   124,   125,   120,   121,   128,   123,   124,   125,
     132,    -1,   128,    -1,    -1,   165,   132,    -1,    -1,    -1,
      -1,   116,   168,   169,    -1,   120,   121,   116,    -1,   124,
     125,   120,   121,   128,   123,   124,   125,   132,    -1,   128,
      -1,    -1,    -1,   132,    -1,    -1,    -1,    -1,   170,    -1,
      -1,    -1,    -1,   175,   170,    -1,    -1,    -1,    -1,   175,
      -1,    -1,    -1,    -1,   285,   286,   287,   288,   289,   290,
     291,   292,   293,    -1,    -1,   170,    46,    -1,    -1,    -1,
     175,   170,   459,    -1,    -1,    -1,   175,    -1,    -1,    -1,
     311,   312,    -1,    -1,    -1,    -1,   212,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    -1,   326,   256,    -1,    51,   459,
     256,    -1,    -1,   259,   260,    -1,    86,    -1,    61,    -1,
      -1,   267,    -1,    66,    -1,    -1,   347,   348,   349,   350,
      -1,    -1,    -1,    -1,    -1,   459,    -1,    80,    -1,    -1,
      -1,    -1,    -1,    86,    -1,    -1,   116,    -1,    -1,    -1,
     120,   121,    -1,   123,   124,   125,    -1,    -1,   128,    -1,
      -1,   129,   132,    46,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   317,    -1,   116,    -1,    -1,    -1,   120,   121,   122,
     123,   124,   125,    -1,    -1,   128,   129,    -1,    -1,   132,
      -1,   341,    -1,   136,    -1,   345,   139,    -1,   141,   459,
     170,    -1,    -1,    86,    -1,   175,    -1,    -1,    -1,    -1,
      -1,   432,   433,    -1,    -1,   183,    -1,    -1,    -1,    -1,
      -1,   189,    -1,    -1,   346,   446,   447,   170,    -1,   351,
     352,   353,   175,   116,    -1,    -1,   457,   120,   121,   385,
      -1,   124,   125,   126,   212,   128,   189,    -1,   191,   132,
     400,    -1,    -1,   459,   404,   401,    -1,   200,     8,     9,
      10,    -1,    -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,
     392,    46,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    66,    -1,    33,   434,    -1,    -1,   170,    -1,   257,
     436,   437,   175,   439,   440,   238,   442,    -1,   448,    -1,
      -1,    -1,    -1,   453,    -1,    -1,   422,   423,    -1,    -1,
     426,    86,    -1,   256,    -1,   431,    -1,    -1,   464,    -1,
     263,   264,    -1,   266,    46,    -1,    -1,    -1,   271,   272,
      -1,   274,   275,    -1,   277,    -1,    -1,   280,   281,    -1,
      -1,   116,   464,    -1,    -1,   120,   121,    -1,   464,   124,
     125,   294,   295,   128,   139,   323,   299,   132,   301,   302,
      19,   304,    -1,    -1,    86,    -1,   309,    -1,    -1,   464,
     313,   314,   255,   316,   317,   464,   319,   320,   321,    -1,
      -1,    -1,   325,    -1,   169,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,   116,   170,    -1,   182,   120,   121,
     175,   123,   124,   125,    18,    19,   128,     8,     9,    10,
     132,   196,    -1,    -1,    -1,   385,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    45,    33,    -1,    -1,    -1,    -1,    -1,   406,   407,
      -1,    -1,    -1,   411,   412,    -1,   414,    -1,   170,    -1,
      -1,    -1,    -1,   175,   422,   423,    -1,    -1,    -1,   342,
     343,   344,    -1,    -1,    -1,   435,    -1,   100,    -1,    -1,
      -1,   256,    86,    -1,   259,   260,   109,    -1,    -1,    -1,
      -1,   114,   267,   116,    -1,   118,    -1,   120,    -1,   122,
      -1,   124,    -1,   126,   464,   128,   464,   130,    -1,    -1,
      -1,    -1,    -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,
      -1,   125,   126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   464,    -1,    -1,   138,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   317,    -1,    -1,   320,    -1,    -1,   323,    -1,
      -1,   155,   156,   157,   158,    -1,   160,   161,    -1,    -1,
     209,   210,   211,   212,   213,   214,   215,   216,   333,   218,
     219,   220,   221,   222,   223,    -1,    -1,   352,    -1,   354,
      -1,   356,   357,   358,   359,   360,   361,    -1,    -1,    -1,
      -1,   464,   367,    -1,    -1,   370,    -1,    -1,   373,    -1,
      -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,    12,
     385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   393,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    -1,
      33,    -1,    -1,     3,    -1,    -1,   401,    -1,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   255,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    -1,    33,   209,   210,   211,   212,   213,   214,
     215,   216,    -1,   218,   219,   220,   221,   222,   223,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   464,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   464,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   464,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   225
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   470,   471,    46,    71,    72,    81,   136,   172,
     175,   177,   184,   186,   191,   192,   193,   198,   199,   200,
     341,   496,   497,   498,   499,   500,   501,   554,   555,   556,
     557,   559,   560,   561,   564,   567,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   585,
     586,   587,   588,   589,   590,   591,   592,   593,   662,   673,
     707,   708,   709,   710,   711,   712,   713,   714,   764,   765,
     775,   786,   787,   788,   790,     0,     3,    34,    43,    46,
      57,    70,    80,    86,   116,   118,   119,   126,   163,   164,
     175,   198,   201,   459,   472,   485,   491,   494,   495,   504,
     507,   510,   512,   515,   517,   518,   520,   521,   528,   538,
     539,   596,   598,   608,   646,   649,   663,   668,   669,   672,
     675,   676,   716,   717,   718,   723,   753,   756,   766,   767,
     776,   779,   789,   791,   792,   793,    19,    20,    45,   594,
      20,    56,    64,    65,    66,   502,     3,   594,   594,   173,
     174,   594,   594,     3,   163,   145,   146,   163,   178,   187,
     189,   190,   256,   345,   434,   448,   453,   163,   163,    79,
     143,   145,   146,   194,   195,   196,   197,    13,    15,    16,
      17,    18,    19,    20,    27,    28,    30,    32,   120,   126,
     191,   192,   228,   229,   245,   248,   253,   460,   467,   613,
     625,   630,   633,   634,   635,   637,   639,    36,    45,   463,
     583,   594,   193,    19,    19,    20,    44,    55,   482,   487,
      68,   145,   159,    43,    62,   118,   189,   492,   493,    50,
      67,    81,    19,   117,    19,    86,   165,   145,   482,   639,
      19,    19,   140,   522,   522,   463,    73,    78,   122,   165,
     256,   341,   345,   400,   404,   434,   448,   453,   522,    46,
      66,    86,   116,   120,   121,   123,   124,   125,   128,   132,
     170,   175,   464,   523,   541,   522,   522,    51,    61,    66,
      80,   122,   123,   129,   136,   139,   141,   189,   191,   200,
     238,   256,   263,   264,   266,   271,   272,   274,   275,   277,
     280,   281,   294,   295,   299,   301,   302,   304,   309,   313,
     314,   316,   317,   319,   320,   321,   325,   464,   523,   522,
     522,    84,   346,   351,   352,   353,   385,   392,   464,   523,
     677,   678,   679,   522,   333,   401,   464,   523,   522,   522,
     522,    66,   189,   313,   464,   523,   768,   771,   522,    73,
      74,    75,    77,    78,    80,    84,    87,   464,   506,   509,
     523,    75,   155,   464,   508,   523,    36,    45,   463,   542,
     502,     3,     3,   502,    67,   503,    20,   484,   484,   594,
     594,     3,    36,    45,   463,   545,    86,   569,    19,    20,
      45,   595,     3,   188,   565,     3,     3,   562,   568,   270,
      19,   123,   196,   384,   398,   399,   558,   146,   196,   558,
     146,   196,   458,    18,    19,   476,   478,   478,     3,     3,
       3,     3,     3,     3,     3,     3,    15,    19,    29,   460,
     466,   629,   631,   637,    30,   460,   254,    28,   254,    15,
     466,   632,   639,   460,   460,   460,   460,   460,   460,   230,
     231,   232,   233,   618,   639,    15,    16,    17,    19,   460,
     613,   614,   617,   619,   620,   621,   623,   625,   626,   627,
       5,    82,    83,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   140,   179,   234,   235,   237,   238,   239,   240,   241,
     242,   243,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   311,   312,   326,   347,   348,   349,   350,   432,   433,
     446,   447,   457,   638,   794,     3,     8,     9,    10,    11,
      12,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      33,    46,    47,    48,    49,    50,    51,    52,    53,    54,
     489,   490,    15,   584,   484,   674,    22,    63,   486,    45,
     463,   488,    15,    19,    35,    36,    37,    38,    69,   460,
     473,   475,   542,   473,    20,    58,    59,   459,   473,   474,
     474,   182,   171,   516,    15,    17,    18,    19,   140,   460,
     511,   597,    19,   513,   545,   459,   609,   140,    19,   463,
     463,   519,   463,   542,   323,    19,   527,   117,   473,   475,
     540,    45,    69,   126,   127,   137,   255,   524,   605,    69,
     524,   129,   482,    69,   482,   545,   459,   459,   463,   463,
     182,   283,   327,   323,    81,   459,    20,   286,   287,   284,
     482,   475,    69,    85,   189,   298,   324,   168,    80,   475,
     459,   473,   476,   664,   185,   476,    76,   273,   282,    76,
     271,   278,    87,   282,   296,   297,   296,   300,   475,   303,
     305,   310,    86,    87,   122,   315,    87,   318,   316,   475,
     266,   286,   475,   459,   463,   463,   383,   511,   475,   116,
     473,   475,   117,   459,   463,   463,    86,   402,   403,   459,
     463,   463,   463,   323,   478,    86,   459,   207,   276,   306,
     315,   449,   450,   451,   452,   463,   774,   463,    86,   475,
      76,   475,    79,    81,    85,   473,   459,   459,   459,    76,
     484,   459,   459,    79,   130,   131,   143,   144,   146,   543,
     544,     3,   503,     3,   473,     3,     3,     3,     3,     3,
     130,   176,   546,   547,     3,    19,     3,   595,     3,     3,
       3,    86,   158,   173,   185,   566,     3,    45,    86,   118,
     125,   126,   138,   155,   156,   157,   158,   160,   161,   478,
     563,   605,     3,    19,    86,   118,   119,   126,   163,   201,
     558,   558,   558,   715,    45,   558,    45,   558,     3,   558,
     558,     3,   558,   558,   558,    30,   462,   480,   183,   183,
       7,   631,   631,   639,   631,   631,    14,    15,   639,   643,
     644,    27,    28,   254,    28,   632,   632,    30,   639,   639,
     639,   639,   639,    19,    15,   465,   461,   465,    29,   616,
     618,   639,     7,   465,   468,    27,    28,   463,   465,   468,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   211,   236,   244,   249,   250,   251,
     464,   465,     3,     3,     3,    86,   126,   142,   605,   639,
     482,   489,   459,   474,   639,   473,    60,    61,    60,    61,
      39,    40,    41,   473,   535,   536,   639,   459,   209,   210,
     211,   212,   213,   214,   215,   216,   218,   219,   220,   221,
     222,   223,   599,   600,   601,   603,   607,    42,   166,   167,
     168,   459,   514,   459,   460,   606,    19,   163,   464,   475,
     511,   529,   532,   533,    36,   473,   526,    19,   603,   604,
     138,   639,   526,   526,   648,    76,    76,    80,   328,   475,
      76,   322,   475,   459,   473,   473,    51,   329,   459,   459,
     473,   259,   260,   475,   308,   475,   176,   476,   459,   459,
     459,    31,   477,    42,   185,   459,   473,   185,   473,    76,
      76,   473,    76,   137,   279,   475,    76,   459,   117,   459,
     475,   459,   475,   279,   306,   307,   475,   527,   475,   459,
     459,   475,   475,   475,   459,   185,   475,   459,   671,   475,
     475,    69,   473,   680,    19,   459,   459,   722,   755,   475,
     527,    20,   476,   476,   276,   769,   770,   773,   459,   778,
     473,   473,   475,   475,   475,   473,   476,   478,   479,   464,
     465,     3,   464,   465,     3,    19,    15,   478,    19,    19,
     604,   479,    19,     3,    20,   483,   483,     3,    19,   116,
     279,   323,   346,   361,   390,   391,   558,   483,   558,   483,
     483,   483,   483,   483,   483,   473,   476,    15,    15,    15,
     461,   465,   461,   254,    28,   465,   465,   465,   461,   465,
     461,   465,   639,   639,   465,     7,   465,   465,   461,    18,
     460,   614,   621,    15,    18,   626,   460,   490,    20,   527,
     604,   482,   459,   464,   461,    20,   459,   533,   459,   461,
      19,   217,   459,   463,   473,   476,   461,   600,   602,   607,
     478,   459,    28,   531,   465,   133,   525,   475,   123,   263,
     264,   464,   523,   647,   473,   473,    81,    76,   459,   473,
     459,   459,   459,   459,   475,   463,   475,   665,   459,   459,
     459,   459,   475,   459,   475,   459,    19,   664,   473,   473,
     459,   473,   459,   473,   473,   459,   473,   459,   459,   459,
     473,   511,   459,   459,   459,   459,   459,   459,   459,   459,
     459,   459,   459,   459,   473,   459,    86,   126,   342,   343,
     344,   464,   523,   605,   670,   473,   123,   129,   188,   352,
     374,   376,   381,   383,   387,   388,   464,   681,   688,   691,
     459,   123,   212,   422,   423,   426,   431,   464,   523,   719,
     123,   385,   435,   464,   523,   754,   459,   459,   477,   476,
     256,   386,   769,    19,    51,   120,   202,   203,   204,   205,
     206,   207,   208,   224,   227,   256,   464,   635,   636,   640,
     645,   772,   123,   464,   523,   777,    69,   505,   544,   547,
       3,     3,   511,   511,    15,   511,   483,     3,   483,     3,
       3,     3,     3,     3,     3,   185,   185,   631,   643,    28,
      28,   639,   639,   639,   639,   639,   465,   461,   465,    29,
     616,   639,   616,    29,   616,   616,   639,   465,   639,   601,
     610,   611,   645,   459,   461,   183,    20,   479,   530,   532,
      81,   134,   135,   136,   650,   656,   650,   657,   476,   661,
     459,   465,   459,   322,   475,   473,   459,   459,   174,   212,
     329,   331,   333,   334,   337,   666,   667,   459,   459,   459,
     459,   459,   459,   459,   459,   459,   459,   459,    20,   604,
     482,   473,   191,   459,   700,   706,   354,   355,   387,   475,
     354,   475,   682,   323,   478,   684,   685,   683,   389,   475,
     459,   392,   701,   724,   732,   478,   733,   738,   720,   721,
     478,    79,   459,   757,   763,   475,   473,   459,   477,   475,
     473,    22,   460,    22,   460,   639,   639,   639,   475,   638,
     794,   459,   639,   641,   642,   780,   785,   459,   473,     3,
       3,    15,    15,    28,   461,   461,   461,   461,   465,   639,
     639,   461,   465,     7,   461,   465,   461,   465,     7,   461,
     465,   465,    15,   461,   464,   645,   602,    15,   479,   533,
     534,   463,   655,    31,   265,   658,   473,   459,   459,   459,
     340,    69,   247,   332,   336,   335,   338,   339,   464,   465,
     280,   533,   702,   473,   473,   475,   473,   463,   511,   463,
     463,   473,   473,   463,   534,   463,   737,   463,   476,   739,
     744,    20,   463,   745,   750,   475,   534,    69,   639,   644,
     639,   635,   459,   225,   463,   459,    22,    22,    33,   465,
     459,   534,   569,   569,    28,   639,   461,   461,    29,   616,
      29,   616,    29,   616,     7,    29,   616,    29,   616,   464,
     185,   655,   654,   651,    19,   482,   266,   659,   459,   194,
     330,   667,   475,   703,   463,   705,   693,   686,   693,   689,
     463,   731,   736,   735,   740,   746,   463,   762,   473,   459,
     461,   459,   794,   463,   612,   645,   628,   639,   639,   126,
     191,   192,   248,   254,   642,   463,   784,     3,     3,   461,
     461,   461,   461,   465,     7,   461,   461,   461,   465,   460,
     461,     7,   461,   461,     7,   461,    15,   651,   139,   141,
     169,   257,   258,   261,   262,   267,   464,   548,   550,   551,
     652,   476,   263,   660,   701,   704,   464,   478,   694,   695,
     188,   354,   375,   464,   687,   464,   182,   267,   356,   357,
     358,   360,   464,   548,   690,   730,   729,   415,   416,   419,
     420,   421,   464,   734,   743,   749,   761,   758,   461,   610,
     226,     6,    15,    16,    17,   460,   464,   613,   615,   617,
     619,   620,   622,   624,   459,   459,   460,   460,   460,   460,
     459,   783,   781,    29,   616,    29,   616,   616,     7,   616,
     459,   482,   475,   463,   259,   260,   260,   474,   473,   127,
     148,   268,   269,   653,   463,   459,   475,    66,   182,   196,
     256,   259,   260,   267,   317,   320,   323,   352,   354,   356,
     357,   358,   359,   360,   361,   367,   370,   373,   385,   393,
     464,   548,   692,   375,   382,   696,   475,   473,   475,   459,
     473,   127,   268,   371,   473,   473,   282,   157,   473,   459,
     129,   183,   189,   212,   257,   323,   406,   407,   411,   412,
     414,   422,   423,   464,   725,   418,   418,   475,   475,   475,
     459,   418,   424,   464,   741,   418,   425,   464,   747,    42,
      66,    67,    87,   141,   168,   256,   259,   260,   267,   317,
     385,   401,   436,   437,   439,   440,   442,   464,   548,   759,
     459,   464,   612,   610,   639,     7,   462,   465,   639,   639,
     639,   639,    42,    66,   259,   260,   357,   361,   436,   454,
     464,   782,   461,   461,   461,   465,   461,   460,   461,   549,
     550,   261,   261,   261,   150,   151,   148,   117,   140,   142,
     147,   162,   206,   552,   323,   473,   463,   475,   378,   180,
     181,   359,   395,   537,   127,   268,   371,   318,   475,   396,
     475,   473,   473,   473,   282,   473,   157,   473,   362,   363,
     364,   365,   366,   367,   368,   369,   394,   364,   473,   386,
     362,   459,   473,   459,   473,   473,   120,   418,   405,   120,
     409,   418,   409,   738,   282,   405,   410,   475,   408,    76,
     413,   278,   266,   726,   266,   727,   459,   473,   473,   417,
     473,   751,   739,   742,   459,   751,   745,   748,   459,   473,
     323,   444,    76,   473,   475,   476,   475,   378,   359,   395,
     537,   127,   150,   371,   445,   760,   318,   386,   362,   438,
      76,    76,   377,   473,   441,   443,   459,   461,   460,   615,
     610,   622,   461,   461,   461,   461,   473,   323,   378,   359,
     395,   537,   261,   455,   456,   261,   473,   459,   616,   616,
     464,   459,   474,   474,   474,   150,   151,   473,    20,   481,
     481,   148,   149,   553,   140,   142,   140,   142,   464,   475,
     697,   379,   380,   473,   473,   473,   473,   473,   260,   475,
     397,   473,   473,   475,   475,   473,   475,   428,   429,   430,
     728,   473,   261,   728,    76,   473,    76,   473,   261,   473,
     475,   473,   473,    69,   475,   744,   475,   750,   427,   752,
     752,   473,   475,   475,   473,   473,   473,   473,   260,   475,
     473,   473,   473,   475,   475,   475,   639,   459,   459,   459,
     459,   475,   473,   473,   473,   473,   473,   461,   465,   549,
     459,   459,   459,   150,   151,   152,   153,   154,   150,   151,
     152,   153,   154,   459,   481,   481,   481,   481,   464,   476,
     699,   377,   475,   752,   473,   473,   752,   473,   473,   473,
     475,   377,   616,   552,   552,   552,   552,   459,   459,   459,
     459,   372,   698,   465,   552,   552,   552,   552,   459,   616,
     461
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   469,   470,   470,   471,   471,   472,   473,   473,   473,
     474,   474,   474,   475,   475,   475,   475,   475,   475,   476,
     476,   477,   477,   478,   479,   479,   480,   480,   481,   482,
     482,   483,   483,   484,   484,   485,   486,   486,   487,   487,
     487,   488,   488,   489,   489,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   491,   491,   492,   492,   492,   492,
     493,   493,   493,   493,   493,   493,   494,   495,   495,   495,
     495,   496,   497,   498,   499,   500,   501,   502,   502,   503,
     503,   503,   504,   505,   505,   506,   506,   506,   506,   506,
     506,   507,   508,   508,   509,   509,   510,   510,   511,   511,
     511,   511,   511,   512,   513,   513,   514,   514,   514,   514,
     515,   516,   516,   517,   518,   519,   519,   520,   520,   521,
     521,   522,   522,   522,   522,   523,   523,   523,   523,   523,
     523,   523,   523,   523,   523,   523,   523,   523,   523,   523,
     523,   524,   524,   524,   524,   525,   525,   525,   525,   525,
     526,   526,   527,   528,   528,   529,   530,   530,   530,   531,
     531,   532,   533,   533,   534,   535,   536,   537,   537,   538,
     539,   539,   539,   539,   540,   541,   542,   542,   542,   543,
     543,   544,   544,   544,   544,   544,   544,   545,   545,   545,
     546,   546,   547,   547,   548,   548,   549,   549,   550,   550,
     551,   552,   552,   552,   552,   552,   552,   552,   552,   552,
     553,   553,   553,   553,   553,   553,   553,   553,   553,   553,
     554,   555,   556,   557,   558,   558,   559,   560,   561,   562,
     562,   562,   562,   562,   562,   562,   562,   562,   562,   562,
     562,   562,   563,   563,   563,   564,   565,   565,   565,   565,
     566,   566,   566,   567,   568,   568,   568,   568,   568,   568,
     568,   568,   569,   569,   570,   571,   572,   573,   574,   575,
     576,   577,   578,   579,   580,   581,   582,   583,   583,   583,
     584,   584,   585,   586,   587,   588,   589,   590,   591,   592,
     593,   594,   594,   594,   595,   595,   595,   597,   596,   598,
     599,   599,   599,   599,   599,   599,   599,   599,   599,   599,
     599,   599,   599,   599,   599,   600,   601,   601,   602,   602,
     603,   604,   604,   605,   606,   606,   607,   609,   608,   610,
     610,   611,   611,   612,   612,   613,   614,   614,   614,   614,
     614,   614,   615,   615,   615,   615,   615,   616,   617,   617,
     617,   617,   617,   617,   617,   617,   617,   617,   618,   618,
     618,   618,   619,   619,   619,   620,   620,   620,   620,   620,
     620,   620,   620,   621,   621,   621,   621,   621,   622,   622,
     622,   622,   622,   623,   623,   624,   624,   625,   626,   626,
     626,   626,   627,   627,   628,   628,   628,   629,   629,   630,
     630,   631,   631,   631,   631,   631,   631,   632,   632,   632,
     633,   633,   633,   633,   633,   633,   633,   633,   633,   633,
     634,   634,   634,   634,   635,   636,   637,   638,   638,   638,
     638,   638,   638,   638,   638,   638,   638,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   639,   639,   639,
     639,   639,   639,   639,   639,   639,   639,   640,   640,   640,
     640,   640,   640,   641,   642,   642,   642,   643,   643,   644,
     644,   645,   645,   645,   645,   645,   645,   645,   645,   645,
     645,   645,   645,   645,   645,   645,   645,   646,   647,   647,
     647,   647,   648,   648,   649,   650,   651,   652,   652,   652,
     652,   652,   652,   652,   652,   653,   653,   653,   653,   653,
     653,   654,   654,   655,   655,   656,   657,   658,   658,   658,
     659,   659,   660,   660,   661,   662,   663,   664,   664,   664,
     665,   665,   666,   666,   667,   667,   667,   667,   667,   667,
     667,   667,   667,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   668,
     668,   668,   668,   668,   668,   668,   668,   668,   668,   669,
     670,   670,   670,   670,   670,   670,   670,   671,   671,   672,
     673,   674,   674,   674,   674,   674,   674,   675,   676,   676,
     677,   677,   677,   677,   677,   677,   677,   677,   677,   678,
     679,   680,   680,   681,   681,   681,   681,   681,   681,   681,
     681,   681,   682,   681,   683,   681,   681,   681,   681,   684,
     684,   685,   686,   686,   687,   687,   687,   688,   688,   689,
     689,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   690,   691,   692,   692,   692,   692,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   692,   692,   692,   692,   692,   692,   692,   692,   692,
     692,   692,   693,   693,   694,   695,   696,   696,   696,   697,
     697,   698,   698,   699,   700,   701,   701,   703,   702,   704,
     704,   705,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   715,   715,   715,   715,   715,   715,   715,
     715,   716,   717,   717,   717,   717,   717,   718,   719,   719,
     719,   720,   719,   721,   719,   719,   719,   722,   722,   723,
     724,   725,   725,   725,   725,   725,   725,   725,   725,   725,
     725,   725,   725,   725,   725,   725,   725,   726,   725,   727,
     725,   725,   725,   728,   728,   728,   729,   730,   730,   731,
     731,   732,   733,   734,   734,   734,   734,   734,   735,   736,
     736,   737,   737,   738,   739,   740,   741,   741,   741,   742,
     743,   743,   744,   744,   745,   746,   747,   747,   747,   748,
     749,   749,   750,   750,   751,   751,   752,   752,   753,   754,
     754,   754,   754,   754,   755,   755,   756,   757,   758,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   759,   759,   759,   759,   759,   759,
     759,   759,   759,   759,   760,   760,   760,   760,   761,   761,
     762,   762,   763,   764,   765,   766,   767,   767,   767,   767,
     767,   768,   769,   769,   769,   770,   770,   771,   771,   771,
     771,   771,   771,   771,   771,   771,   772,   772,   773,   773,
     774,   774,   775,   776,   777,   777,   778,   778,   779,   780,
     781,   782,   782,   782,   782,   782,   782,   782,   782,   782,
     782,   782,   782,   783,   783,   784,   784,   785,   786,   787,
     788,   789,   789,   789,   789,   789,   789,   789,   789,   789,
     789,   789,   789,   789,   789,   789,   789,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     790,   790,   790,   790,   790,   790,   790,   790,   790,   790,
     791,   791,   791,   791,   791,   791,   791,   791,   791,   791,
     791,   791,   792,   792,   792,   792,   793,   793,   793,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794,   794,   794,   794,   794,   794,   794,   794,   794,
     794,   794
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     0,     1,     2,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     3,     1,     1,     1,     1,
       2,     4,     3,     3,     3,     3,     3,     3,     4,     3,
       3,     4,     5,     3,     3,     4,     2,     0,     1,     0,
       1,     2,     2,     0,     2,     2,     3,     2,     3,     3,
       4,     2,     3,     3,     3,     2,     4,     5,     1,     3,
       1,     1,     1,     4,     0,     2,     2,     2,     1,     1,
       5,     0,     1,     3,     3,     0,     8,     1,     4,     1,
       1,     0,     1,     2,     3,     0,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     4,     2,     2,     2,     3,
       2,     2,     1,     1,     1,     0,     2,     2,     2,     2,
       2,     1,     1,     3,     3,     0,     1,     1,     2,     0,
       1,     3,     1,     3,     1,     0,     2,     2,     2,     2,
       3,     3,     3,     5,     0,     3,     1,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     3,     1,     1,     4,     1,     0,     3,     4,     1,
       2,     0,     5,     5,     5,     5,     4,     4,     4,     4,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       3,     3,     4,     5,     1,     0,     3,     4,     4,     0,
       2,     3,     3,     3,     2,     2,     2,     2,     3,     3,
       2,     2,     1,     1,     1,     4,     0,     3,     3,     3,
       0,     1,     1,     4,     0,     2,     2,     2,     2,     2,
       2,     2,     0,     2,     9,     9,     4,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     1,     1,     3,
       0,     1,     4,     4,     4,     3,     4,     4,     4,     4,
       2,     1,     1,     1,     1,     0,     1,     0,     4,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     0,     3,     1,     3,
       1,     1,     1,     2,     3,     2,     4,     0,     5,     0,
       1,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       3,     1,     1,     3,     1,     1,     1,     1,     5,     7,
       5,     7,     9,     7,     5,     7,     5,    11,     1,     1,
       2,     1,     7,     9,     7,     7,     9,     7,     9,     7,
       9,     7,    15,     1,     1,     1,     1,     3,     1,     1,
       1,     1,     3,     1,     3,     1,     3,     3,     1,     2,
       2,     6,     1,     3,     0,     4,     3,     1,     3,     3,
       3,     2,     4,     2,     2,     2,     0,     2,     2,     0,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
       5,     7,     7,     1,     0,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     4,     1,     1,     1,     1,     2,     2,
       3,     3,     6,     3,     3,     3,     3,     3,     5,     7,
       6,     6,     6,     6,     4,     8,     4,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     3,     1,     3,     0,
       1,     4,     6,     4,     3,     5,     5,     4,     6,     3,
       2,     5,     5,     8,     8,     8,     8,     2,     1,     2,
       2,     2,     0,     3,     5,     0,     0,     2,     4,     4,
       4,     2,     2,     2,     1,     1,     1,     2,     2,     3,
       3,     0,     3,     0,     3,     4,     3,     0,     2,     2,
       0,     2,     0,     2,     4,     5,     2,     0,     3,     3,
       1,     3,     1,     3,     1,     3,     2,     2,     2,     2,
       2,     2,     3,     3,     3,     5,     6,     4,     6,     4,
       6,     4,     4,     5,     6,     3,     3,     4,     5,     5,
       5,     5,     5,     4,     4,     5,     5,     5,     5,     5,
       5,     5,     5,     6,     6,     6,     5,     6,     8,     6,
       6,     6,     5,     6,     4,     5,     4,     4,     5,     4,
       5,     4,     5,     5,     5,     5,     5,     6,     5,     5,
       6,     7,     7,     7,     5,     5,     5,     4,     4,     2,
       1,     2,     2,     1,     2,     2,     4,     0,     3,     5,
       4,     0,     3,     3,     3,     2,     3,     2,     3,     3,
       1,     2,     3,     2,     4,     3,     2,     3,     1,     2,
       4,     0,     3,     2,     1,     2,     3,     3,     3,     3,
       2,     3,     0,     5,     0,     5,     2,     2,     1,     4,
       1,     1,     0,     3,     2,     2,     2,     5,     2,     0,
       3,     0,     2,     2,     3,     2,     2,     3,     2,     2,
       2,     1,     3,     2,     2,     2,     2,     2,     2,     3,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     2,     3,     2,     3,     3,     4,     4,     2,     2,
       2,     3,     3,     3,     2,     3,     3,     3,     4,     2,
       2,     1,     0,     2,     3,     1,     0,     1,     2,     0,
       2,     0,     1,     3,     0,     0,     2,     0,     3,     0,
       3,     0,     3,     3,     4,     6,     6,     6,     7,     6,
       7,     5,     0,     2,     3,     2,     3,     3,     2,     3,
       2,     2,     3,     3,     5,     4,     4,     2,     1,     2,
       2,     0,     3,     0,     3,     2,     3,     0,     3,     5,
       0,     4,     4,     3,     2,     3,     3,     3,     3,     4,
       4,     4,     3,     3,     4,     4,     2,     0,     3,     0,
       3,     3,     3,     1,     1,     1,     0,     0,     3,     0,
       3,     4,     1,     2,     2,     2,     4,     4,     0,     0,
       3,     0,     3,     3,     1,     0,     0,     2,     2,     0,
       0,     3,     1,     5,     1,     0,     0,     2,     2,     0,
       0,     3,     1,     5,     1,     2,     0,     2,     2,     1,
       2,     4,     2,     2,     0,     3,     5,     0,     0,     2,
       2,     2,     2,     2,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     3,     4,
       3,     2,     2,     1,     1,     1,     1,     1,     0,     3,
       0,     3,     4,     6,     6,     2,     3,     3,     5,     5,
       4,     2,     3,     3,     3,     1,     2,     4,     3,     3,
       3,     2,     2,     2,     2,     2,     1,     3,     0,     2,
       0,     3,     4,     2,     1,     2,     0,     3,     5,     0,
       0,     0,     2,     2,     3,     3,     2,     2,     3,     3,
       2,     3,     3,     0,     3,     0,     3,     4,     6,     6,
       6,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     1,     2,     1,     2,     2,     1,     1,
       2,     1,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 882 "cf-parse.y" /* yacc.c:1648  */
    { return 0; }
#line 4376 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 3:
#line 883 "cf-parse.y" /* yacc.c:1648  */
    { return 0; }
#line 4382 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 6:
#line 896 "cf-parse.y" /* yacc.c:1648  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 4393 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 8:
#line 906 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 4399 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 9:
#line 907 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 4407 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 10:
#line 914 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 4413 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 11:
#line 915 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 4419 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 12:
#line 916 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 4425 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 13:
#line 924 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = !!(yyvsp[0].i); }
#line 4431 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 14:
#line 925 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1; }
#line 4437 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 15:
#line 926 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1; }
#line 4443 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 16:
#line 927 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 4449 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 17:
#line 928 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 4455 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 18:
#line 929 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1; }
#line 4461 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 20:
#line 936 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 4470 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 21:
#line 943 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.iface) = NULL; }
#line 4476 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 22:
#line 944 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 4482 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 23:
#line 948 "cf-parse.y" /* yacc.c:1648  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 4491 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 25:
#line 956 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 4497 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 26:
#line 960 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 4506 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 27:
#line 964 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.i) = ipa_masklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 4515 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 28:
#line 971 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 4525 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 30:
#line 980 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 4534 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 32:
#line 988 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = NULL; }
#line 4540 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 33:
#line 992 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4546 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 34:
#line 993 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = NULL; }
#line 4552 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 35:
#line 999 "cf-parse.y" /* yacc.c:1648  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 4563 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 36:
#line 1008 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = (yyvsp[0].t); }
#line 4569 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 37:
#line 1009 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = bird_name; }
#line 4575 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 38:
#line 1013 "cf-parse.y" /* yacc.c:1648  */
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = rf_file(f);
   }
#line 4585 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 39:
#line 1018 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 4591 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 40:
#line 1019 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.g) = stderr; }
#line 4597 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 41:
#line 1023 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ~0; }
#line 4603 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 42:
#line 1024 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4609 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 43:
#line 1028 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 4615 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 44:
#line 1029 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 4621 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 45:
#line 1033 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_DEBUG[0]; }
#line 4627 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 46:
#line 1034 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_TRACE[0]; }
#line 4633 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 47:
#line 1035 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_INFO[0]; }
#line 4639 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 48:
#line 1036 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_REMOTE[0]; }
#line 4645 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 49:
#line 1037 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_WARN[0]; }
#line 4651 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 50:
#line 1038 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_ERR[0]; }
#line 4657 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 51:
#line 1039 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_AUTH[0]; }
#line 4663 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 52:
#line 1040 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_FATAL[0]; }
#line 4669 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 53:
#line 1041 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = L_BUG[0]; }
#line 4675 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 54:
#line 1047 "cf-parse.y" /* yacc.c:1648  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 4681 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 55:
#line 1048 "cf-parse.y" /* yacc.c:1648  */
    {
     struct rfile *f = rf_open(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = rf_fileno(f);
   }
#line 4691 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 56:
#line 1058 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.tf) = &new_config->tf_route; }
#line 4697 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 57:
#line 1059 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 4703 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 58:
#line 1060 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.tf) = &new_config->tf_base; }
#line 4709 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 59:
#line 1061 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.tf) = &new_config->tf_log; }
#line 4715 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 60:
#line 1064 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 4721 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 61:
#line 1065 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 4727 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 62:
#line 1066 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 4733 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 63:
#line 1067 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4739 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 64:
#line 1068 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4745 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 65:
#line 1069 "cf-parse.y" /* yacc.c:1648  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4751 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 67:
#line 1079 "cf-parse.y" /* yacc.c:1648  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 4757 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 68:
#line 1080 "cf-parse.y" /* yacc.c:1648  */
    { new_config->latency_limit = (yyvsp[0].i32); }
#line 4763 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 69:
#line 1081 "cf-parse.y" /* yacc.c:1648  */
    { new_config->watchdog_warning = (yyvsp[0].i32); }
#line 4769 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 70:
#line 1082 "cf-parse.y" /* yacc.c:1648  */
    { new_config->watchdog_timeout = ((yyvsp[0].i32) + 999999) TO_S; }
#line 4775 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 71:
#line 1091 "cf-parse.y" /* yacc.c:1648  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4781 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 72:
#line 1094 "cf-parse.y" /* yacc.c:1648  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4787 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 73:
#line 1101 "cf-parse.y" /* yacc.c:1648  */
    { cmd_reconfig_confirm(); }
#line 4793 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 74:
#line 1104 "cf-parse.y" /* yacc.c:1648  */
    { cmd_reconfig_undo(); }
#line 4799 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 75:
#line 1107 "cf-parse.y" /* yacc.c:1648  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4805 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 76:
#line 1110 "cf-parse.y" /* yacc.c:1648  */
    { cmd_shutdown(); }
#line 4811 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 77:
#line 1113 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.t) = NULL; }
#line 4817 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 79:
#line 1118 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 4823 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 80:
#line 1119 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4829 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 81:
#line 1120 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4835 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 82:
#line 1128 "cf-parse.y" /* yacc.c:1648  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4841 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 83:
#line 1133 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = KRT_DEFAULT_ECMP_LIMIT; }
#line 4847 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 84:
#line 1134 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i); if (((yyvsp[0].i) <= 0) || ((yyvsp[0].i) > 255)) cf_error("Merge paths limit must be in range 1-255"); }
#line 4853 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 85:
#line 1138 "cf-parse.y" /* yacc.c:1648  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4859 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 86:
#line 1139 "cf-parse.y" /* yacc.c:1648  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4868 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 87:
#line 1143 "cf-parse.y" /* yacc.c:1648  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported on this platform");
#endif
   }
#line 4880 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 88:
#line 1150 "cf-parse.y" /* yacc.c:1648  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4886 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 89:
#line 1151 "cf-parse.y" /* yacc.c:1648  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4892 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 90:
#line 1152 "cf-parse.y" /* yacc.c:1648  */
    {
      THIS_KRT->merge_paths = (yyvsp[-1].i) ? (yyvsp[0].i) : 0;
#ifndef KRT_ALLOW_MERGE_PATHS
      if ((yyvsp[-1].i))
	cf_error("Path merging not supported on this platform");
#endif
   }
#line 4904 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 91:
#line 1164 "cf-parse.y" /* yacc.c:1648  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4910 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 92:
#line 1169 "cf-parse.y" /* yacc.c:1648  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4919 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 93:
#line 1173 "cf-parse.y" /* yacc.c:1648  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4931 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 94:
#line 1187 "cf-parse.y" /* yacc.c:1648  */
    { THIS_KRT->sys.table_id = (yyvsp[0].i); }
#line 4937 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 95:
#line 1188 "cf-parse.y" /* yacc.c:1648  */
    { THIS_KRT->sys.metric = (yyvsp[0].i); }
#line 4943 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 96:
#line 1202 "cf-parse.y" /* yacc.c:1648  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4949 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 97:
#line 1203 "cf-parse.y" /* yacc.c:1648  */
    { new_config->router_id_from = this_ipatt; }
#line 4955 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 98:
#line 1207 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4961 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 99:
#line 1208 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = f_eval_int((yyvsp[-1].x)); }
#line 4967 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 101:
#line 1210 "cf-parse.y" /* yacc.c:1648  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4979 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 102:
#line 1217 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_INT) || (yyvsp[0].s)->class == (SYM_CONSTANT | T_QUAD))
       (yyval.i32) = SYM_VAL((yyvsp[0].s)).i;
#ifndef IPV6
     else if ((yyvsp[0].s)->class == (SYM_CONSTANT | T_IP))
       (yyval.i32) = ipa_to_u32(SYM_VAL((yyvsp[0].s)).px.ip);
#endif
     else
       cf_error("Number or IPv4 address constant expected");
   }
#line 4994 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 106:
#line 1239 "cf-parse.y" /* yacc.c:1648  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 5000 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 107:
#line 1240 "cf-parse.y" /* yacc.c:1648  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 5006 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 108:
#line 1241 "cf-parse.y" /* yacc.c:1648  */
    { new_config->listen_bgp_flags = 0; }
#line 5012 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 109:
#line 1242 "cf-parse.y" /* yacc.c:1648  */
    { new_config->listen_bgp_flags = 1; }
#line 5018 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 110:
#line 1247 "cf-parse.y" /* yacc.c:1648  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 5024 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 111:
#line 1253 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 5030 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 112:
#line 1254 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1; }
#line 5036 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 113:
#line 1258 "cf-parse.y" /* yacc.c:1648  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 5046 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 114:
#line 1266 "cf-parse.y" /* yacc.c:1648  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 5054 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 116:
#line 1272 "cf-parse.y" /* yacc.c:1648  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 5062 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 119:
#line 1286 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = SYM_PROTO; }
#line 5068 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 120:
#line 1287 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 5074 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 121:
#line 1291 "cf-parse.y" /* yacc.c:1648  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 5085 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 122:
#line 1297 "cf-parse.y" /* yacc.c:1648  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 5094 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 123:
#line 1301 "cf-parse.y" /* yacc.c:1648  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 5108 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 124:
#line 1310 "cf-parse.y" /* yacc.c:1648  */
    {
     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 5120 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 126:
#line 1321 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 5129 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 127:
#line 1325 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 5135 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 128:
#line 1326 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->debug = (yyvsp[0].i); }
#line 5141 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 129:
#line 1327 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 5147 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 130:
#line 1328 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 5153 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 131:
#line 1329 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 5159 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 132:
#line 1330 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 5165 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 133:
#line 1331 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 5171 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 134:
#line 1332 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 5177 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 135:
#line 1333 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 5183 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 136:
#line 1334 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->vrf = if_get_by_name((yyvsp[0].t)); this_proto->vrf_set = 1; }
#line 5189 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 137:
#line 1335 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->vrf = NULL; this_proto->vrf_set = 1; }
#line 5195 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 138:
#line 1336 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->table = (yyvsp[0].r); }
#line 5201 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 139:
#line 1337 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 5207 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 140:
#line 1338 "cf-parse.y" /* yacc.c:1648  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 5213 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 141:
#line 1342 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.f) = (yyvsp[0].f); }
#line 5219 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 143:
#line 1344 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 5225 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 144:
#line 1345 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.f) = FILTER_REJECT; }
#line 5231 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 145:
#line 1349 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = PLA_DISABLE; }
#line 5237 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 146:
#line 1350 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = PLA_WARN; }
#line 5243 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 147:
#line 1351 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = PLA_BLOCK; }
#line 5249 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 148:
#line 1352 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = PLA_RESTART; }
#line 5255 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 149:
#line 1353 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = PLA_DISABLE; }
#line 5261 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 150:
#line 1357 "cf-parse.y" /* yacc.c:1648  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 5272 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 151:
#line 1363 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.g) = NULL; }
#line 5278 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 152:
#line 1367 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 5287 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 153:
#line 1375 "cf-parse.y" /* yacc.c:1648  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 5293 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 154:
#line 1376 "cf-parse.y" /* yacc.c:1648  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 5299 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 155:
#line 1384 "cf-parse.y" /* yacc.c:1648  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 5309 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 156:
#line 1392 "cf-parse.y" /* yacc.c:1648  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 5315 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 157:
#line 1393 "cf-parse.y" /* yacc.c:1648  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5321 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 158:
#line 1394 "cf-parse.y" /* yacc.c:1648  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 5327 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 159:
#line 1398 "cf-parse.y" /* yacc.c:1648  */
    { this_ipn->positive = 1; }
#line 5333 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 160:
#line 1399 "cf-parse.y" /* yacc.c:1648  */
    { this_ipn->positive = 0; }
#line 5339 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 164:
#line 1413 "cf-parse.y" /* yacc.c:1648  */
    { iface_patt_check(); }
#line 5345 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 165:
#line 1415 "cf-parse.y" /* yacc.c:1648  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 5355 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 167:
#line 1427 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 5361 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 168:
#line 1428 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 5367 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 169:
#line 1434 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 5376 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 173:
#line 1444 "cf-parse.y" /* yacc.c:1648  */
    { DIRECT_CFG->check_link = (yyvsp[-1].i); }
#line 5382 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 174:
#line 1448 "cf-parse.y" /* yacc.c:1648  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 5392 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 176:
#line 1462 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ~0; }
#line 5398 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 177:
#line 1463 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 5404 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 178:
#line 1464 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5410 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 180:
#line 1469 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5416 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 181:
#line 1473 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_STATES; }
#line 5422 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 182:
#line 1474 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_ROUTES; }
#line 5428 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 183:
#line 1475 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_FILTERS; }
#line 5434 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 184:
#line 1476 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_IFACES; }
#line 5440 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 185:
#line 1477 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_EVENTS; }
#line 5446 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 186:
#line 1478 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = D_PACKETS; }
#line 5452 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 187:
#line 1484 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ~0; }
#line 5458 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 188:
#line 1485 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 5464 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 189:
#line 1486 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5470 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 191:
#line 1491 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 5476 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 192:
#line 1495 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = MD_STATES; }
#line 5482 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 193:
#line 1496 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = MD_MESSAGES; }
#line 5488 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 200:
#line 1517 "cf-parse.y" /* yacc.c:1648  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->length = strlen((yyvsp[0].t));
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     this_p_item->alg = ALG_UNDEFINED;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 5510 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 201:
#line 1537 "cf-parse.y" /* yacc.c:1648  */
    { }
#line 5516 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 202:
#line 1538 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 5522 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 203:
#line 1539 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 5528 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 204:
#line 1540 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 5534 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 205:
#line 1541 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 5540 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 206:
#line 1542 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->genfrom = this_p_item->accfrom = (yyvsp[-2].time); }
#line 5546 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 207:
#line 1543 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->gento = this_p_item->accto = (yyvsp[-2].time); }
#line 5552 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 208:
#line 1544 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 5558 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 209:
#line 1545 "cf-parse.y" /* yacc.c:1648  */
    { this_p_item->alg = (yyvsp[-2].i); }
#line 5564 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 210:
#line 1549 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_MD5; }
#line 5570 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 211:
#line 1550 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_SHA1; }
#line 5576 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 212:
#line 1551 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_SHA256; }
#line 5582 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 213:
#line 1552 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_SHA384; }
#line 5588 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 214:
#line 1553 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_SHA512; }
#line 5594 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 215:
#line 1554 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_HMAC_MD5; }
#line 5600 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 216:
#line 1555 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_HMAC_SHA1; }
#line 5606 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 217:
#line 1556 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_HMAC_SHA256; }
#line 5612 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 218:
#line 1557 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_HMAC_SHA384; }
#line 5618 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 219:
#line 1558 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ALG_HMAC_SHA512; }
#line 5624 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 220:
#line 1565 "cf-parse.y" /* yacc.c:1648  */
    { cmd_show_status(); }
#line 5630 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 221:
#line 1568 "cf-parse.y" /* yacc.c:1648  */
    { cmd_show_memory(); }
#line 5636 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 222:
#line 1571 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 5642 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 223:
#line 1574 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 5648 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 225:
#line 1578 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.s) = NULL; }
#line 5654 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 226:
#line 1582 "cf-parse.y" /* yacc.c:1648  */
    { if_show(); }
#line 5660 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 227:
#line 1585 "cf-parse.y" /* yacc.c:1648  */
    { if_show_summary(); }
#line 5666 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 228:
#line 1589 "cf-parse.y" /* yacc.c:1648  */
    { rt_show((yyvsp[-1].ra)); }
#line 5672 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 229:
#line 1592 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 5682 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 230:
#line 1597 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 5693 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 231:
#line 1603 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 5705 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 232:
#line 1610 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 5715 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 233:
#line 1615 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5725 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 234:
#line 1620 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5735 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 235:
#line 1625 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 5744 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 236:
#line 1629 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 5753 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 237:
#line 1633 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 5762 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 238:
#line 1637 "cf-parse.y" /* yacc.c:1648  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5776 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 239:
#line 1646 "cf-parse.y" /* yacc.c:1648  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5789 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 240:
#line 1654 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 5798 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 241:
#line 1658 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 5807 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 242:
#line 1665 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 5813 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 243:
#line 1666 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RSEM_EXPORT; }
#line 5819 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 244:
#line 1667 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 5825 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 245:
#line 1673 "cf-parse.y" /* yacc.c:1648  */
    { roa_show((yyvsp[-1].ro)); }
#line 5831 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 246:
#line 1676 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 5843 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 247:
#line 1683 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 5855 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 248:
#line 1690 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 5864 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 249:
#line 1694 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5874 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 250:
#line 1702 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 5880 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 251:
#line 1703 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5886 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 252:
#line 1704 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5892 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 253:
#line 1710 "cf-parse.y" /* yacc.c:1648  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5898 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 254:
#line 1713 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5906 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 255:
#line 1716 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5912 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 256:
#line 1717 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5918 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 257:
#line 1718 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5924 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 258:
#line 1719 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5930 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 259:
#line 1720 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5936 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 260:
#line 1721 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5942 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 261:
#line 1722 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5948 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 262:
#line 1727 "cf-parse.y" /* yacc.c:1648  */
    {
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5958 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 263:
#line 1732 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5968 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 264:
#line 1741 "cf-parse.y" /* yacc.c:1648  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5977 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 265:
#line 1748 "cf-parse.y" /* yacc.c:1648  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5986 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 266:
#line 1755 "cf-parse.y" /* yacc.c:1648  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5995 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 267:
#line 1763 "cf-parse.y" /* yacc.c:1648  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 6001 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 268:
#line 1765 "cf-parse.y" /* yacc.c:1648  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 6007 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 269:
#line 1767 "cf-parse.y" /* yacc.c:1648  */
    { io_log_dump(); cli_msg(0, ""); }
#line 6013 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 270:
#line 1769 "cf-parse.y" /* yacc.c:1648  */
    { if_dump_all(); cli_msg(0, ""); }
#line 6019 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 271:
#line 1771 "cf-parse.y" /* yacc.c:1648  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 6025 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 272:
#line 1773 "cf-parse.y" /* yacc.c:1648  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 6031 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 273:
#line 1775 "cf-parse.y" /* yacc.c:1648  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 6037 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 274:
#line 1777 "cf-parse.y" /* yacc.c:1648  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 6043 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 275:
#line 1780 "cf-parse.y" /* yacc.c:1648  */
    { cmd_eval((yyvsp[-1].x)); }
#line 6049 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 276:
#line 1783 "cf-parse.y" /* yacc.c:1648  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 6058 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 277:
#line 1789 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = ~0; }
#line 6064 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 278:
#line 1790 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 6070 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 279:
#line 1791 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 6076 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 280:
#line 1795 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 4096; }
#line 6082 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 281:
#line 1796 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 6091 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 282:
#line 1803 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_disable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 6097 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 283:
#line 1805 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_enable, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 6103 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 284:
#line 1807 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_restart, 1, (uintptr_t) (yyvsp[-1].t)); }
#line 6109 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 285:
#line 1809 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 6115 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 286:
#line 1811 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 6121 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 287:
#line 1813 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 6127 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 288:
#line 1817 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 6133 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 289:
#line 1821 "cf-parse.y" /* yacc.c:1648  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 6139 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 290:
#line 1824 "cf-parse.y" /* yacc.c:1648  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 6145 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 291:
#line 1827 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 6151 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 292:
#line 1828 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 6157 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 293:
#line 1829 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 6163 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 294:
#line 1833 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 6169 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 295:
#line 1834 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 6175 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 296:
#line 1835 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 6181 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 297:
#line 1843 "cf-parse.y" /* yacc.c:1648  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 6187 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 298:
#line 1844 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 6198 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 299:
#line 1853 "cf-parse.y" /* yacc.c:1648  */
    { f_eval_int((yyvsp[0].x)); }
#line 6204 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 300:
#line 1857 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_INT; }
#line 6210 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 301:
#line 1858 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_BOOL; }
#line 6216 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 302:
#line 1859 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_IP; }
#line 6222 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 303:
#line 1860 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_PREFIX; }
#line 6228 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 304:
#line 1861 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_PAIR; }
#line 6234 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 305:
#line 1862 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_QUAD; }
#line 6240 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 306:
#line 1863 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_EC; }
#line 6246 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 307:
#line 1864 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_LC; }
#line 6252 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 308:
#line 1865 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_STRING; }
#line 6258 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 309:
#line 1866 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_PATH_MASK; }
#line 6264 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 310:
#line 1867 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_PATH; }
#line 6270 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 311:
#line 1868 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_CLIST; }
#line 6276 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 312:
#line 1869 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_ECLIST; }
#line 6282 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 313:
#line 1870 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = T_LCLIST; }
#line 6288 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 314:
#line 1871 "cf-parse.y" /* yacc.c:1648  */
    {
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_LC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 6312 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 315:
#line 1893 "cf-parse.y" /* yacc.c:1648  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 6325 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 316:
#line 1904 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.s) = NULL; }
#line 6331 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 317:
#line 1905 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6340 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 318:
#line 1912 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.s) = (yyvsp[0].s); }
#line 6346 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 319:
#line 1913 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 6355 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 320:
#line 1920 "cf-parse.y" /* yacc.c:1648  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 6366 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 321:
#line 1929 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 6375 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 323:
#line 1937 "cf-parse.y" /* yacc.c:1648  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst(FI_PRINT_AND_DIE);	/* ACCEPT */
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst(FI_PRINT_AND_DIE);	/* REJECT */
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst(FI_CONDITION);			/* IF */
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 6398 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 324:
#line 1958 "cf-parse.y" /* yacc.c:1648  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 6404 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 325:
#line 1959 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.s)=NULL; }
#line 6410 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 326:
#line 1963 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst(FI_CLEAR_LOCAL_VARS);
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 6424 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 327:
#line 1975 "cf-parse.y" /* yacc.c:1648  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 6433 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 328:
#line 1978 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name);
     cf_pop_scope();
   }
#line 6444 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 329:
#line 1991 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = NULL; }
#line 6450 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 330:
#line 1992 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 6456 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 331:
#line 1995 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 6462 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 332:
#line 1996 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 6468 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 333:
#line 2000 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 6476 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 334:
#line 2003 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 6484 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 335:
#line 2012 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 6490 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 336:
#line 2025 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6496 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 337:
#line 2026 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6502 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 338:
#line 2027 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6508 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 339:
#line 2028 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6514 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 340:
#line 2029 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 6523 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 341:
#line 2033 "cf-parse.y" /* yacc.c:1648  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 6533 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 342:
#line 2041 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 6539 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 343:
#line 2042 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 6545 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 344:
#line 2043 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 6551 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 345:
#line 2044 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6557 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 346:
#line 2045 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 6563 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 347:
#line 2049 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 6569 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 348:
#line 2052 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6575 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 349:
#line 2053 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6581 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 350:
#line 2054 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item((yyvsp[-3].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6587 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 351:
#line 2055 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_set((yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6593 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 352:
#line 2056 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_set((yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6599 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 353:
#line 2057 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item((yyvsp[-5].i32), (yyvsp[-3].i32), 0, CC_ALL); }
#line 6605 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 354:
#line 2058 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6611 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 355:
#line 2059 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_set(0, CC_ALL, (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6617 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 356:
#line 2060 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item(0, CC_ALL, 0, CC_ALL); }
#line 6623 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 357:
#line 2062 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_pair_item((yyvsp[-9].i32), (yyvsp[-3].i32), (yyvsp[-7].i32), (yyvsp[-1].i32)); }
#line 6629 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 358:
#line 2066 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = EC_RT; }
#line 6635 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 359:
#line 2067 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = EC_RO; }
#line 6641 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 360:
#line 2068 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6647 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 361:
#line 2069 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = EC_GENERIC; }
#line 6653 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 362:
#line 2073 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6659 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 363:
#line 2074 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6665 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 364:
#line 2075 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 6671 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 365:
#line 2079 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 6677 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 366:
#line 2080 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 6683 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 367:
#line 2081 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6689 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 368:
#line 2082 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-7].i32), (yyvsp[-5].i32), (yyvsp[-3].i32), 0, LC_ALL); }
#line 6695 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 369:
#line 2083 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-5].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6701 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 370:
#line 2084 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-7].i32), (yyvsp[-5].i32), 0, LC_ALL, 0, LC_ALL); }
#line 6707 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 371:
#line 2085 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item(0, LC_ALL, 0, LC_ALL, 0, LC_ALL); }
#line 6713 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 372:
#line 2087 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_lc_item((yyvsp[-13].i32), (yyvsp[-5].i32), (yyvsp[-11].i32), (yyvsp[-3].i32), (yyvsp[-9].i32), (yyvsp[-1].i32)); }
#line 6719 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 376:
#line 2094 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6725 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 377:
#line 2095 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6731 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 381:
#line 2102 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 6737 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 382:
#line 2103 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 6743 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 384:
#line 2108 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6749 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 386:
#line 2113 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 6755 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 387:
#line 2117 "cf-parse.y" /* yacc.c:1648  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 6764 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 388:
#line 2124 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v) = (yyvsp[0].v); }
#line 6770 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 389:
#line 2125 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 6776 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 390:
#line 2126 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 6782 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 391:
#line 2127 "cf-parse.y" /* yacc.c:1648  */
    {
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 6791 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 392:
#line 2134 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6797 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 393:
#line 2135 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6803 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 394:
#line 2138 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.e) = NULL; }
#line 6809 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 395:
#line 2139 "cf-parse.y" /* yacc.c:1648  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 6821 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 396:
#line 2146 "cf-parse.y" /* yacc.c:1648  */
    {
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 6833 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 397:
#line 2158 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6839 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 398:
#line 2159 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6845 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 399:
#line 2163 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6851 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 400:
#line 2164 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6857 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 401:
#line 2168 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6863 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 402:
#line 2169 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_RANGE; (yyval.h)->val = (yyvsp[-3].i); (yyval.h)->val2 = (yyvsp[-1].i); }
#line 6869 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 403:
#line 2170 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6875 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 404:
#line 2171 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; }
#line 6881 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 405:
#line 2172 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 6887 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 406:
#line 2173 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = NULL; }
#line 6893 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 407:
#line 2177 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN; (yyval.h)->val = (yyvsp[-1].i); }
#line 6899 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 408:
#line 2178 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = cfg_allocz(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; }
#line 6905 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 409:
#line 2179 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.h) = NULL; }
#line 6911 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 410:
#line 2183 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 6917 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 411:
#line 2184 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 6923 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 412:
#line 2185 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 6929 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 413:
#line 2186 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 6935 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 414:
#line 2187 "cf-parse.y" /* yacc.c:1648  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6941 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 415:
#line 2188 "cf-parse.y" /* yacc.c:1648  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6947 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 416:
#line 2189 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 6953 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 417:
#line 2190 "cf-parse.y" /* yacc.c:1648  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6959 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 418:
#line 2191 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6965 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 419:
#line 2192 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CONSTANT); (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6971 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 420:
#line 2196 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6977 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 421:
#line 2197 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6983 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 422:
#line 2198 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_lc((yyvsp[-5].x), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6989 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 423:
#line 2199 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_path_mask((yyvsp[0].h)); }
#line 6995 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 425:
#line 2213 "cf-parse.y" /* yacc.c:1648  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 7019 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 426:
#line 2235 "cf-parse.y" /* yacc.c:1648  */
    {
     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x) = f_new_inst(FI_CONSTANT_INDIRECT); break;
       case SYM_VARIABLE: (yyval.x) = f_new_inst(FI_VARIABLE); break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 7034 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 427:
#line 2247 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_FROM,	1); }
#line 7040 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 428:
#line 2248 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_IP,         SA_GW,	1); }
#line 7046 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 429:
#line 2249 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_PREFIX,     SA_NET,	0); }
#line 7052 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 430:
#line 2250 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_PROTO,	0); }
#line 7058 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 431:
#line 2251 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTS,   SA_SOURCE,	0); }
#line 7064 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 432:
#line 2252 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_SCOPE, SA_SCOPE,	1); }
#line 7070 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 433:
#line 2253 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTC,   SA_CAST,	0); }
#line 7076 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 434:
#line 2254 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_ENUM_RTD,   SA_DEST,	1); }
#line 7082 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 435:
#line 2255 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_STRING,     SA_IFNAME,	1); }
#line 7088 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 436:
#line 2256 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fsa) = f_new_static_attr(T_INT,        SA_IFINDEX,	0); }
#line 7094 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 437:
#line 2260 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7100 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 438:
#line 2261 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_ADD);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7106 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 439:
#line 2262 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_SUBTRACT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7112 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 440:
#line 2263 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_MULTIPLY);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7118 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 441:
#line 2264 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_DIVIDE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7124 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 442:
#line 2265 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_AND);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7130 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 443:
#line 2266 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_OR);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7136 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 444:
#line 2267 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_EQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7142 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 445:
#line 2268 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_NEQ);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7148 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 446:
#line 2269 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7154 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 447:
#line 2270 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7160 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 448:
#line 2271 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_LT);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 7166 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 449:
#line 2272 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_LTE);	(yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 7172 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 450:
#line 2273 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_MATCH);	(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7178 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 451:
#line 2274 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_NOT_MATCH);(yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 7184 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 452:
#line 2275 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_NOT);	(yyval.x)->a1.p = (yyvsp[0].x); }
#line 7190 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 453:
#line 2276 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_DEFINED);	(yyval.x)->a1.p = (yyvsp[-1].x); }
#line 7196 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 454:
#line 2278 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7202 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 455:
#line 2279 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7208 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 456:
#line 2280 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7214 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 457:
#line 2282 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_PREF_GET); }
#line 7220 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 458:
#line 2284 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst_sa(FI_RTA_GET, (yyvsp[0].fsa)); }
#line 7226 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 459:
#line 2286 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst_da(FI_EA_GET, (yyvsp[0].fda)); }
#line 7232 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 460:
#line 2288 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_IP); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 7238 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 461:
#line 2289 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_LENGTH); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7244 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 462:
#line 2290 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_IP_MASK); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 7250 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 463:
#line 2291 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_FIRST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7256 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 464:
#line 2292 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7262 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 465:
#line 2293 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_AS_PATH_LAST_NAG); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 7268 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 466:
#line 2303 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_PATH; }
#line 7274 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 467:
#line 2304 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_CLIST; }
#line 7280 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 468:
#line 2305 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_ECLIST; }
#line 7286 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 469:
#line 2306 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_EMPTY); (yyval.x)->aux = T_LCLIST; }
#line 7292 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 470:
#line 2307 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_PATH_PREPEND); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 7298 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 471:
#line 2308 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 7304 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 472:
#line 2309 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 7310 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 473:
#line 2310 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_CLIST_ADD_DEL); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 7316 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 474:
#line 2312 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 7322 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 475:
#line 2313 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 7328 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 476:
#line 2316 "cf-parse.y" /* yacc.c:1648  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst(FI_CALL);
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 7352 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 477:
#line 2338 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_QUITBIRD; }
#line 7358 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 478:
#line 2339 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_ACCEPT; }
#line 7364 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 479:
#line 2340 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_REJECT; }
#line 7370 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 480:
#line 2341 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_ERROR; }
#line 7376 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 481:
#line 2342 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_NOP; }
#line 7382 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 482:
#line 2343 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = F_NONL; }
#line 7388 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 483:
#line 2347 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_PRINT); (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 7394 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 484:
#line 2350 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = NULL; }
#line 7400 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 485:
#line 2351 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7406 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 486:
#line 2352 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 7417 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 487:
#line 2360 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 7428 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 488:
#line 2366 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 7439 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 489:
#line 2374 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = NULL; }
#line 7445 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 490:
#line 2375 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[0].x); }
#line 7451 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 491:
#line 2379 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7461 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 492:
#line 2384 "cf-parse.y" /* yacc.c:1648  */
    {
     struct f_inst *i = f_new_inst(FI_CONDITION);
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst(FI_CONDITION);
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 7474 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 493:
#line 2392 "cf-parse.y" /* yacc.c:1648  */
    {
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x) = f_new_inst(FI_SET);
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 7487 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 494:
#line 2400 "cf-parse.y" /* yacc.c:1648  */
    {
     DBG( "Ook, we'll return the value\n" );
     (yyval.x) = f_new_inst(FI_RETURN);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7497 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 495:
#line 2405 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-3].fda));
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7506 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 496:
#line 2409 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst_sa(FI_RTA_SET, (yyvsp[-3].fsa));
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7517 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 497:
#line 2415 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst(FI_PREF_SET);
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 7526 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 498:
#line 2419 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.x) = f_new_inst_da(FI_EA_SET, (yyvsp[-2].fda));
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->a1.p = NULL;
   }
#line 7536 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 499:
#line 2424 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_new_inst(FI_PRINT_AND_DIE); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 7542 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 500:
#line 2425 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 7548 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 501:
#line 2426 "cf-parse.y" /* yacc.c:1648  */
    {
      (yyval.x) = f_new_inst(FI_SWITCH);
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 7558 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 502:
#line 2433 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].fda)); }
#line 7564 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 503:
#line 2434 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_complex( FI_PATH_PREPEND, 'x', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7570 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 504:
#line 2435 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'a', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7576 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 505:
#line 2436 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'd', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7582 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 506:
#line 2437 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.x) = f_generate_complex( FI_CLIST_ADD_DEL, 'f', (yyvsp[-6].fda), (yyvsp[-2].x) ); }
#line 7588 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 507:
#line 2444 "cf-parse.y" /* yacc.c:1648  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);
}
#line 7598 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 515:
#line 2467 "cf-parse.y" /* yacc.c:1648  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  add_tail(&BFD_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;

  reset_passwords();
}
#line 7615 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 516:
#line 2481 "cf-parse.y" /* yacc.c:1648  */
    {
  BFD_IFACE->passwords = get_passwords();

  if (!BFD_IFACE->auth_type != !BFD_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (BFD_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *BFD_IFACE->passwords)
    {
      if (pass->alg)
        cf_error("Password algorithm option not available in BFD protocol");

      pass->alg = bfd_auth_type_to_hash_alg[BFD_IFACE->auth_type];
    }
  }
}
#line 7638 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 517:
#line 2501 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7644 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 518:
#line 2502 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 7650 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 519:
#line 2503 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 7656 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 520:
#line 2504 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 7662 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 521:
#line 2505 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 7668 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 522:
#line 2506 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 7674 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 523:
#line 2507 "cf-parse.y" /* yacc.c:1648  */
    { BFD_IFACE->auth_type = (yyvsp[0].i); }
#line 7680 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 524:
#line 2508 "cf-parse.y" /* yacc.c:1648  */
    {}
#line 7686 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 525:
#line 2512 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_NONE; }
#line 7692 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 526:
#line 2513 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_SIMPLE; }
#line 7698 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 527:
#line 2514 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_KEYED_MD5; }
#line 7704 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 528:
#line 2515 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_KEYED_SHA1; }
#line 7710 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 529:
#line 2516 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_MD5; }
#line 7716 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 530:
#line 2517 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = BFD_AUTH_METICULOUS_KEYED_SHA1; }
#line 7722 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 536:
#line 2535 "cf-parse.y" /* yacc.c:1648  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 7728 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 537:
#line 2539 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.iface) = NULL; }
#line 7734 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 538:
#line 2540 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 7740 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 539:
#line 2541 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 7746 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 540:
#line 2545 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.a) = IPA_NONE; }
#line 7752 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 541:
#line 2546 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.a) = (yyvsp[0].a); }
#line 7758 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 542:
#line 2550 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 7764 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 543:
#line 2551 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i); }
#line 7770 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 544:
#line 2555 "cf-parse.y" /* yacc.c:1648  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 7790 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 545:
#line 2574 "cf-parse.y" /* yacc.c:1648  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 7796 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 546:
#line 2579 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
     BGP_CFG->llgr_mode = -1;
     BGP_CFG->llgr_time = 3600;
     BGP_CFG->setkey = 1;
 }
#line 7826 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 548:
#line 2608 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number");  }
#line 7832 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 549:
#line 2609 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 7838 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 550:
#line 2614 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i) ? ~(1 << 7) : 0; }
#line 7844 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 551:
#line 2615 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 7850 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 553:
#line 2620 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 7856 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 554:
#line 2624 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 0; }
#line 7862 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 555:
#line 2625 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 1; }
#line 7868 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 556:
#line 2626 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 2; }
#line 7874 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 557:
#line 2627 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 3; }
#line 7880 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 558:
#line 2628 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 4; }
#line 7886 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 559:
#line 2629 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 5; }
#line 7892 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 560:
#line 2630 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 6; }
#line 7898 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 561:
#line 2631 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 7; }
#line 7904 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 562:
#line 2632 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1 << 8; }
#line 7910 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 565:
#line 2638 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7916 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 566:
#line 2639 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 7922 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 568:
#line 2641 "cf-parse.y" /* yacc.c:1648  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 7933 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 569:
#line 2647 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 7939 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 570:
#line 2648 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 7945 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 571:
#line 2649 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->rr_client = 1; }
#line 7951 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 572:
#line 2650 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->rs_client = 1; }
#line 7957 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 573:
#line 2651 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 7963 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 574:
#line 2652 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 7969 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 575:
#line 2653 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->multihop = 0; }
#line 7975 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 576:
#line 2654 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->multihop = 64; }
#line 7981 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 577:
#line 2655 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 7987 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 578:
#line 2656 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 7993 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 579:
#line 2657 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 7999 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 580:
#line 2658 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 8005 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 581:
#line 2659 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 8011 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 582:
#line 2660 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 8017 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 583:
#line 2661 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 8023 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 584:
#line 2662 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 8029 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 585:
#line 2663 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 8035 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 586:
#line 2664 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 8041 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 587:
#line 2665 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 8047 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 588:
#line 2666 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 8053 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 589:
#line 2667 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 8059 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 590:
#line 2668 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 8065 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 591:
#line 2669 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 8071 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 592:
#line 2670 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 8077 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 593:
#line 2671 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 8083 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 594:
#line 2672 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 8089 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 595:
#line 2673 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 8095 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 596:
#line 2674 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 8101 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 597:
#line 2675 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 8107 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 598:
#line 2676 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 8113 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 599:
#line 2677 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 8119 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 600:
#line 2678 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->disable_after_cease = (yyvsp[-1].i); }
#line 8125 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 601:
#line 2679 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 8131 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 602:
#line 2680 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 8137 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 603:
#line 2681 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->enable_extended_messages = (yyvsp[-1].i); }
#line 8143 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 604:
#line 2682 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 8149 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 605:
#line 2683 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 8155 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 606:
#line 2684 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 8161 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 607:
#line 2685 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->setkey = (yyvsp[-1].i); }
#line 8167 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 608:
#line 2686 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
#line 8178 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 609:
#line 2692 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 8184 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 610:
#line 2693 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 8190 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 611:
#line 2694 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 8196 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 612:
#line 2695 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 8202 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 613:
#line 2696 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 8208 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 614:
#line 2697 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 8214 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 615:
#line 2698 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->allow_local_pref = (yyvsp[-1].i); }
#line 8220 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 616:
#line 2699 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->allow_local_as = -1; }
#line 8226 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 617:
#line 2700 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 8232 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 618:
#line 2701 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 8238 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 619:
#line 2702 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 8244 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 620:
#line 2703 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 8250 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 621:
#line 2704 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->llgr_mode = (yyvsp[-1].i); }
#line 8256 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 622:
#line 2705 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->llgr_mode = BGP_LLGR_AWARE; }
#line 8262 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 623:
#line 2706 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->llgr_time = (yyvsp[-1].i); }
#line 8268 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 624:
#line 2707 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 8274 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 625:
#line 2708 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 8280 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 626:
#line 2709 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 8286 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 627:
#line 2710 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 8292 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 628:
#line 2711 "cf-parse.y" /* yacc.c:1648  */
    { BGP_CFG->bfd = BGP_BFD_GRACEFUL; cf_check_bfd(1); }
#line 8298 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 629:
#line 2723 "cf-parse.y" /* yacc.c:1648  */
    {
  this_proto = proto_config_new(&proto_mrt, (yyvsp[-1].i));
}
#line 8306 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 631:
#line 2729 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->table_expr = (yyvsp[0].t); }
#line 8312 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 632:
#line 2730 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->filter = (yyvsp[0].f); }
#line 8318 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 633:
#line 2731 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->filter = (yyvsp[0].f); }
#line 8324 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 634:
#line 2732 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->filename = (yyvsp[0].t); }
#line 8330 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 635:
#line 2733 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->period = (yyvsp[0].i); }
#line 8336 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 636:
#line 2734 "cf-parse.y" /* yacc.c:1648  */
    { MRT_CFG->always_add_path = (yyvsp[0].i); }
#line 8342 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 639:
#line 2743 "cf-parse.y" /* yacc.c:1648  */
    { mrt_check_config(this_proto); }
#line 8348 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 640:
#line 2747 "cf-parse.y" /* yacc.c:1648  */
    { mrt_dump_cmd((yyvsp[-1].md)); }
#line 8354 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 641:
#line 2750 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = cfg_allocz(sizeof(struct mrt_dump_data)); }
#line 8360 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 642:
#line 2751 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_ptr = (yyvsp[0].r)->table; }
#line 8366 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 643:
#line 2752 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->table_expr = (yyvsp[0].t); }
#line 8372 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 644:
#line 2753 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 8378 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 645:
#line 2754 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = (yyvsp[-1].md); (yyval.md)->filter = (yyvsp[0].f); }
#line 8384 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 646:
#line 2755 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.md) = (yyvsp[-2].md); (yyval.md)->filename = (yyvsp[0].t); }
#line 8390 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 647:
#line 2762 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
#line 8402 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 651:
#line 2778 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 8408 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 652:
#line 2779 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 8414 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 653:
#line 2780 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 8420 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 654:
#line 2781 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 8426 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 655:
#line 2782 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 8432 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 656:
#line 2783 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 8438 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 657:
#line 2784 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8444 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 659:
#line 2788 "cf-parse.y" /* yacc.c:1648  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 8462 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 660:
#line 2803 "cf-parse.y" /* yacc.c:1648  */
    { ospf_area_finish(); }
#line 8468 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 663:
#line 2812 "cf-parse.y" /* yacc.c:1648  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 8474 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 664:
#line 2813 "cf-parse.y" /* yacc.c:1648  */
    { this_area->type = OPT_N; }
#line 8480 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 665:
#line 2814 "cf-parse.y" /* yacc.c:1648  */
    { this_area->summary = (yyvsp[0].i); }
#line 8486 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 666:
#line 2815 "cf-parse.y" /* yacc.c:1648  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 8492 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 667:
#line 2816 "cf-parse.y" /* yacc.c:1648  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8498 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 668:
#line 2817 "cf-parse.y" /* yacc.c:1648  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 8504 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 669:
#line 2818 "cf-parse.y" /* yacc.c:1648  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 8510 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 670:
#line 2819 "cf-parse.y" /* yacc.c:1648  */
    { this_area->translator = (yyvsp[0].i); }
#line 8516 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 671:
#line 2820 "cf-parse.y" /* yacc.c:1648  */
    { this_area->transint = (yyvsp[0].i); }
#line 8522 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 672:
#line 2821 "cf-parse.y" /* yacc.c:1648  */
    { this_nets = &this_area->net_list; }
#line 8528 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 674:
#line 2822 "cf-parse.y" /* yacc.c:1648  */
    { this_nets = &this_area->enet_list; }
#line 8534 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 681:
#line 2834 "cf-parse.y" /* yacc.c:1648  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 8545 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 684:
#line 2848 "cf-parse.y" /* yacc.c:1648  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 8551 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 685:
#line 2849 "cf-parse.y" /* yacc.c:1648  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 8557 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 686:
#line 2850 "cf-parse.y" /* yacc.c:1648  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 8563 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 687:
#line 2854 "cf-parse.y" /* yacc.c:1648  */
    { ospf_iface_finish(); }
#line 8569 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 688:
#line 2855 "cf-parse.y" /* yacc.c:1648  */
    { ospf_iface_finish(); }
#line 8575 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 692:
#line 2864 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8581 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 693:
#line 2865 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8587 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 694:
#line 2866 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8593 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 695:
#line 2867 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8599 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 696:
#line 2868 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8605 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 697:
#line 2869 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8611 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 698:
#line 2870 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 8617 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 699:
#line 2871 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8623 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 700:
#line 2872 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8629 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 701:
#line 2873 "cf-parse.y" /* yacc.c:1648  */
    { ospf_check_auth(); }
#line 8635 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 702:
#line 2877 "cf-parse.y" /* yacc.c:1648  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 8656 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 703:
#line 2896 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 8662 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 704:
#line 2897 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 8668 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 705:
#line 2898 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 8674 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 706:
#line 2899 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 8680 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 707:
#line 2900 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 8686 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 708:
#line 2901 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 8692 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 709:
#line 2902 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 8698 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 710:
#line 2903 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8704 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 711:
#line 2904 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 8710 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 712:
#line 2905 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8716 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 713:
#line 2906 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 8722 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 714:
#line 2907 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8728 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 715:
#line 2908 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 8734 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 716:
#line 2909 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8740 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 717:
#line 2910 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 8746 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 718:
#line 2911 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 8752 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 719:
#line 2912 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 8758 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 720:
#line 2913 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 8764 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 721:
#line 2914 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 8770 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 722:
#line 2915 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 8776 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 723:
#line 2916 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 8782 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 724:
#line 2917 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 8788 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 725:
#line 2918 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 8794 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 726:
#line 2919 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 8800 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 728:
#line 2921 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 8806 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 729:
#line 2922 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 8812 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 730:
#line 2923 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 8818 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 731:
#line 2924 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->rx_buffer = 0; }
#line 8824 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 732:
#line 2925 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 8830 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 733:
#line 2926 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 8836 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 734:
#line 2927 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 8842 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 735:
#line 2928 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 8848 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 736:
#line 2929 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 8854 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 737:
#line 2930 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 8860 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 738:
#line 2931 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->ttl_security = 2; }
#line 8866 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 739:
#line 2932 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 8872 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 740:
#line 2933 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 8878 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 741:
#line 2934 "cf-parse.y" /* yacc.c:1648  */
    { ospf_check_auth(); }
#line 8884 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 745:
#line 2945 "cf-parse.y" /* yacc.c:1648  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 8895 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 747:
#line 2955 "cf-parse.y" /* yacc.c:1648  */
    { this_pref->hidden = 1; }
#line 8901 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 748:
#line 2956 "cf-parse.y" /* yacc.c:1648  */
    { this_pref->tag = (yyvsp[0].i); }
#line 8907 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 751:
#line 2965 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; }
#line 8913 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 752:
#line 2966 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 1; }
#line 8919 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 753:
#line 2970 "cf-parse.y" /* yacc.c:1648  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 8930 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 754:
#line 2979 "cf-parse.y" /* yacc.c:1648  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 8954 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 756:
#line 3002 "cf-parse.y" /* yacc.c:1648  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 8960 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 757:
#line 3006 "cf-parse.y" /* yacc.c:1648  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 8966 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 763:
#line 3020 "cf-parse.y" /* yacc.c:1648  */
    { ospf_iface_finish(); }
#line 8972 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 764:
#line 3026 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 8978 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 765:
#line 3029 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8984 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 766:
#line 3032 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 8990 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 767:
#line 3037 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 8996 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 768:
#line 3040 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 9002 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 769:
#line 3045 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 9008 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 770:
#line 3048 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 9014 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 771:
#line 3052 "cf-parse.y" /* yacc.c:1648  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 9020 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 772:
#line 3055 "cf-parse.y" /* yacc.c:1648  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 9028 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 773:
#line 3058 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 9034 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 774:
#line 3059 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 9040 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 775:
#line 3060 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 9046 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 776:
#line 3061 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 9052 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 777:
#line 3062 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 9058 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 778:
#line 3063 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 9064 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 779:
#line 3064 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 9070 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 780:
#line 3065 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 9076 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 781:
#line 3071 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 9085 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 784:
#line 3080 "cf-parse.y" /* yacc.c:1648  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 9095 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 785:
#line 3085 "cf-parse.y" /* yacc.c:1648  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 9101 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 786:
#line 3086 "cf-parse.y" /* yacc.c:1648  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 9107 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 787:
#line 3093 "cf-parse.y" /* yacc.c:1648  */
    {
  this_proto = proto_config_new(&proto_radv, (yyvsp[-1].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
#line 9119 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 790:
#line 3104 "cf-parse.y" /* yacc.c:1648  */
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 9125 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 791:
#line 3105 "cf-parse.y" /* yacc.c:1648  */
    { init_list(&radv_dns_list); }
#line 9131 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 792:
#line 3105 "cf-parse.y" /* yacc.c:1648  */
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 9137 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 793:
#line 3106 "cf-parse.y" /* yacc.c:1648  */
    { init_list(&radv_dns_list); }
#line 9143 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 794:
#line 3106 "cf-parse.y" /* yacc.c:1648  */
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 9149 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 795:
#line 3107 "cf-parse.y" /* yacc.c:1648  */
    {
     RADV_CFG->trigger_prefix = (yyvsp[0].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[0].px).len;
     RADV_CFG->trigger_valid = 1;
   }
#line 9159 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 796:
#line 3112 "cf-parse.y" /* yacc.c:1648  */
    { RADV_CFG->propagate_routes = (yyvsp[0].i); }
#line 9165 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 800:
#line 3125 "cf-parse.y" /* yacc.c:1648  */
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->prefix_linger_time = -1;
  RADV_IFACE->route_linger_time = -1;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
  RADV_IFACE->route_lifetime = -1;
  RADV_IFACE->route_lifetime_sensitive = 0;
  RADV_IFACE->route_preference = RA_PREF_MEDIUM;
}
#line 9191 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 801:
#line 3148 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 9197 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 802:
#line 3149 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 9203 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 803:
#line 3150 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 9209 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 804:
#line 3151 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->managed = (yyvsp[0].i); }
#line 9215 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 805:
#line 3152 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 9221 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 806:
#line 3153 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->link_mtu = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Link MTU must be 0 or positive"); }
#line 9227 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 807:
#line 3154 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->reachable_time = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
#line 9233 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 808:
#line 3155 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->retrans_timer = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
#line 9239 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 809:
#line 3156 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
#line 9245 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 810:
#line 3157 "cf-parse.y" /* yacc.c:1648  */
    {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if (((yyvsp[-1].i) < 0) || ((yyvsp[-1].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9255 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 811:
#line 3162 "cf-parse.y" /* yacc.c:1648  */
    {
     RADV_IFACE->route_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != -1) RADV_IFACE->route_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9264 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 812:
#line 3166 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 9270 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 813:
#line 3167 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->route_preference = (yyvsp[0].i); }
#line 9276 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 814:
#line 3168 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->prefix_linger_time = (yyvsp[0].i); }
#line 9282 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 815:
#line 3169 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->route_linger_time = (yyvsp[0].i); }
#line 9288 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 816:
#line 3170 "cf-parse.y" /* yacc.c:1648  */
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 9294 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 817:
#line 3171 "cf-parse.y" /* yacc.c:1648  */
    { init_list(&radv_dns_list); }
#line 9300 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 818:
#line 3171 "cf-parse.y" /* yacc.c:1648  */
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 9306 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 819:
#line 3172 "cf-parse.y" /* yacc.c:1648  */
    { init_list(&radv_dns_list); }
#line 9312 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 820:
#line 3172 "cf-parse.y" /* yacc.c:1648  */
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 9318 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 821:
#line 3173 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 9324 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 822:
#line 3174 "cf-parse.y" /* yacc.c:1648  */
    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 9330 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 823:
#line 3178 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RA_PREF_LOW; }
#line 9336 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 824:
#line 3179 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RA_PREF_MEDIUM; }
#line 9342 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 825:
#line 3180 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RA_PREF_HIGH; }
#line 9348 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 826:
#line 3183 "cf-parse.y" /* yacc.c:1648  */
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if (ic->route_lifetime == (u32) -1)
    ic->route_lifetime = 3 * ic->max_ra_int;

  if (ic->prefix_linger_time == (u32) -1)
    ic->prefix_linger_time = 3 * ic->max_ra_int;

  if (ic->route_linger_time == (u32) -1)
    ic->route_linger_time = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");

  if ((ic->route_lifetime > 0) && (ic->route_lifetime < ic->max_ra_int))
    cf_error("Route lifetime must be either 0 or at least Max RA interval");

  if ((ic->prefix_linger_time > 0) && (ic->prefix_linger_time < ic->max_ra_int))
    cf_error("Prefix linger time must be either 0 or at least Max RA interval");

  if ((ic->route_linger_time > 0) && (ic->route_linger_time < ic->max_ra_int))
    cf_error("Route linger time must be either 0 or at least Max RA interval");

  RADV_CFG->max_linger_time = MAX_(RADV_CFG->max_linger_time, ic->route_linger_time);
}
#line 9389 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 832:
#line 3236 "cf-parse.y" /* yacc.c:1648  */
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[0].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[0].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 9404 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 833:
#line 3248 "cf-parse.y" /* yacc.c:1648  */
    { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 9410 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 834:
#line 3249 "cf-parse.y" /* yacc.c:1648  */
    { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 9416 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 835:
#line 3250 "cf-parse.y" /* yacc.c:1648  */
    { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 9422 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 836:
#line 3251 "cf-parse.y" /* yacc.c:1648  */
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9431 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 837:
#line 3255 "cf-parse.y" /* yacc.c:1648  */
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[0].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 9440 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 838:
#line 3262 "cf-parse.y" /* yacc.c:1648  */
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 9452 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 844:
#line 3286 "cf-parse.y" /* yacc.c:1648  */
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 9464 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 845:
#line 3295 "cf-parse.y" /* yacc.c:1648  */
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 9473 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 848:
#line 3302 "cf-parse.y" /* yacc.c:1648  */
    { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 9479 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 849:
#line 3306 "cf-parse.y" /* yacc.c:1648  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 9495 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 854:
#line 3330 "cf-parse.y" /* yacc.c:1648  */
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 9510 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 855:
#line 3342 "cf-parse.y" /* yacc.c:1648  */
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 9519 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 858:
#line 3349 "cf-parse.y" /* yacc.c:1648  */
    { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 9525 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 859:
#line 3353 "cf-parse.y" /* yacc.c:1648  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 9541 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 864:
#line 3377 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 9547 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 865:
#line 3378 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 9553 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 866:
#line 3382 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = -1; }
#line 9559 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 867:
#line 3383 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = (yyvsp[0].i); }
#line 9565 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 868:
#line 3391 "cf-parse.y" /* yacc.c:1648  */
    {
  this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
  init_list(&RIP_CFG->patt_list);

  RIP_CFG->rip2 = RIP_IS_V2;
  RIP_CFG->infinity = RIP_DEFAULT_INFINITY;

  RIP_CFG->min_timeout_time = 60;
  RIP_CFG->max_garbage_time = 60;
}
#line 9580 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 870:
#line 3404 "cf-parse.y" /* yacc.c:1648  */
    { RIP_CFG->ecmp = (yyvsp[0].i) ? RIP_DEFAULT_ECMP_LIMIT : 0; }
#line 9586 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 871:
#line 3405 "cf-parse.y" /* yacc.c:1648  */
    { RIP_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 9592 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 872:
#line 3406 "cf-parse.y" /* yacc.c:1648  */
    { RIP_CFG->infinity = (yyvsp[0].i); }
#line 9598 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 877:
#line 3420 "cf-parse.y" /* yacc.c:1648  */
    {
  this_ipatt = cfg_allocz(sizeof(struct rip_iface_config));
  add_tail(&RIP_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  reset_passwords();

  RIP_IFACE->metric = 1;
  RIP_IFACE->port = rip_cfg_is_v2() ? RIP_PORT : RIP_NG_PORT;
  RIP_IFACE->version = rip_cfg_is_v2() ? RIP_V2 : RIP_V1;
  RIP_IFACE->split_horizon = 1;
  RIP_IFACE->poison_reverse = 1;
  RIP_IFACE->check_zero = 1;
  RIP_IFACE->ttl_security = rip_cfg_is_v2() ? 0 : 1;
  RIP_IFACE->rx_buffer = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_length = rip_cfg_is_v2() ? RIP_MAX_PKT_LENGTH : 0;
  RIP_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  RIP_IFACE->tx_priority = sk_priority_control;
  RIP_IFACE->update_time = RIP_DEFAULT_UPDATE_TIME;
  RIP_IFACE->timeout_time = RIP_DEFAULT_TIMEOUT_TIME;
  RIP_IFACE->garbage_time = RIP_DEFAULT_GARBAGE_TIME;
}
#line 9624 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 878:
#line 3443 "cf-parse.y" /* yacc.c:1648  */
    {
  /* Default mode is broadcast for RIPv1, multicast for RIPv2 and RIPng */
  if (!RIP_IFACE->mode)
    RIP_IFACE->mode = (rip_cfg_is_v2() && (RIP_IFACE->version == RIP_V1)) ?
      RIP_IM_BROADCAST : RIP_IM_MULTICAST;

  RIP_IFACE->passwords = get_passwords();

  if (!RIP_IFACE->auth_type != !RIP_IFACE->passwords)
    log(L_WARN "Authentication and password options should be used together");

  if (RIP_IFACE->passwords)
  {
    struct password_item *pass;
    WALK_LIST(pass, *RIP_IFACE->passwords)
    {
      if (pass->alg && (RIP_IFACE->auth_type != RIP_AUTH_CRYPTO))
	cf_error("Password algorithm option requires cryptographic authentication");

      /* Set default crypto algorithm (MD5) */
      if (!pass->alg && (RIP_IFACE->auth_type == RIP_AUTH_CRYPTO))
	pass->alg = ALG_MD5;
    }
  }

  RIP_CFG->min_timeout_time = MIN_(RIP_CFG->min_timeout_time, RIP_IFACE->timeout_time);
  RIP_CFG->max_garbage_time = MAX_(RIP_CFG->max_garbage_time, RIP_IFACE->garbage_time);
}
#line 9657 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 879:
#line 3473 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->metric = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>255)) cf_error("Metric must be in range 1-255"); }
#line 9663 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 880:
#line 3474 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->mode = RIP_IM_MULTICAST; }
#line 9669 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 881:
#line 3475 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->mode = RIP_IM_BROADCAST; if (rip_cfg_is_ng()) cf_error("Broadcast not supported in RIPng"); }
#line 9675 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 882:
#line 3476 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->passive = (yyvsp[0].i); }
#line 9681 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 883:
#line 3477 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->address = (yyvsp[0].a); }
#line 9687 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 884:
#line 3478 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 9693 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 885:
#line 3479 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->version = (yyvsp[0].i);
			  if (rip_cfg_is_ng()) cf_error("Version not supported in RIPng");
			  if (((yyvsp[0].i) != RIP_V1) && ((yyvsp[0].i) != RIP_V2)) cf_error("Unsupported version");
			}
#line 9702 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 886:
#line 3483 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->version_only = (yyvsp[0].i); }
#line 9708 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 887:
#line 3484 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->split_horizon = (yyvsp[0].i); }
#line 9714 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 888:
#line 3485 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->poison_reverse = (yyvsp[0].i); }
#line 9720 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 889:
#line 3486 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->check_zero = (yyvsp[0].i); }
#line 9726 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 890:
#line 3487 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->update_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Update time must be positive"); }
#line 9732 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 891:
#line 3488 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->timeout_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Timeout time must be positive"); }
#line 9738 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 892:
#line 3489 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->garbage_time = (yyvsp[0].i); if ((yyvsp[0].i)<=0) cf_error("Garbage time must be positive"); }
#line 9744 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 893:
#line 3490 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 9750 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 894:
#line 3491 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX length must be in range 256-65535"); }
#line 9756 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 895:
#line 3492 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 9762 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 896:
#line 3493 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->tx_tos = (yyvsp[0].i); }
#line 9768 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 897:
#line 3494 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->tx_priority = (yyvsp[0].i); }
#line 9774 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 898:
#line 3495 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->ttl_security = (yyvsp[0].i); }
#line 9780 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 899:
#line 3496 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->ttl_security = 2; }
#line 9786 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 900:
#line 3497 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->check_link = (yyvsp[0].i); }
#line 9792 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 901:
#line 3498 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 9798 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 902:
#line 3499 "cf-parse.y" /* yacc.c:1648  */
    { RIP_IFACE->auth_type = (yyvsp[0].i); if ((yyvsp[0].i)) rip_check_auth(); }
#line 9804 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 903:
#line 3500 "cf-parse.y" /* yacc.c:1648  */
    { rip_check_auth(); }
#line 9810 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 904:
#line 3504 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RIP_AUTH_NONE; }
#line 9816 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 905:
#line 3505 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RIP_AUTH_PLAIN; }
#line 9822 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 906:
#line 3506 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 9828 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 907:
#line 3507 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.i) = RIP_AUTH_CRYPTO; }
#line 9834 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 913:
#line 3528 "cf-parse.y" /* yacc.c:1648  */
    { rip_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 9840 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 914:
#line 3531 "cf-parse.y" /* yacc.c:1648  */
    { rip_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_rip), (yyvsp[-1].t)); }
#line 9846 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 915:
#line 3537 "cf-parse.y" /* yacc.c:1648  */
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 9855 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 918:
#line 3546 "cf-parse.y" /* yacc.c:1648  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 9861 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 919:
#line 3547 "cf-parse.y" /* yacc.c:1648  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 9867 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 920:
#line 3548 "cf-parse.y" /* yacc.c:1648  */
    { static_route_finish(); }
#line 9873 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 921:
#line 3551 "cf-parse.y" /* yacc.c:1648  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
     this_srt_last_cmd = &(this_srt->cmds);
  }
#line 9885 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 922:
#line 3561 "cf-parse.y" /* yacc.c:1648  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
     this_srt_nh->use_bfd = -1; /* undefined */
   }
#line 9899 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 923:
#line 3570 "cf-parse.y" /* yacc.c:1648  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 9908 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 924:
#line 3574 "cf-parse.y" /* yacc.c:1648  */
    {
     this_srt_nh->use_bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i));
   }
#line 9916 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 925:
#line 3580 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->mp_next = this_srt_nh; }
#line 9922 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 926:
#line 3581 "cf-parse.y" /* yacc.c:1648  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 9928 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 927:
#line 3585 "cf-parse.y" /* yacc.c:1648  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 9938 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 928:
#line 3590 "cf-parse.y" /* yacc.c:1648  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 9949 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 929:
#line 3596 "cf-parse.y" /* yacc.c:1648  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 9957 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 930:
#line 3599 "cf-parse.y" /* yacc.c:1648  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 9966 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 931:
#line 3604 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9972 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 932:
#line 3605 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9978 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 933:
#line 3606 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 9984 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 934:
#line 3607 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 9990 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 935:
#line 3608 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 9996 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 936:
#line 3612 "cf-parse.y" /* yacc.c:1648  */
    { *this_srt_last_cmd = (yyvsp[0].x); this_srt_last_cmd = &((yyvsp[0].x)->next); }
#line 10002 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 937:
#line 3613 "cf-parse.y" /* yacc.c:1648  */
    { this_srt->use_bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 10008 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 942:
#line 3628 "cf-parse.y" /* yacc.c:1648  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 10014 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 943:
#line 3634 "cf-parse.y" /* yacc.c:1648  */
    {
  this_proto = proto_config_new(&proto_babel, (yyvsp[-1].i));
  init_list(&BABEL_CFG->iface_list);
}
#line 10023 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 949:
#line 3654 "cf-parse.y" /* yacc.c:1648  */
    {
  this_ipatt = cfg_allocz(sizeof(struct babel_iface_config));
  add_tail(&BABEL_CFG->iface_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  BABEL_IFACE->port = BABEL_PORT;
  BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED;
  BABEL_IFACE->tx_tos = IP_PREC_INTERNET_CONTROL;
  BABEL_IFACE->tx_priority = sk_priority_control;
  BABEL_IFACE->check_link = 1;
}
#line 10038 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 950:
#line 3667 "cf-parse.y" /* yacc.c:1648  */
    {
  if (BABEL_IFACE->type == BABEL_IFACE_TYPE_WIRELESS)
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRELESS;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRELESS;
  }
  else
  {
    if (!BABEL_IFACE->hello_interval)
      BABEL_IFACE->hello_interval = BABEL_HELLO_INTERVAL_WIRED;
    if (!BABEL_IFACE->rxcost)
      BABEL_IFACE->rxcost = BABEL_RXCOST_WIRED;
  }

  /* Make sure we do not overflow the 16-bit centisec fields */
  if (!BABEL_IFACE->update_interval)
    BABEL_IFACE->update_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_UPDATE_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
  BABEL_IFACE->ihu_interval = MIN_(BABEL_IFACE->hello_interval*BABEL_IHU_INTERVAL_FACTOR, BABEL_MAX_INTERVAL);
}
#line 10064 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 952:
#line 3691 "cf-parse.y" /* yacc.c:1648  */
    { BABEL_IFACE->port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number"); }
#line 10070 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 953:
#line 3692 "cf-parse.y" /* yacc.c:1648  */
    { BABEL_IFACE->rxcost = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid rxcost"); }
#line 10076 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 954:
#line 3693 "cf-parse.y" /* yacc.c:1648  */
    { BABEL_IFACE->hello_interval = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid hello interval"); }
#line 10082 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 955:
#line 3694 "cf-parse.y" /* yacc.c:1648  */
    { BABEL_IFACE->update_interval = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>BABEL_MAX_INTERVAL)) cf_error("Invalid update interval"); }
#line 10088 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 956:
#line 3695 "cf-parse.y" /* yacc.c:1648  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRED; }
#line 10094 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 957:
#line 3696 "cf-parse.y" /* yacc.c:1648  */
    { BABEL_IFACE->type = BABEL_IFACE_TYPE_WIRELESS; }
#line 10100 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 958:
#line 3697 "cf-parse.y" /* yacc.c:1648  */
    { BABEL_IFACE->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("RX buffer must be in range 256-65535"); }
#line 10106 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 959:
#line 3698 "cf-parse.y" /* yacc.c:1648  */
    { BABEL_IFACE->tx_length = (yyvsp[0].i); if (((yyvsp[0].i)<256) || ((yyvsp[0].i)>65535)) cf_error("TX length must be in range 256-65535"); }
#line 10112 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 960:
#line 3699 "cf-parse.y" /* yacc.c:1648  */
    { BABEL_IFACE->tx_tos = (yyvsp[0].i); }
#line 10118 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 961:
#line 3700 "cf-parse.y" /* yacc.c:1648  */
    { BABEL_IFACE->tx_priority = (yyvsp[0].i); }
#line 10124 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 962:
#line 3701 "cf-parse.y" /* yacc.c:1648  */
    { BABEL_IFACE->check_link = (yyvsp[0].i); }
#line 10130 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 968:
#line 3722 "cf-parse.y" /* yacc.c:1648  */
    { babel_show_interfaces(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 10136 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 969:
#line 3725 "cf-parse.y" /* yacc.c:1648  */
    { babel_show_neighbors(proto_get_named((yyvsp[-2].s), &proto_babel), (yyvsp[-1].t)); }
#line 10142 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 970:
#line 3728 "cf-parse.y" /* yacc.c:1648  */
    { babel_show_entries(proto_get_named((yyvsp[-2].s), &proto_babel)); }
#line 10148 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1044:
#line 3736 "cf-parse.y" /* yacc.c:1648  */
    { bgp_check_config(BGP_CFG); }
#line 10154 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1046:
#line 3736 "cf-parse.y" /* yacc.c:1648  */
    { ospf_proto_finish(); }
#line 10160 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1059:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 10166 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1060:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 10172 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1061:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 10178 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1062:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 10184 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1063:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SCOPE); }
#line 10190 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1064:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_MTU); }
#line 10196 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1065:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_WINDOW); }
#line 10202 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1066:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTT); }
#line 10208 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1067:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTTVAR); }
#line 10214 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1068:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_SSTRESH); }
#line 10220 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1069:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_CWND); }
#line 10226 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1070:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_ADVMSS); }
#line 10232 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1071:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REORDERING); }
#line 10238 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1072:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_HOPLIMIT); }
#line 10244 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1073:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITCWND); }
#line 10250 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1074:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_RTO_MIN); }
#line 10256 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1075:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_INITRWND); }
#line 10262 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1076:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_QUICKACK); }
#line 10268 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1077:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_MTU); }
#line 10274 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1078:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_WINDOW); }
#line 10280 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1079:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTT); }
#line 10286 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1080:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTTVAR); }
#line 10292 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1081:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_SSTHRESH); }
#line 10298 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1082:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_CWND); }
#line 10304 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1083:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_ADVMSS); }
#line 10310 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1084:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_REORDERING); }
#line 10316 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1085:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_HOPLIMIT); }
#line 10322 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1086:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_LOCK_RTO_MIN); }
#line 10328 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1087:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ECN); }
#line 10334 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1088:
#line 3739 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_BITFIELD, T_BOOL, EA_KRT_FEATURE_ALLFRAG); }
#line 10340 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1089:
#line 3740 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 10346 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1090:
#line 3740 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = (struct f_dynamic_attr) {}; }
#line 10352 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1091:
#line 3741 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 10358 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1092:
#line 3742 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 10364 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1093:
#line 3743 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 10370 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1094:
#line 3744 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 10376 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1095:
#line 3745 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 10382 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1096:
#line 3746 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 10388 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1097:
#line 3747 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 10394 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1098:
#line 3748 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 10400 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1099:
#line 3749 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 10406 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1100:
#line 3750 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 10412 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1101:
#line 3751 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 10418 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1102:
#line 3752 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_LC_SET, T_LCLIST, EA_CODE(EAP_BGP, BA_LARGE_COMMUNITY)); }
#line 10424 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1103:
#line 3752 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 10430 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1104:
#line 3752 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 10436 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1105:
#line 3752 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 10442 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1106:
#line 3752 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 10448 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1107:
#line 3752 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_RA_PREFERENCE, EA_RA_PREFERENCE); }
#line 10454 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1108:
#line 3752 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_RA_LIFETIME); }
#line 10460 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1109:
#line 3752 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 10466 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1110:
#line 3752 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 10472 "cf-parse.tab.c" /* yacc.c:1648  */
    break;

  case 1111:
#line 3752 "cf-parse.y" /* yacc.c:1648  */
    { (yyval.fda) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_BABEL_METRIC); }
#line 10478 "cf-parse.tab.c" /* yacc.c:1648  */
    break;


#line 10482 "cf-parse.tab.c" /* yacc.c:1648  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3754 "cf-parse.y" /* yacc.c:1907  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/mrt/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

/* C Code from ../../proto/babel/config.Y */

